/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2004 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.codegen;



/**
 * Class OOLocalVarDeclStatement
 *
 * @author    $Author: schneider $
 * @version   $Revision: 1.17 $
 */
public class OOLocalVarDeclStatement
    extends OOStatement
{
   /**
    * Default Constructor
    */
   private OOLocalVarDeclStatement() { }


   /**
    * Constructor for class OOLocalVarDeclStatement
    *
    * @param varType     No description provided
    * @param objectName  No description provided
    * @param initExpr    No description provided
    */
   public OOLocalVarDeclStatement (OOTypeInterface varType,
                                   OOVariable objectName,
                                   OOExpression initExpr)
   {
      this.varType = varType;
      this.objectName = objectName;
      this.initExpr = initExpr;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private boolean declared = false;


   /**
    * Get the value of declared.
    *
    * @return   Value of declared.
    */
   public boolean isDeclared()
   {
      return this.declared;
   }


   /**
    * Set the value of declared.
    *
    * @param declared  Value to assign to declared.
    */
   public void setDeclared (boolean declared)
   {
      if (this.declared != declared)
      {
         this.declared = declared;
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private OOTypeInterface varType;


   /**
    * Get the value of varType.
    *
    * @return   Value of varType.
    */
   public OOTypeInterface getVarType()
   {
      return this.varType;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private OOVariable objectName;


   /**
    * Get the value of objectName.
    *
    * @return   Value of objectName.
    */
   public OOVariable getObjectName()
   {
      return this.objectName;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private OOExpression initExpr;


   /**
    * Get the value of initExpr.
    *
    * @return   Value of initExpr.
    */
   public OOExpression getInitExpr()
   {
      return this.initExpr;
   }


   /**
    * Sets the initExpr attribute of the OOLocalVarDeclStatement object
    *
    * @param initExpr  The new initExpr value
    */
   public void setInitExpr (OOExpression initExpr)
   {
      if (this.initExpr != initExpr)
      {
         this.initExpr = initExpr;
      }
   }


   /**
    * Get the sourceCode attribute of the OOLocalVarDeclStatement object
    *
    * @param visitor  No description provided
    * @return         The sourceCode value
    */
   public String getSourceCode (OOGenVisitor visitor)
   {
      return visitor.getSourceCode (this);
   }


   /**
    * @return   short string representation of current object
    */
   public String toString()
   {
      return "OOLocalVarDeclStatement[" + this.declared + "," +
         this.varType + "," + this.objectName + "," + this.initExpr + "]";
   }
}

/*
 * $Log: OOLocalVarDeclStatement.java,v $
 * Revision 1.17  2004/10/20 17:49:34  schneider
 * Introduction of interfaces for class diagram classes
 *
 */
