package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLArray;

public class ArrayReferenceEngine
extends GFRNEngine
{
   private  ArrayReferenceEngine()
   {
   }

   private static ArrayReferenceEngine theArrayReferenceEngine;

   public static ArrayReferenceEngine get()
   {
      if (theArrayReferenceEngine == null)
      {
         theArrayReferenceEngine = new ArrayReferenceEngine ();
      }
      return theArrayReferenceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ArrayReferenceAnnotation arrayReference = null ;
      Iterator fujaba__IterFieldTypeRevAttrTypeReferencingField = null ;
      Iterator fujaba__IterReferencingClassAnnotationsArrayReference = null ;
      Iterator fujaba__IterReferencingClassAttrsReferencingField = null ;
      Iterator fujaba__IterReferencingClassMethodsReapOp = null ;
      Iterator fujaba__IterReferencingClassMethodsWriteOp = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsArrayReference = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation2 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation4 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation6 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation8 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation1 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation3 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation5 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation7 = null ;
      Iterator fujaba__IterReferredClassAnnotationsArrayReference = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReadOperationAnnotation readOperation2 = null ;
      ReadOperationAnnotation readOperation4 = null ;
      ReadOperationAnnotation readOperation6 = null ;
      ReadOperationAnnotation readOperation8 = null ;
      de.uni_paderborn.fujaba.uml.UMLArray fieldType = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr referencingField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencingClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referredClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod reapOp = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod writeOp = null ;
      WriteOperationAnnotation writeOperation1 = null ;
      WriteOperationAnnotation writeOperation3 = null ;
      WriteOperationAnnotation writeOperation5 = null ;
      WriteOperationAnnotation writeOperation7 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLArray ) ;
             
            // explicit type cast
            fieldType = (de.uni_paderborn.fujaba.uml.UMLArray) fujaba__tmpTypeCastObject ;
             
            // bind referredClass: UMLClass
            fujaba__TmpObject = fieldType.getArrayType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterFieldTypeRevAttrTypeReferencingField = fieldType.iteratorOfRevAttrType () ;
            while ( fujaba__IterFieldTypeRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterFieldTypeRevAttrTypeReferencingField.next () ;
                   
                  // bind referencingClass: UMLClass
                  referencingClass = referencingField.getParent () ;
                  JavaSDM.ensure ( referencingClass != null ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                   
                  // bind writeOperation1: WriteOperationAnnotation
                  fujaba__IterReferencingFieldAnnotationsWriteOperation1 = referencingField.iteratorOfAnnotations () ;
                  do
                  {
                     try
                     {
                        writeOperation1 = null ;
                        if ( fujaba__IterReferencingFieldAnnotationsWriteOperation1.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation1.next () ;
                           if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                           {
                              writeOperation1 = (WriteOperationAnnotation) fujaba__TmpObject;
                           }
                           else
                           {
                              JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation1.hasNext ()) ) ;
                           }
                        }
                         
                        // check Reverse-Qualified-Link 'elements' between writeOperation1 and referencingField
                        JavaSDM.ensure ( (writeOperation1 == null) || writeOperation1.hasInElements ("field", referencingField) ) ;
                         
                        // bind readOperation2: ReadOperationAnnotation
                        fujaba__IterReferencingFieldAnnotationsReadOperation2 = referencingField.iteratorOfAnnotations () ;
                        do
                        {
                           try
                           {
                              readOperation2 = null ;
                              if ( fujaba__IterReferencingFieldAnnotationsReadOperation2.hasNext () )
                              {
                                 fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation2.next () ;
                                 if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                                 {
                                    readOperation2 = (ReadOperationAnnotation) fujaba__TmpObject;
                                 }
                                 else
                                 {
                                    JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation2.hasNext ()) ) ;
                                 }
                              }
                               
                              // check Reverse-Qualified-Link 'elements' between readOperation2 and referencingField
                              JavaSDM.ensure ( (readOperation2 == null) || readOperation2.hasInElements ("field", referencingField) ) ;
                               
                              // bind reapOp: UMLMethod
                              fujaba__IterReferencingClassMethodsReapOp = referencingClass.iteratorOfMethods () ;
                              do
                              {
                                 try
                                 {
                                    reapOp = null ;
                                    if ( fujaba__IterReferencingClassMethodsReapOp.hasNext () )
                                    {
                                       reapOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReapOp.next () ;
                                        
                                    }
                                     
                                    // check To-Many-Link 'elements' between readOperation2 and reapOp
                                    JavaSDM.ensure ( ((readOperation2 == null) || (reapOp == null)) || ((readOperation2 != null) || (reapOp != null) || readOperation2.hasInElements ("method", reapOp)) ) ;
                                     
                                    // bind writeOp: UMLMethod
                                    fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                                    do
                                    {
                                       try
                                       {
                                          writeOp = null ;
                                          if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                                          {
                                             writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                              
                                          }
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( (writeOp == null) || ((reapOp == null) || !(reapOp.equals (writeOp))) ) ;
                                           
                                          // check To-Many-Link 'elements' between writeOperation1 and writeOp
                                          JavaSDM.ensure ( ((writeOperation1 == null) || (writeOp == null)) || ((writeOperation1 != null) || (writeOp != null) || writeOperation1.hasInElements ("method", writeOp)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object referencingClass is really bound
                                                JavaSDM.ensure ( referencingClass != null ) ;
                                                 
                                                // check object referredClass is really bound
                                                JavaSDM.ensure ( referredClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                 
                                                // check object referencingField is really bound
                                                JavaSDM.ensure ( referencingField != null ) ;
                                                 
                                                // bind arrayReference: ArrayReferenceAnnotation
                                                fujaba__IterReferencingFieldAnnotationsArrayReference = referencingField.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReferencingFieldAnnotationsArrayReference.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsArrayReference.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof ArrayReferenceAnnotation ) ;
                                                      arrayReference = (ArrayReferenceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between arrayReference and referencingField
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("field", referencingField) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between arrayReference and referencingClass
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between arrayReference and referredClass
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("references", referredClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object referencingClass is really bound
                                                   JavaSDM.ensure ( referencingClass != null ) ;
                                                    
                                                   // check object referredClass is really bound
                                                   JavaSDM.ensure ( referredClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                    
                                                   // check object referencingField is really bound
                                                   JavaSDM.ensure ( referencingField != null ) ;
                                                    
                                                   // check object fieldType is really bound
                                                   JavaSDM.ensure ( fieldType != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( (writeOp == null) || ((reapOp == null) || !(reapOp.equals (writeOp))) ) ;
                                                    
                                                   // create object
                                                   arrayReference = new ArrayReferenceAnnotation ( ) ;
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("referecningClass", referencingClass);
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("references", referredClass);
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("field", referencingField);
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("fieldType", fieldType);
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referencingField", referencingField);
                                                    
                                                   // create link
                                                   if ( reapOp != null )
                                                   {
                                                      arrayReference.addToBoundObjects ("reapOp", reapOp);
                                                   } // if
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referencingClass", referencingClass);
                                                    
                                                   // create link
                                                   if ( writeOp != null )
                                                   {
                                                      arrayReference.addToBoundObjects ("writeOp", writeOp);
                                                   } // if
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referredClass", referredClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object arrayReference is really bound
                                                   JavaSDM.ensure ( arrayReference != null ) ;
                                                    
                                                   // create link
                                                   if ( writeOperation1 != null )
                                                   {
                                                      arrayReference.addToAntecedentAnnos (writeOperation1);
                                                   } // if
                                                    
                                                   // create link
                                                   if ( readOperation2 != null )
                                                   {
                                                      arrayReference.addToAntecedentAnnos (readOperation2);
                                                   } // if
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (arrayReference) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingClassMethodsReapOp.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingFieldAnnotationsReadOperation2.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
                  while ( fujaba__IterReferencingFieldAnnotationsWriteOperation1.hasNext () ) ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object arrayReference is really bound
            JavaSDM.ensure ( arrayReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind fieldType: UMLArray
            fujaba__TmpObject = referencingField.getAttrType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLArray ) ;
            fieldType = (de.uni_paderborn.fujaba.uml.UMLArray) fujaba__TmpObject ;
             
            // bind referencingClass: UMLClass
            referencingClass = referencingField.getParent () ;
            JavaSDM.ensure ( referencingClass != null ) ;
             
            // bind referredClass: UMLClass
            fujaba__TmpObject = fieldType.getArrayType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
             
            // bind writeOperation3: WriteOperationAnnotation
            fujaba__IterReferencingFieldAnnotationsWriteOperation3 = referencingField.iteratorOfAnnotations () ;
            do
            {
               try
               {
                  writeOperation3 = null ;
                  if ( fujaba__IterReferencingFieldAnnotationsWriteOperation3.hasNext () )
                  {
                     fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation3.next () ;
                     if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                     {
                        writeOperation3 = (WriteOperationAnnotation) fujaba__TmpObject;
                     }
                     else
                     {
                        JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation3.hasNext ()) ) ;
                     }
                  }
                   
                  // check Reverse-Qualified-Link 'elements' between writeOperation3 and referencingField
                  JavaSDM.ensure ( (writeOperation3 == null) || writeOperation3.hasInElements ("field", referencingField) ) ;
                   
                  // bind readOperation4: ReadOperationAnnotation
                  fujaba__IterReferencingFieldAnnotationsReadOperation4 = referencingField.iteratorOfAnnotations () ;
                  do
                  {
                     try
                     {
                        readOperation4 = null ;
                        if ( fujaba__IterReferencingFieldAnnotationsReadOperation4.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation4.next () ;
                           if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                           {
                              readOperation4 = (ReadOperationAnnotation) fujaba__TmpObject;
                           }
                           else
                           {
                              JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation4.hasNext ()) ) ;
                           }
                        }
                         
                        // check Reverse-Qualified-Link 'elements' between readOperation4 and referencingField
                        JavaSDM.ensure ( (readOperation4 == null) || readOperation4.hasInElements ("field", referencingField) ) ;
                         
                        // bind reapOp: UMLMethod
                        fujaba__IterReferencingClassMethodsReapOp = referencingClass.iteratorOfMethods () ;
                        do
                        {
                           try
                           {
                              reapOp = null ;
                              if ( fujaba__IterReferencingClassMethodsReapOp.hasNext () )
                              {
                                 reapOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReapOp.next () ;
                                  
                              }
                               
                              // check To-Many-Link 'elements' between readOperation4 and reapOp
                              JavaSDM.ensure ( ((readOperation4 == null) || (reapOp == null)) || ((readOperation4 != null) || (reapOp != null) || readOperation4.hasInElements ("method", reapOp)) ) ;
                               
                              // bind writeOp: UMLMethod
                              fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                              do
                              {
                                 try
                                 {
                                    writeOp = null ;
                                    if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                                    {
                                       writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                        
                                    }
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( (writeOp == null) || ((reapOp == null) || !(reapOp.equals (writeOp))) ) ;
                                     
                                    // check To-Many-Link 'elements' between writeOperation3 and writeOp
                                    JavaSDM.ensure ( ((writeOperation3 == null) || (writeOp == null)) || ((writeOperation3 != null) || (writeOp != null) || writeOperation3.hasInElements ("method", writeOp)) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object referencingClass is really bound
                                          JavaSDM.ensure ( referencingClass != null ) ;
                                           
                                          // check object referredClass is really bound
                                          JavaSDM.ensure ( referredClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                           
                                          // check object referencingField is really bound
                                          JavaSDM.ensure ( referencingField != null ) ;
                                           
                                          // bind arrayReference: ArrayReferenceAnnotation
                                          fujaba__IterReferredClassAnnotationsArrayReference = referredClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterReferredClassAnnotationsArrayReference.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterReferredClassAnnotationsArrayReference.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ArrayReferenceAnnotation ) ;
                                                arrayReference = (ArrayReferenceAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between arrayReference and referredClass
                                                JavaSDM.ensure ( arrayReference.hasInElements ("references", referredClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between arrayReference and referencingClass
                                                JavaSDM.ensure ( arrayReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between arrayReference and referencingField
                                                JavaSDM.ensure ( arrayReference.hasInElements ("field", referencingField) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object referencingClass is really bound
                                             JavaSDM.ensure ( referencingClass != null ) ;
                                              
                                             // check object referredClass is really bound
                                             JavaSDM.ensure ( referredClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                              
                                             // check object referencingField is really bound
                                             JavaSDM.ensure ( referencingField != null ) ;
                                              
                                             // check object fieldType is really bound
                                             JavaSDM.ensure ( fieldType != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( (writeOp == null) || ((reapOp == null) || !(reapOp.equals (writeOp))) ) ;
                                              
                                             // create object
                                             arrayReference = new ArrayReferenceAnnotation ( ) ;
                                              
                                             // create link
                                             arrayReference.addToElements ("referecningClass", referencingClass);
                                              
                                             // create link
                                             arrayReference.addToElements ("references", referredClass);
                                              
                                             // create link
                                             arrayReference.addToElements ("field", referencingField);
                                              
                                             // create link
                                             arrayReference.addToBoundObjects ("fieldType", fieldType);
                                              
                                             // create link
                                             arrayReference.addToBoundObjects ("referencingField", referencingField);
                                              
                                             // create link
                                             if ( reapOp != null )
                                             {
                                                arrayReference.addToBoundObjects ("reapOp", reapOp);
                                             } // if
                                              
                                             // create link
                                             arrayReference.addToBoundObjects ("referencingClass", referencingClass);
                                              
                                             // create link
                                             if ( writeOp != null )
                                             {
                                                arrayReference.addToBoundObjects ("writeOp", writeOp);
                                             } // if
                                              
                                             // create link
                                             arrayReference.addToBoundObjects ("referredClass", referredClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object arrayReference is really bound
                                             JavaSDM.ensure ( arrayReference != null ) ;
                                              
                                             // create link
                                             if ( writeOperation3 != null )
                                             {
                                                arrayReference.addToAntecedentAnnos (writeOperation3);
                                             } // if
                                              
                                             // create link
                                             if ( readOperation4 != null )
                                             {
                                                arrayReference.addToAntecedentAnnos (readOperation4);
                                             } // if
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (arrayReference) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingClassMethodsReapOp.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
                  while ( fujaba__IterReferencingFieldAnnotationsReadOperation4.hasNext () ) ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
            while ( fujaba__IterReferencingFieldAnnotationsWriteOperation3.hasNext () ) ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object arrayReference is really bound
            JavaSDM.ensure ( arrayReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("referecningClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  // bind fieldType: UMLArray
                  fujaba__TmpObject = referencingField.getAttrType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLArray ) ;
                  fieldType = (de.uni_paderborn.fujaba.uml.UMLArray) fujaba__TmpObject ;
                   
                  // bind referredClass: UMLClass
                  fujaba__TmpObject = fieldType.getArrayType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                   
                  // bind reapOp: UMLMethod
                  fujaba__IterReferencingClassMethodsReapOp = referencingClass.iteratorOfMethods () ;
                  do
                  {
                     try
                     {
                        reapOp = null ;
                        if ( fujaba__IterReferencingClassMethodsReapOp.hasNext () )
                        {
                           reapOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReapOp.next () ;
                            
                        }
                         
                        // bind writeOp: UMLMethod
                        fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                        do
                        {
                           try
                           {
                              writeOp = null ;
                              if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                              {
                                 writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                  
                              }
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( (writeOp == null) || ((reapOp == null) || !(reapOp.equals (writeOp))) ) ;
                               
                              // bind writeOperation5: WriteOperationAnnotation
                              fujaba__IterReferencingFieldAnnotationsWriteOperation5 = referencingField.iteratorOfAnnotations () ;
                              do
                              {
                                 try
                                 {
                                    writeOperation5 = null ;
                                    if ( fujaba__IterReferencingFieldAnnotationsWriteOperation5.hasNext () )
                                    {
                                       fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation5.next () ;
                                       if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                                       {
                                          writeOperation5 = (WriteOperationAnnotation) fujaba__TmpObject;
                                       }
                                       else
                                       {
                                          JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation5.hasNext ()) ) ;
                                       }
                                    }
                                     
                                    // check Reverse-Qualified-Link 'elements' between writeOperation5 and referencingField
                                    JavaSDM.ensure ( (writeOperation5 == null) || writeOperation5.hasInElements ("field", referencingField) ) ;
                                     
                                    // check To-Many-Link 'elements' between writeOperation5 and writeOp
                                    JavaSDM.ensure ( ((writeOperation5 == null) || (writeOp == null)) || ((writeOperation5 != null) || (writeOp != null) || writeOperation5.hasInElements ("method", writeOp)) ) ;
                                     
                                    // bind readOperation6: ReadOperationAnnotation
                                    fujaba__IterReferencingFieldAnnotationsReadOperation6 = referencingField.iteratorOfAnnotations () ;
                                    do
                                    {
                                       try
                                       {
                                          readOperation6 = null ;
                                          if ( fujaba__IterReferencingFieldAnnotationsReadOperation6.hasNext () )
                                          {
                                             fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation6.next () ;
                                             if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                                             {
                                                readOperation6 = (ReadOperationAnnotation) fujaba__TmpObject;
                                             }
                                             else
                                             {
                                                JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation6.hasNext ()) ) ;
                                             }
                                          }
                                           
                                          // check Reverse-Qualified-Link 'elements' between readOperation6 and referencingField
                                          JavaSDM.ensure ( (readOperation6 == null) || readOperation6.hasInElements ("field", referencingField) ) ;
                                           
                                          // check To-Many-Link 'elements' between readOperation6 and reapOp
                                          JavaSDM.ensure ( ((readOperation6 == null) || (reapOp == null)) || ((readOperation6 != null) || (reapOp != null) || readOperation6.hasInElements ("method", reapOp)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object referencingClass is really bound
                                                JavaSDM.ensure ( referencingClass != null ) ;
                                                 
                                                // check object referredClass is really bound
                                                JavaSDM.ensure ( referredClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                 
                                                // check object referencingField is really bound
                                                JavaSDM.ensure ( referencingField != null ) ;
                                                 
                                                // bind arrayReference: ArrayReferenceAnnotation
                                                fujaba__IterReferencingClassAnnotationsArrayReference = referencingClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReferencingClassAnnotationsArrayReference.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReferencingClassAnnotationsArrayReference.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof ArrayReferenceAnnotation ) ;
                                                      arrayReference = (ArrayReferenceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between arrayReference and referencingClass
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between arrayReference and referredClass
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("references", referredClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between arrayReference and referencingField
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("field", referencingField) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object referencingClass is really bound
                                                   JavaSDM.ensure ( referencingClass != null ) ;
                                                    
                                                   // check object referredClass is really bound
                                                   JavaSDM.ensure ( referredClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                    
                                                   // check object referencingField is really bound
                                                   JavaSDM.ensure ( referencingField != null ) ;
                                                    
                                                   // check object fieldType is really bound
                                                   JavaSDM.ensure ( fieldType != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( (writeOp == null) || ((reapOp == null) || !(reapOp.equals (writeOp))) ) ;
                                                    
                                                   // create object
                                                   arrayReference = new ArrayReferenceAnnotation ( ) ;
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("referecningClass", referencingClass);
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("references", referredClass);
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("field", referencingField);
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("fieldType", fieldType);
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referencingField", referencingField);
                                                    
                                                   // create link
                                                   if ( reapOp != null )
                                                   {
                                                      arrayReference.addToBoundObjects ("reapOp", reapOp);
                                                   } // if
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referencingClass", referencingClass);
                                                    
                                                   // create link
                                                   if ( writeOp != null )
                                                   {
                                                      arrayReference.addToBoundObjects ("writeOp", writeOp);
                                                   } // if
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referredClass", referredClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object arrayReference is really bound
                                                   JavaSDM.ensure ( arrayReference != null ) ;
                                                    
                                                   // create link
                                                   if ( writeOperation5 != null )
                                                   {
                                                      arrayReference.addToAntecedentAnnos (writeOperation5);
                                                   } // if
                                                    
                                                   // create link
                                                   if ( readOperation6 != null )
                                                   {
                                                      arrayReference.addToAntecedentAnnos (readOperation6);
                                                   } // if
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (arrayReference) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingFieldAnnotationsReadOperation6.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingFieldAnnotationsWriteOperation5.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
                  while ( fujaba__IterReferencingClassMethodsReapOp.hasNext () ) ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object arrayReference is really bound
            JavaSDM.ensure ( arrayReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("referecningClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind fieldType: UMLArray
            fieldType = referredClass.getRevArrayType () ;
            JavaSDM.ensure ( fieldType != null ) ;
             
            // bind referencingField: UMLAttr
            fujaba__IterFieldTypeRevAttrTypeReferencingField = fieldType.iteratorOfRevAttrType () ;
            while ( fujaba__IterFieldTypeRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterFieldTypeRevAttrTypeReferencingField.next () ;
                   
                  // bind referencingClass: UMLClass
                  referencingClass = referencingField.getParent () ;
                  JavaSDM.ensure ( referencingClass != null ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                   
                  // bind writeOperation7: WriteOperationAnnotation
                  fujaba__IterReferencingFieldAnnotationsWriteOperation7 = referencingField.iteratorOfAnnotations () ;
                  do
                  {
                     try
                     {
                        writeOperation7 = null ;
                        if ( fujaba__IterReferencingFieldAnnotationsWriteOperation7.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation7.next () ;
                           if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                           {
                              writeOperation7 = (WriteOperationAnnotation) fujaba__TmpObject;
                           }
                           else
                           {
                              JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation7.hasNext ()) ) ;
                           }
                        }
                         
                        // check Reverse-Qualified-Link 'elements' between writeOperation7 and referencingField
                        JavaSDM.ensure ( (writeOperation7 == null) || writeOperation7.hasInElements ("field", referencingField) ) ;
                         
                        // bind readOperation8: ReadOperationAnnotation
                        fujaba__IterReferencingFieldAnnotationsReadOperation8 = referencingField.iteratorOfAnnotations () ;
                        do
                        {
                           try
                           {
                              readOperation8 = null ;
                              if ( fujaba__IterReferencingFieldAnnotationsReadOperation8.hasNext () )
                              {
                                 fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation8.next () ;
                                 if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                                 {
                                    readOperation8 = (ReadOperationAnnotation) fujaba__TmpObject;
                                 }
                                 else
                                 {
                                    JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation8.hasNext ()) ) ;
                                 }
                              }
                               
                              // check Reverse-Qualified-Link 'elements' between readOperation8 and referencingField
                              JavaSDM.ensure ( (readOperation8 == null) || readOperation8.hasInElements ("field", referencingField) ) ;
                               
                              // bind reapOp: UMLMethod
                              fujaba__IterReferencingClassMethodsReapOp = referencingClass.iteratorOfMethods () ;
                              do
                              {
                                 try
                                 {
                                    reapOp = null ;
                                    if ( fujaba__IterReferencingClassMethodsReapOp.hasNext () )
                                    {
                                       reapOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReapOp.next () ;
                                        
                                    }
                                     
                                    // check To-Many-Link 'elements' between readOperation8 and reapOp
                                    JavaSDM.ensure ( ((readOperation8 == null) || (reapOp == null)) || ((readOperation8 != null) || (reapOp != null) || readOperation8.hasInElements ("method", reapOp)) ) ;
                                     
                                    // bind writeOp: UMLMethod
                                    fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                                    do
                                    {
                                       try
                                       {
                                          writeOp = null ;
                                          if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                                          {
                                             writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                              
                                          }
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( (writeOp == null) || ((reapOp == null) || !(reapOp.equals (writeOp))) ) ;
                                           
                                          // check To-Many-Link 'elements' between writeOperation7 and writeOp
                                          JavaSDM.ensure ( ((writeOperation7 == null) || (writeOp == null)) || ((writeOperation7 != null) || (writeOp != null) || writeOperation7.hasInElements ("method", writeOp)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object referencingClass is really bound
                                                JavaSDM.ensure ( referencingClass != null ) ;
                                                 
                                                // check object referredClass is really bound
                                                JavaSDM.ensure ( referredClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                 
                                                // check object referencingField is really bound
                                                JavaSDM.ensure ( referencingField != null ) ;
                                                 
                                                // bind arrayReference: ArrayReferenceAnnotation
                                                fujaba__IterReferencingClassAnnotationsArrayReference = referencingClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReferencingClassAnnotationsArrayReference.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReferencingClassAnnotationsArrayReference.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof ArrayReferenceAnnotation ) ;
                                                      arrayReference = (ArrayReferenceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between arrayReference and referencingClass
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between arrayReference and referredClass
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("references", referredClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between arrayReference and referencingField
                                                      JavaSDM.ensure ( arrayReference.hasInElements ("field", referencingField) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object referencingClass is really bound
                                                   JavaSDM.ensure ( referencingClass != null ) ;
                                                    
                                                   // check object referredClass is really bound
                                                   JavaSDM.ensure ( referredClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                    
                                                   // check object referencingField is really bound
                                                   JavaSDM.ensure ( referencingField != null ) ;
                                                    
                                                   // check object fieldType is really bound
                                                   JavaSDM.ensure ( fieldType != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( (writeOp == null) || ((reapOp == null) || !(reapOp.equals (writeOp))) ) ;
                                                    
                                                   // create object
                                                   arrayReference = new ArrayReferenceAnnotation ( ) ;
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("referecningClass", referencingClass);
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("references", referredClass);
                                                    
                                                   // create link
                                                   arrayReference.addToElements ("field", referencingField);
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("fieldType", fieldType);
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referencingField", referencingField);
                                                    
                                                   // create link
                                                   if ( reapOp != null )
                                                   {
                                                      arrayReference.addToBoundObjects ("reapOp", reapOp);
                                                   } // if
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referencingClass", referencingClass);
                                                    
                                                   // create link
                                                   if ( writeOp != null )
                                                   {
                                                      arrayReference.addToBoundObjects ("writeOp", writeOp);
                                                   } // if
                                                    
                                                   // create link
                                                   arrayReference.addToBoundObjects ("referredClass", referredClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object arrayReference is really bound
                                                   JavaSDM.ensure ( arrayReference != null ) ;
                                                    
                                                   // create link
                                                   if ( writeOperation7 != null )
                                                   {
                                                      arrayReference.addToAntecedentAnnos (writeOperation7);
                                                   } // if
                                                    
                                                   // create link
                                                   if ( readOperation8 != null )
                                                   {
                                                      arrayReference.addToAntecedentAnnos (readOperation8);
                                                   } // if
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (arrayReference) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingClassMethodsReapOp.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingFieldAnnotationsReadOperation8.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
                  while ( fujaba__IterReferencingFieldAnnotationsWriteOperation7.hasNext () ) ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object arrayReference is really bound
            JavaSDM.ensure ( arrayReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("references", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (arrayReference) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("referecningClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLArray )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterFieldTypeRevAttrTypeReferencingField = null ;
      Iterator fujaba__IterReferencingClassAttrsReferencingField = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLArray fieldType = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr referencingField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencingClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referredClass = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("WriteOperation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind fieldType: UMLArray
            fieldType = referredClass.getRevArrayType () ;
            JavaSDM.ensure ( fieldType != null ) ;
             
            // bind referencingField: UMLAttr
            fujaba__IterFieldTypeRevAttrTypeReferencingField = fieldType.iteratorOfRevAttrType () ;
            while ( fujaba__IterFieldTypeRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterFieldTypeRevAttrTypeReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLArray ) ;
             
            // explicit type cast
            fieldType = (de.uni_paderborn.fujaba.uml.UMLArray) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterFieldTypeRevAttrTypeReferencingField = fieldType.iteratorOfRevAttrType () ;
            while ( fujaba__IterFieldTypeRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterFieldTypeRevAttrTypeReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("ReadOperation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind fieldType: UMLArray
            fieldType = referredClass.getRevArrayType () ;
            JavaSDM.ensure ( fieldType != null ) ;
             
            // bind referencingField: UMLAttr
            fujaba__IterFieldTypeRevAttrTypeReferencingField = fieldType.iteratorOfRevAttrType () ;
            while ( fujaba__IterFieldTypeRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterFieldTypeRevAttrTypeReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLArray ) ;
             
            // explicit type cast
            fieldType = (de.uni_paderborn.fujaba.uml.UMLArray) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterFieldTypeRevAttrTypeReferencingField = fieldType.iteratorOfRevAttrType () ;
            while ( fujaba__IterFieldTypeRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterFieldTypeRevAttrTypeReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
