package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class BridgeEngine
extends GFRNEngine
{
   private  BridgeEngine()
   {
   }

   private static BridgeEngine theBridgeEngine;

   public static BridgeEngine get()
   {
      if (theBridgeEngine == null)
      {
         theBridgeEngine = new BridgeEngine ();
      }
      return theBridgeEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      de.upb.tools.fca.FHashSet set = null ;
      boolean fujaba__Success = false ;
      BridgeAnnotation bridge = null ;
      Iterator fujaba__IterAbstractionAnnotationsBridge = null ;
      Iterator fujaba__IterAbstractionAnnotationsGeneralization1 = null ;
      Iterator fujaba__IterAbstractionAnnotationsGeneralization4 = null ;
      Iterator fujaba__IterAbstractionAnnotationsGeneralization7 = null ;
      Iterator fujaba__IterAbstractionAttrsRefField = null ;
      Iterator fujaba__IterAbstractionMethodsOperation = null ;
      Iterator fujaba__IterImplementorAnnotationsBridge = null ;
      Iterator fujaba__IterImplementorAnnotationsReference2 = null ;
      Iterator fujaba__IterImplementorAnnotationsReference8 = null ;
      Iterator fujaba__IterImplementorMethodsOperationImpl = null ;
      Iterator fujaba__IterNeighborCall3ElementsOperation = null ;
      Iterator fujaba__IterNeighborCall6ElementsOperationImpl = null ;
      Iterator fujaba__IterNeighborCall9ElementsOperation = null ;
      Iterator fujaba__IterNeighborCall9ElementsOperationImpl = null ;
      Iterator fujaba__IterOperationAnnotationsNeighborCall6 = null ;
      Iterator fujaba__IterOperationImplAnnotationsNeighborCall3 = null ;
      Iterator fujaba__IterRefFieldAnnotationsReference5 = null ;
      Iterator fujaba__IterReference2ElementsRefField = null ;
      Iterator fujaba__IterReference5ElementsImplementor = null ;
      Iterator fujaba__IterSet = null ;
      GeneralizationAnnotation fujaba__TmpObjectGeneralizationAnnotation = null ;
      GeneralizationAnnotation generalization1 = null ;
      GeneralizationAnnotation generalization4 = null ;
      GeneralizationAnnotation generalization7 = null ;
      NeighborCallAnnotation neighborCall3 = null ;
      NeighborCallAnnotation neighborCall6 = null ;
      NeighborCallAnnotation neighborCall9 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference2 = null ;
      ReferenceAnnotation reference5 = null ;
      ReferenceAnnotation reference8 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass abstraction = null ;
      de.uni_paderborn.fujaba.uml.UMLClass implementor = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod operation = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod operationImpl = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("implementor", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (implementor.isAbstract () == true) ) ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterImplementorMethodsOperationImpl = implementor.iteratorOfMethods () ;
            while ( fujaba__IterImplementorMethodsOperationImpl.hasNext () )
            {
               try
               {
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterImplementorMethodsOperationImpl.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                   
                  // bind reference2: ReferenceAnnotation
                  fujaba__IterImplementorAnnotationsReference2 = implementor.iteratorOfAnnotations () ;
                  while ( fujaba__IterImplementorAnnotationsReference2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterImplementorAnnotationsReference2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference2 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference2 and implementor
                        JavaSDM.ensure ( reference2.hasInElements ("references", implementor) ) ;
                         
                        // bind neighborCall3: NeighborCallAnnotation
                        fujaba__IterOperationImplAnnotationsNeighborCall3 = operationImpl.iteratorOfAnnotations () ;
                        while ( fujaba__IterOperationImplAnnotationsNeighborCall3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOperationImplAnnotationsNeighborCall3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall3 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall3 and operationImpl
                              JavaSDM.ensure ( neighborCall3.hasInElements ("callee", operationImpl) ) ;
                               
                              // bind refField: UMLAttr
                              fujaba__IterReference2ElementsRefField = reference2.iteratorOfElements ("field") ;
                              while ( fujaba__IterReference2ElementsRefField.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference2ElementsRefField.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                    refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                                     
                                    // bind abstraction: UMLClass
                                    abstraction = refField.getParent () ;
                                    JavaSDM.ensure ( abstraction != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                                     
                                    // bind operation: UMLMethod
                                    fujaba__IterNeighborCall3ElementsOperation = neighborCall3.iteratorOfElements ("caller") ;
                                    while ( fujaba__IterNeighborCall3ElementsOperation.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterNeighborCall3ElementsOperation.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(operationImpl.equals (operation)) ) ;
                                           
                                          // check To-One-Link 'parent' between operation and abstraction
                                          JavaSDM.ensure ( (operation.getParent () != null) && operation.getParent ().equals (abstraction) ) ;
                                           
                                          // bind generalization1: GeneralizationAnnotation
                                          fujaba__IterAbstractionAnnotationsGeneralization1 = abstraction.iteratorOfAnnotations () ;
                                          while ( fujaba__IterAbstractionAnnotationsGeneralization1.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractionAnnotationsGeneralization1.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                generalization1 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between generalization1 and abstraction
                                                JavaSDM.ensure ( generalization1.hasInElements ("superClass", abstraction) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( (set == null) || !(set.contains (generalization1)) ) ;
                                                 
                                                // linkSearchToSetTop
                                                set = new de.upb.tools.fca.FHashSet ( ) ;
                                                fujaba__IterSet = implementor.iteratorOfAnnotations () ;
                                                while ( fujaba__IterSet.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterSet.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      set.remove (generalization1);
                                                      //  check link :) 'elements' between set and abstraction
                                                      JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (abstraction) ) ;
                                                       
                                                      set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                } // while
                                                // constraint
                                                JavaSDM.ensure ( set.size() == 0 ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object abstraction is really bound
                                                      JavaSDM.ensure ( abstraction != null ) ;
                                                       
                                                      // check object implementor is really bound
                                                      JavaSDM.ensure ( implementor != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                                                       
                                                      // bind bridge: BridgeAnnotation
                                                      fujaba__IterAbstractionAnnotationsBridge = abstraction.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterAbstractionAnnotationsBridge.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractionAnnotationsBridge.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof BridgeAnnotation ) ;
                                                            bridge = (BridgeAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between bridge and abstraction
                                                            JavaSDM.ensure ( bridge.hasInElements ("abstraction", abstraction) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between bridge and implementor
                                                            JavaSDM.ensure ( bridge.hasInElements ("implementor", implementor) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object abstraction is really bound
                                                         JavaSDM.ensure ( abstraction != null ) ;
                                                          
                                                         // check object implementor is really bound
                                                         JavaSDM.ensure ( implementor != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                                                          
                                                         // check object refField is really bound
                                                         JavaSDM.ensure ( refField != null ) ;
                                                          
                                                         // check object operation is really bound
                                                         JavaSDM.ensure ( operation != null ) ;
                                                          
                                                         // check object operationImpl is really bound
                                                         JavaSDM.ensure ( operationImpl != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                                                          
                                                         // create object
                                                         bridge = new BridgeAnnotation ( ) ;
                                                          
                                                         // create link
                                                         bridge.addToElements ("abstraction", abstraction);
                                                          
                                                         // create link
                                                         bridge.addToElements ("implementor", implementor);
                                                          
                                                         // create link
                                                         bridge.addToBoundObjects ("implementor", implementor);
                                                          
                                                         // create link
                                                         bridge.addToBoundObjects ("abstraction", abstraction);
                                                          
                                                         // create link
                                                         bridge.addToBoundObjects ("refField", refField);
                                                          
                                                         // create link
                                                         bridge.addToBoundObjects ("operation", operation);
                                                          
                                                         // create link
                                                         bridge.addToBoundObjects ("operationImpl", operationImpl);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object generalization1 is really bound
                                                         JavaSDM.ensure ( generalization1 != null ) ;
                                                          
                                                         set.remove (generalization1);
                                                         // check object reference2 is really bound
                                                         JavaSDM.ensure ( reference2 != null ) ;
                                                          
                                                         // check object neighborCall3 is really bound
                                                         JavaSDM.ensure ( neighborCall3 != null ) ;
                                                          
                                                         // check object bridge is really bound
                                                         JavaSDM.ensure ( bridge != null ) ;
                                                          
                                                         // create link
                                                         bridge.addToAntecedentAnnos (generalization1);
                                                          
                                                         // create link
                                                         bridge.addToAntecedentAnnos (reference2);
                                                          
                                                         // create link
                                                         bridge.addToAntecedentAnnos (neighborCall3);
                                                          
                                                         fujaba__IterSet = set.iterator () ;
                                                         while ( fujaba__IterSet.hasNext () )
                                                         {
                                                            fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                            //  create set link
                                                            bridge.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                            fujaba__Success = true ;
                                                         } // while
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (bridge) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object bridge is really bound
            JavaSDM.ensure ( bridge != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("implementor", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("abstraction", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterAbstractionAttrsRefField = abstraction.iteratorOfAttrs () ;
            while ( fujaba__IterAbstractionAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAbstractionAttrsRefField.next () ;
                   
                  // bind operation: UMLMethod
                  fujaba__IterAbstractionMethodsOperation = abstraction.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractionMethodsOperation.hasNext () )
                  {
                     try
                     {
                        operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractionMethodsOperation.next () ;
                         
                        // bind generalization4: GeneralizationAnnotation
                        fujaba__IterAbstractionAnnotationsGeneralization4 = abstraction.iteratorOfAnnotations () ;
                        while ( fujaba__IterAbstractionAnnotationsGeneralization4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAbstractionAnnotationsGeneralization4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization4 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization4 and abstraction
                              JavaSDM.ensure ( generalization4.hasInElements ("superClass", abstraction) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( (set == null) || !(set.contains (generalization4)) ) ;
                               
                              // bind reference5: ReferenceAnnotation
                              fujaba__IterRefFieldAnnotationsReference5 = refField.iteratorOfAnnotations () ;
                              while ( fujaba__IterRefFieldAnnotationsReference5.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterRefFieldAnnotationsReference5.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                    reference5 = (ReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between reference5 and refField
                                    JavaSDM.ensure ( reference5.hasInElements ("field", refField) ) ;
                                     
                                    // bind neighborCall6: NeighborCallAnnotation
                                    fujaba__IterOperationAnnotationsNeighborCall6 = operation.iteratorOfAnnotations () ;
                                    while ( fujaba__IterOperationAnnotationsNeighborCall6.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterOperationAnnotationsNeighborCall6.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall6 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall6 and operation
                                          JavaSDM.ensure ( neighborCall6.hasInElements ("caller", operation) ) ;
                                           
                                          // bind implementor: UMLClass
                                          fujaba__IterReference5ElementsImplementor = reference5.iteratorOfElements ("references") ;
                                          while ( fujaba__IterReference5ElementsImplementor.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterReference5ElementsImplementor.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (implementor.isAbstract () == true) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                                                 
                                                // bind operationImpl: UMLMethod
                                                fujaba__IterNeighborCall6ElementsOperationImpl = neighborCall6.iteratorOfElements ("callee") ;
                                                while ( fujaba__IterNeighborCall6ElementsOperationImpl.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall6ElementsOperationImpl.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between operationImpl and implementor
                                                      JavaSDM.ensure ( (operationImpl.getParent () != null) && operationImpl.getParent ().equals (implementor) ) ;
                                                       
                                                      // linkSearchToSetTop
                                                      set = new de.upb.tools.fca.FHashSet ( ) ;
                                                      fujaba__IterSet = abstraction.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterSet.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterSet.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                            fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                             
                                                            set.remove (generalization4);
                                                            //  check link :) 'elements' between set and implementor
                                                            JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (implementor) ) ;
                                                             
                                                            set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      } // while
                                                      // constraint
                                                      JavaSDM.ensure ( set.size() == 0 ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object abstraction is really bound
                                                            JavaSDM.ensure ( abstraction != null ) ;
                                                             
                                                            // check object implementor is really bound
                                                            JavaSDM.ensure ( implementor != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                                                             
                                                            // bind bridge: BridgeAnnotation
                                                            fujaba__IterAbstractionAnnotationsBridge = abstraction.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterAbstractionAnnotationsBridge.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAbstractionAnnotationsBridge.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof BridgeAnnotation ) ;
                                                                  bridge = (BridgeAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between bridge and abstraction
                                                                  JavaSDM.ensure ( bridge.hasInElements ("abstraction", abstraction) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between bridge and implementor
                                                                  JavaSDM.ensure ( bridge.hasInElements ("implementor", implementor) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object abstraction is really bound
                                                               JavaSDM.ensure ( abstraction != null ) ;
                                                                
                                                               // check object implementor is really bound
                                                               JavaSDM.ensure ( implementor != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                                                                
                                                               // check object refField is really bound
                                                               JavaSDM.ensure ( refField != null ) ;
                                                                
                                                               // check object operation is really bound
                                                               JavaSDM.ensure ( operation != null ) ;
                                                                
                                                               // check object operationImpl is really bound
                                                               JavaSDM.ensure ( operationImpl != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                                                                
                                                               // create object
                                                               bridge = new BridgeAnnotation ( ) ;
                                                                
                                                               // create link
                                                               bridge.addToElements ("abstraction", abstraction);
                                                                
                                                               // create link
                                                               bridge.addToElements ("implementor", implementor);
                                                                
                                                               // create link
                                                               bridge.addToBoundObjects ("implementor", implementor);
                                                                
                                                               // create link
                                                               bridge.addToBoundObjects ("abstraction", abstraction);
                                                                
                                                               // create link
                                                               bridge.addToBoundObjects ("refField", refField);
                                                                
                                                               // create link
                                                               bridge.addToBoundObjects ("operation", operation);
                                                                
                                                               // create link
                                                               bridge.addToBoundObjects ("operationImpl", operationImpl);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object generalization4 is really bound
                                                               JavaSDM.ensure ( generalization4 != null ) ;
                                                                
                                                               set.remove (generalization4);
                                                               // check object reference5 is really bound
                                                               JavaSDM.ensure ( reference5 != null ) ;
                                                                
                                                               // check object neighborCall6 is really bound
                                                               JavaSDM.ensure ( neighborCall6 != null ) ;
                                                                
                                                               // check object bridge is really bound
                                                               JavaSDM.ensure ( bridge != null ) ;
                                                                
                                                               // create link
                                                               bridge.addToAntecedentAnnos (generalization4);
                                                                
                                                               // create link
                                                               bridge.addToAntecedentAnnos (reference5);
                                                                
                                                               // create link
                                                               bridge.addToAntecedentAnnos (neighborCall6);
                                                                
                                                               fujaba__IterSet = set.iterator () ;
                                                               while ( fujaba__IterSet.hasNext () )
                                                               {
                                                                  fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                                  //  create set link
                                                                  bridge.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                                  fujaba__Success = true ;
                                                               } // while
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (bridge) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object bridge is really bound
            JavaSDM.ensure ( bridge != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("abstraction", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall9 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind operation: UMLMethod
            fujaba__IterNeighborCall9ElementsOperation = neighborCall9.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall9ElementsOperation.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall9ElementsOperation.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind abstraction: UMLClass
                  abstraction = operation.getParent () ;
                  JavaSDM.ensure ( abstraction != null ) ;
                   
                  // bind operationImpl: UMLMethod
                  fujaba__IterNeighborCall9ElementsOperationImpl = neighborCall9.iteratorOfElements ("callee") ;
                  while ( fujaba__IterNeighborCall9ElementsOperationImpl.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall9ElementsOperationImpl.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                         
                        // bind implementor: UMLClass
                        implementor = operationImpl.getParent () ;
                        JavaSDM.ensure ( implementor != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (implementor.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                         
                        // bind refField: UMLAttr
                        fujaba__IterAbstractionAttrsRefField = abstraction.iteratorOfAttrs () ;
                        while ( fujaba__IterAbstractionAttrsRefField.hasNext () )
                        {
                           try
                           {
                              refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAbstractionAttrsRefField.next () ;
                               
                              // bind generalization7: GeneralizationAnnotation
                              fujaba__IterAbstractionAnnotationsGeneralization7 = abstraction.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractionAnnotationsGeneralization7.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractionAnnotationsGeneralization7.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization7 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization7 and abstraction
                                    JavaSDM.ensure ( generalization7.hasInElements ("superClass", abstraction) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( (set == null) || !(set.contains (generalization7)) ) ;
                                     
                                    // bind reference8: ReferenceAnnotation
                                    fujaba__IterImplementorAnnotationsReference8 = implementor.iteratorOfAnnotations () ;
                                    while ( fujaba__IterImplementorAnnotationsReference8.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterImplementorAnnotationsReference8.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                          reference8 = (ReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between reference8 and implementor
                                          JavaSDM.ensure ( reference8.hasInElements ("references", implementor) ) ;
                                           
                                          // check To-Many-Link 'elements' between reference8 and refField
                                          JavaSDM.ensure ( reference8.hasInElements ("field", refField) ) ;
                                           
                                          // linkSearchToSetTop
                                          set = new de.upb.tools.fca.FHashSet ( ) ;
                                          fujaba__IterSet = abstraction.iteratorOfAnnotations () ;
                                          while ( fujaba__IterSet.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSet.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                set.remove (generalization7);
                                                //  check link :) 'elements' between set and implementor
                                                JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (implementor) ) ;
                                                 
                                                set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          } // while
                                          // constraint
                                          JavaSDM.ensure ( set.size() == 0 ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object abstraction is really bound
                                                JavaSDM.ensure ( abstraction != null ) ;
                                                 
                                                // check object implementor is really bound
                                                JavaSDM.ensure ( implementor != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                                                 
                                                // bind bridge: BridgeAnnotation
                                                fujaba__IterImplementorAnnotationsBridge = implementor.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterImplementorAnnotationsBridge.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterImplementorAnnotationsBridge.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof BridgeAnnotation ) ;
                                                      bridge = (BridgeAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between bridge and implementor
                                                      JavaSDM.ensure ( bridge.hasInElements ("implementor", implementor) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between bridge and abstraction
                                                      JavaSDM.ensure ( bridge.hasInElements ("abstraction", abstraction) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object abstraction is really bound
                                                   JavaSDM.ensure ( abstraction != null ) ;
                                                    
                                                   // check object implementor is really bound
                                                   JavaSDM.ensure ( implementor != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                                                    
                                                   // check object refField is really bound
                                                   JavaSDM.ensure ( refField != null ) ;
                                                    
                                                   // check object operation is really bound
                                                   JavaSDM.ensure ( operation != null ) ;
                                                    
                                                   // check object operationImpl is really bound
                                                   JavaSDM.ensure ( operationImpl != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                                                    
                                                   // create object
                                                   bridge = new BridgeAnnotation ( ) ;
                                                    
                                                   // create link
                                                   bridge.addToElements ("abstraction", abstraction);
                                                    
                                                   // create link
                                                   bridge.addToElements ("implementor", implementor);
                                                    
                                                   // create link
                                                   bridge.addToBoundObjects ("implementor", implementor);
                                                    
                                                   // create link
                                                   bridge.addToBoundObjects ("abstraction", abstraction);
                                                    
                                                   // create link
                                                   bridge.addToBoundObjects ("refField", refField);
                                                    
                                                   // create link
                                                   bridge.addToBoundObjects ("operation", operation);
                                                    
                                                   // create link
                                                   bridge.addToBoundObjects ("operationImpl", operationImpl);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object generalization7 is really bound
                                                   JavaSDM.ensure ( generalization7 != null ) ;
                                                    
                                                   set.remove (generalization7);
                                                   // check object reference8 is really bound
                                                   JavaSDM.ensure ( reference8 != null ) ;
                                                    
                                                   // check object neighborCall9 is really bound
                                                   JavaSDM.ensure ( neighborCall9 != null ) ;
                                                    
                                                   // check object bridge is really bound
                                                   JavaSDM.ensure ( bridge != null ) ;
                                                    
                                                   // create link
                                                   bridge.addToAntecedentAnnos (generalization7);
                                                    
                                                   // create link
                                                   bridge.addToAntecedentAnnos (reference8);
                                                    
                                                   // create link
                                                   bridge.addToAntecedentAnnos (neighborCall9);
                                                    
                                                   fujaba__IterSet = set.iterator () ;
                                                   while ( fujaba__IterSet.hasNext () )
                                                   {
                                                      fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                      //  create set link
                                                      bridge.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                      fujaba__Success = true ;
                                                   } // while
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (bridge) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object bridge is really bound
            JavaSDM.ensure ( bridge != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (bridge) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("abstraction", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("implementor", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractionMethodsOperation = null ;
      Iterator fujaba__IterImplementorAnnotationsReference11 = null ;
      Iterator fujaba__IterImplementorMethodsOperationImpl = null ;
      Iterator fujaba__IterNeighborCall10ElementsOperation = null ;
      Iterator fujaba__IterNeighborCall10ElementsOperationImpl = null ;
      Iterator fujaba__IterNeighborCall12ElementsOperationImpl = null ;
      Iterator fujaba__IterOperationAnnotationsNeighborCall12 = null ;
      Iterator fujaba__IterOperationImplAnnotationsNeighborCall10 = null ;
      Iterator fujaba__IterReference11ElementsRefField = null ;
      NeighborCallAnnotation neighborCall10 = null ;
      NeighborCallAnnotation neighborCall12 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference11 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass abstraction = null ;
      de.uni_paderborn.fujaba.uml.UMLClass implementor = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod operation = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod operationImpl = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstraction);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterImplementorMethodsOperationImpl = implementor.iteratorOfMethods () ;
            while ( fujaba__IterImplementorMethodsOperationImpl.hasNext () )
            {
               try
               {
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterImplementorMethodsOperationImpl.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                   
                  // bind neighborCall10: NeighborCallAnnotation
                  fujaba__IterOperationImplAnnotationsNeighborCall10 = operationImpl.iteratorOfAnnotations () ;
                  while ( fujaba__IterOperationImplAnnotationsNeighborCall10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOperationImplAnnotationsNeighborCall10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall10 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall10 and operationImpl
                        JavaSDM.ensure ( neighborCall10.hasInElements ("callee", operationImpl) ) ;
                         
                        // bind operation: UMLMethod
                        fujaba__IterNeighborCall10ElementsOperation = neighborCall10.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall10ElementsOperation.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall10ElementsOperation.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(operationImpl.equals (operation)) ) ;
                               
                              // bind abstraction: UMLClass
                              abstraction = operation.getParent () ;
                              JavaSDM.ensure ( abstraction != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstraction);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall10 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterNeighborCall10ElementsOperationImpl = neighborCall10.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall10ElementsOperationImpl.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall10ElementsOperationImpl.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                   
                  // bind implementor: UMLClass
                  implementor = operationImpl.getParent () ;
                  JavaSDM.ensure ( implementor != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (implementor.isAbstract () == true) ) ;
                   
                  // bind reference11: ReferenceAnnotation
                  fujaba__IterImplementorAnnotationsReference11 = implementor.iteratorOfAnnotations () ;
                  while ( fujaba__IterImplementorAnnotationsReference11.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterImplementorAnnotationsReference11.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference11 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference11 and implementor
                        JavaSDM.ensure ( reference11.hasInElements ("references", implementor) ) ;
                         
                        // bind refField: UMLAttr
                        fujaba__IterReference11ElementsRefField = reference11.iteratorOfElements ("field") ;
                        while ( fujaba__IterReference11ElementsRefField.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReference11ElementsRefField.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              // bind abstraction: UMLClass
                              abstraction = refField.getParent () ;
                              JavaSDM.ensure ( abstraction != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstraction);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstraction);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (implementor);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall10 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterNeighborCall10ElementsOperationImpl = neighborCall10.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall10ElementsOperationImpl.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall10ElementsOperationImpl.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                   
                  // bind implementor: UMLClass
                  implementor = operationImpl.getParent () ;
                  JavaSDM.ensure ( implementor != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (implementor.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (implementor);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind operation: UMLMethod
            fujaba__IterAbstractionMethodsOperation = abstraction.iteratorOfMethods () ;
            while ( fujaba__IterAbstractionMethodsOperation.hasNext () )
            {
               try
               {
                  operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractionMethodsOperation.next () ;
                   
                  // bind neighborCall12: NeighborCallAnnotation
                  fujaba__IterOperationAnnotationsNeighborCall12 = operation.iteratorOfAnnotations () ;
                  while ( fujaba__IterOperationAnnotationsNeighborCall12.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOperationAnnotationsNeighborCall12.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall12 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall12 and operation
                        JavaSDM.ensure ( neighborCall12.hasInElements ("caller", operation) ) ;
                         
                        // bind operationImpl: UMLMethod
                        fujaba__IterNeighborCall12ElementsOperationImpl = neighborCall12.iteratorOfElements ("callee") ;
                        while ( fujaba__IterNeighborCall12ElementsOperationImpl.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall12ElementsOperationImpl.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                               
                              // bind implementor: UMLClass
                              implementor = operationImpl.getParent () ;
                              JavaSDM.ensure ( implementor != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (implementor.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (implementor);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (implementor);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall12 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterNeighborCall12ElementsOperationImpl = neighborCall12.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall12ElementsOperationImpl.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall12ElementsOperationImpl.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                   
                  // bind implementor: UMLClass
                  implementor = operationImpl.getParent () ;
                  JavaSDM.ensure ( implementor != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (implementor.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (implementor);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind operation: UMLMethod
            fujaba__IterAbstractionMethodsOperation = abstraction.iteratorOfMethods () ;
            while ( fujaba__IterAbstractionMethodsOperation.hasNext () )
            {
               try
               {
                  operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractionMethodsOperation.next () ;
                   
                  {
                     //  for each flow
                     set.add (operation);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterImplementorMethodsOperationImpl = implementor.iteratorOfMethods () ;
            while ( fujaba__IterImplementorMethodsOperationImpl.hasNext () )
            {
               try
               {
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterImplementorMethodsOperationImpl.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (operationImpl.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (operationImpl);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
