package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class BroadcastMediatorEngine
extends GFRNEngine
{
   private  BroadcastMediatorEngine()
   {
   }

   private static BroadcastMediatorEngine theBroadcastMediatorEngine;

   public static BroadcastMediatorEngine get()
   {
      if (theBroadcastMediatorEngine == null)
      {
         theBroadcastMediatorEngine = new BroadcastMediatorEngine ();
      }
      return theBroadcastMediatorEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      BroadcastMediatorAnnotation broadcastMediator = null ;
      Iterator fujaba__IterColleagueAnnotationsBroadcastMediator = null ;
      Iterator fujaba__IterColleagueAnnotationsOneToManyAssociation20 = null ;
      Iterator fujaba__IterColleagueAnnotationsOneToManyAssociation6 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod1 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod17 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod3 = null ;
      Iterator fujaba__IterMediatorAnnotationsBroadcastMediator = null ;
      Iterator fujaba__IterMediatorAnnotationsOneToManyAssociation13 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod12 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod19 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod9 = null ;
      Iterator fujaba__IterNeighborCall11ElementsUMLMethod10 = null ;
      Iterator fujaba__IterNeighborCall14ElementsUMLMethod8 = null ;
      Iterator fujaba__IterNeighborCall21ElementsUMLMethod15 = null ;
      Iterator fujaba__IterNeighborCall21ElementsUMLMethod16 = null ;
      Iterator fujaba__IterNeighborCall4ElementsUMLMethod5 = null ;
      Iterator fujaba__IterNeighborCall7ElementsUMLMethod2 = null ;
      Iterator fujaba__IterOneToManyAssociation13ElementsColleague = null ;
      Iterator fujaba__IterOneToManyAssociation6ElementsMediator = null ;
      Iterator fujaba__IterUMLMethod12AnnotationsNeighborCall11 = null ;
      Iterator fujaba__IterUMLMethod17AnnotationsNeighborCall18 = null ;
      Iterator fujaba__IterUMLMethod1AnnotationsNeighborCall7 = null ;
      Iterator fujaba__IterUMLMethod3AnnotationsNeighborCall4 = null ;
      Iterator fujaba__IterUMLMethod9AnnotationsNeighborCall14 = null ;
      NeighborCallAnnotation neighborCall11 = null ;
      NeighborCallAnnotation neighborCall14 = null ;
      NeighborCallAnnotation neighborCall18 = null ;
      NeighborCallAnnotation neighborCall21 = null ;
      NeighborCallAnnotation neighborCall4 = null ;
      NeighborCallAnnotation neighborCall7 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation13 = null ;
      OneToManyAssociationAnnotation oneToManyAssociation20 = null ;
      OneToManyAssociationAnnotation oneToManyAssociation6 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass colleague = null ;
      de.uni_paderborn.fujaba.uml.UMLClass mediator = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod1 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod10 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod12 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod15 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod16 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod17 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod19 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod2 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod3 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod5 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod8 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod9 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("colleague", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
             
            // bind uMLMethod1: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod1 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod1.hasNext () )
            {
               try
               {
                  uMLMethod1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod1.next () ;
                   
                  // bind uMLMethod3: UMLMethod
                  fujaba__IterColleagueMethodsUMLMethod3 = colleague.iteratorOfMethods () ;
                  while ( fujaba__IterColleagueMethodsUMLMethod3.hasNext () )
                  {
                     try
                     {
                        uMLMethod3 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod3.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod3)) ) ;
                         
                        // bind oneToManyAssociation6: OneToManyAssociationAnnotation
                        fujaba__IterColleagueAnnotationsOneToManyAssociation6 = colleague.iteratorOfAnnotations () ;
                        while ( fujaba__IterColleagueAnnotationsOneToManyAssociation6.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterColleagueAnnotationsOneToManyAssociation6.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                              oneToManyAssociation6 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between oneToManyAssociation6 and colleague
                              JavaSDM.ensure ( oneToManyAssociation6.hasInElements ("many", colleague) ) ;
                               
                              // bind neighborCall7: NeighborCallAnnotation
                              fujaba__IterUMLMethod1AnnotationsNeighborCall7 = uMLMethod1.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod1AnnotationsNeighborCall7.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod1AnnotationsNeighborCall7.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall7 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall7 and uMLMethod1
                                    JavaSDM.ensure ( neighborCall7.hasInElements ("caller", uMLMethod1) ) ;
                                     
                                    // bind neighborCall4: NeighborCallAnnotation
                                    fujaba__IterUMLMethod3AnnotationsNeighborCall4 = uMLMethod3.iteratorOfAnnotations () ;
                                    while ( fujaba__IterUMLMethod3AnnotationsNeighborCall4.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLMethod3AnnotationsNeighborCall4.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall4 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall4 and uMLMethod3
                                          JavaSDM.ensure ( neighborCall4.hasInElements ("callee", uMLMethod3) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(neighborCall7.equals (neighborCall4)) ) ;
                                           
                                          // bind mediator: UMLClass
                                          fujaba__IterOneToManyAssociation6ElementsMediator = oneToManyAssociation6.iteratorOfElements ("one") ;
                                          while ( fujaba__IterOneToManyAssociation6ElementsMediator.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterOneToManyAssociation6ElementsMediator.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                                                 
                                                // bind uMLMethod2: UMLMethod
                                                fujaba__IterNeighborCall7ElementsUMLMethod2 = neighborCall7.iteratorOfElements ("callee") ;
                                                while ( fujaba__IterNeighborCall7ElementsUMLMethod2.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall7ElementsUMLMethod2.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod2)) && !(uMLMethod3.equals (uMLMethod2)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between uMLMethod2 and mediator
                                                      JavaSDM.ensure ( (uMLMethod2.getParent () != null) && uMLMethod2.getParent ().equals (mediator) ) ;
                                                       
                                                      // bind uMLMethod5: UMLMethod
                                                      fujaba__IterNeighborCall4ElementsUMLMethod5 = neighborCall4.iteratorOfElements ("caller") ;
                                                      while ( fujaba__IterNeighborCall4ElementsUMLMethod5.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterNeighborCall4ElementsUMLMethod5.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                            uMLMethod5 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod5)) && !(uMLMethod2.equals (uMLMethod5)) && !(uMLMethod3.equals (uMLMethod5)) ) ;
                                                             
                                                            // check To-One-Link 'parent' between uMLMethod5 and mediator
                                                            JavaSDM.ensure ( (uMLMethod5.getParent () != null) && uMLMethod5.getParent ().equals (mediator) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object mediator is really bound
                                                                  JavaSDM.ensure ( mediator != null ) ;
                                                                   
                                                                  // check object colleague is really bound
                                                                  JavaSDM.ensure ( colleague != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                   
                                                                  // bind broadcastMediator: BroadcastMediatorAnnotation
                                                                  fujaba__IterMediatorAnnotationsBroadcastMediator = mediator.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterMediatorAnnotationsBroadcastMediator.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterMediatorAnnotationsBroadcastMediator.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof BroadcastMediatorAnnotation ) ;
                                                                        broadcastMediator = (BroadcastMediatorAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between broadcastMediator and mediator
                                                                        JavaSDM.ensure ( broadcastMediator.hasInElements ("mediator", mediator) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between broadcastMediator and colleague
                                                                        JavaSDM.ensure ( broadcastMediator.hasInElements ("colleague", colleague) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object mediator is really bound
                                                                     JavaSDM.ensure ( mediator != null ) ;
                                                                      
                                                                     // check object colleague is really bound
                                                                     JavaSDM.ensure ( colleague != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                      
                                                                     // create object
                                                                     broadcastMediator = new BroadcastMediatorAnnotation ( ) ;
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToElements ("mediator", mediator);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToElements ("colleague", colleague);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToBoundObjects ("colleague", colleague);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToBoundObjects ("mediator", mediator);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object neighborCall4 is really bound
                                                                     JavaSDM.ensure ( neighborCall4 != null ) ;
                                                                      
                                                                     // check object oneToManyAssociation6 is really bound
                                                                     JavaSDM.ensure ( oneToManyAssociation6 != null ) ;
                                                                      
                                                                     // check object neighborCall7 is really bound
                                                                     JavaSDM.ensure ( neighborCall7 != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(neighborCall4.equals (neighborCall7)) ) ;
                                                                      
                                                                     // check object broadcastMediator is really bound
                                                                     JavaSDM.ensure ( broadcastMediator != null ) ;
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToAntecedentAnnos (neighborCall4);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToAntecedentAnnos (oneToManyAssociation6);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToAntecedentAnnos (neighborCall7);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (broadcastMediator) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object broadcastMediator is really bound
            JavaSDM.ensure ( broadcastMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("colleague", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("mediator", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod9: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod9 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod9.hasNext () )
            {
               try
               {
                  uMLMethod9 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod9.next () ;
                   
                  // bind uMLMethod12: UMLMethod
                  fujaba__IterMediatorMethodsUMLMethod12 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsUMLMethod12.hasNext () )
                  {
                     try
                     {
                        uMLMethod12 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod12.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod9.equals (uMLMethod12)) ) ;
                         
                        // bind oneToManyAssociation13: OneToManyAssociationAnnotation
                        fujaba__IterMediatorAnnotationsOneToManyAssociation13 = mediator.iteratorOfAnnotations () ;
                        while ( fujaba__IterMediatorAnnotationsOneToManyAssociation13.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMediatorAnnotationsOneToManyAssociation13.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                              oneToManyAssociation13 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between oneToManyAssociation13 and mediator
                              JavaSDM.ensure ( oneToManyAssociation13.hasInElements ("one", mediator) ) ;
                               
                              // bind neighborCall14: NeighborCallAnnotation
                              fujaba__IterUMLMethod9AnnotationsNeighborCall14 = uMLMethod9.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod9AnnotationsNeighborCall14.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod9AnnotationsNeighborCall14.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall14 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall14 and uMLMethod9
                                    JavaSDM.ensure ( neighborCall14.hasInElements ("callee", uMLMethod9) ) ;
                                     
                                    // bind neighborCall11: NeighborCallAnnotation
                                    fujaba__IterUMLMethod12AnnotationsNeighborCall11 = uMLMethod12.iteratorOfAnnotations () ;
                                    while ( fujaba__IterUMLMethod12AnnotationsNeighborCall11.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLMethod12AnnotationsNeighborCall11.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall11 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall11 and uMLMethod12
                                          JavaSDM.ensure ( neighborCall11.hasInElements ("caller", uMLMethod12) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(neighborCall14.equals (neighborCall11)) ) ;
                                           
                                          // bind colleague: UMLClass
                                          fujaba__IterOneToManyAssociation13ElementsColleague = oneToManyAssociation13.iteratorOfElements ("many") ;
                                          while ( fujaba__IterOneToManyAssociation13ElementsColleague.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterOneToManyAssociation13ElementsColleague.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                 
                                                // bind uMLMethod8: UMLMethod
                                                fujaba__IterNeighborCall14ElementsUMLMethod8 = neighborCall14.iteratorOfElements ("caller") ;
                                                while ( fujaba__IterNeighborCall14ElementsUMLMethod8.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall14ElementsUMLMethod8.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod8 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod9.equals (uMLMethod8)) && !(uMLMethod12.equals (uMLMethod8)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between uMLMethod8 and colleague
                                                      JavaSDM.ensure ( (uMLMethod8.getParent () != null) && uMLMethod8.getParent ().equals (colleague) ) ;
                                                       
                                                      // bind uMLMethod10: UMLMethod
                                                      fujaba__IterNeighborCall11ElementsUMLMethod10 = neighborCall11.iteratorOfElements ("callee") ;
                                                      while ( fujaba__IterNeighborCall11ElementsUMLMethod10.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterNeighborCall11ElementsUMLMethod10.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                            uMLMethod10 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(uMLMethod8.equals (uMLMethod10)) && !(uMLMethod9.equals (uMLMethod10)) && !(uMLMethod12.equals (uMLMethod10)) ) ;
                                                             
                                                            // check To-One-Link 'parent' between uMLMethod10 and colleague
                                                            JavaSDM.ensure ( (uMLMethod10.getParent () != null) && uMLMethod10.getParent ().equals (colleague) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object mediator is really bound
                                                                  JavaSDM.ensure ( mediator != null ) ;
                                                                   
                                                                  // check object colleague is really bound
                                                                  JavaSDM.ensure ( colleague != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                   
                                                                  // bind broadcastMediator: BroadcastMediatorAnnotation
                                                                  fujaba__IterColleagueAnnotationsBroadcastMediator = colleague.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterColleagueAnnotationsBroadcastMediator.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterColleagueAnnotationsBroadcastMediator.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof BroadcastMediatorAnnotation ) ;
                                                                        broadcastMediator = (BroadcastMediatorAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between broadcastMediator and colleague
                                                                        JavaSDM.ensure ( broadcastMediator.hasInElements ("colleague", colleague) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between broadcastMediator and mediator
                                                                        JavaSDM.ensure ( broadcastMediator.hasInElements ("mediator", mediator) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object mediator is really bound
                                                                     JavaSDM.ensure ( mediator != null ) ;
                                                                      
                                                                     // check object colleague is really bound
                                                                     JavaSDM.ensure ( colleague != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                      
                                                                     // create object
                                                                     broadcastMediator = new BroadcastMediatorAnnotation ( ) ;
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToElements ("mediator", mediator);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToElements ("colleague", colleague);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToBoundObjects ("colleague", colleague);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToBoundObjects ("mediator", mediator);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object neighborCall11 is really bound
                                                                     JavaSDM.ensure ( neighborCall11 != null ) ;
                                                                      
                                                                     // check object oneToManyAssociation13 is really bound
                                                                     JavaSDM.ensure ( oneToManyAssociation13 != null ) ;
                                                                      
                                                                     // check object neighborCall14 is really bound
                                                                     JavaSDM.ensure ( neighborCall14 != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(neighborCall11.equals (neighborCall14)) ) ;
                                                                      
                                                                     // check object broadcastMediator is really bound
                                                                     JavaSDM.ensure ( broadcastMediator != null ) ;
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToAntecedentAnnos (neighborCall11);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToAntecedentAnnos (oneToManyAssociation13);
                                                                      
                                                                     // create link
                                                                     broadcastMediator.addToAntecedentAnnos (neighborCall14);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (broadcastMediator) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object broadcastMediator is really bound
            JavaSDM.ensure ( broadcastMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("mediator", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall21 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod15: UMLMethod
            fujaba__IterNeighborCall21ElementsUMLMethod15 = neighborCall21.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall21ElementsUMLMethod15.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall21ElementsUMLMethod15.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod15 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  colleague = uMLMethod15.getParent () ;
                  JavaSDM.ensure ( colleague != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  // bind uMLMethod16: UMLMethod
                  fujaba__IterNeighborCall21ElementsUMLMethod16 = neighborCall21.iteratorOfElements ("callee") ;
                  while ( fujaba__IterNeighborCall21ElementsUMLMethod16.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall21ElementsUMLMethod16.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod16 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod15.equals (uMLMethod16)) ) ;
                         
                        // bind mediator: UMLClass
                        mediator = uMLMethod16.getParent () ;
                        JavaSDM.ensure ( mediator != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                         
                        // bind uMLMethod17: UMLMethod
                        fujaba__IterColleagueMethodsUMLMethod17 = colleague.iteratorOfMethods () ;
                        while ( fujaba__IterColleagueMethodsUMLMethod17.hasNext () )
                        {
                           try
                           {
                              uMLMethod17 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod17.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod15.equals (uMLMethod17)) && !(uMLMethod16.equals (uMLMethod17)) ) ;
                               
                              // bind oneToManyAssociation20: OneToManyAssociationAnnotation
                              fujaba__IterColleagueAnnotationsOneToManyAssociation20 = colleague.iteratorOfAnnotations () ;
                              while ( fujaba__IterColleagueAnnotationsOneToManyAssociation20.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterColleagueAnnotationsOneToManyAssociation20.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                                    oneToManyAssociation20 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between oneToManyAssociation20 and colleague
                                    JavaSDM.ensure ( oneToManyAssociation20.hasInElements ("many", colleague) ) ;
                                     
                                    // check To-Many-Link 'elements' between oneToManyAssociation20 and mediator
                                    JavaSDM.ensure ( oneToManyAssociation20.hasInElements ("one", mediator) ) ;
                                     
                                    // bind uMLMethod19: UMLMethod
                                    fujaba__IterMediatorMethodsUMLMethod19 = mediator.iteratorOfMethods () ;
                                    while ( fujaba__IterMediatorMethodsUMLMethod19.hasNext () )
                                    {
                                       try
                                       {
                                          uMLMethod19 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod19.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod15.equals (uMLMethod19)) && !(uMLMethod16.equals (uMLMethod19)) && !(uMLMethod17.equals (uMLMethod19)) ) ;
                                           
                                          // bind neighborCall18: NeighborCallAnnotation
                                          fujaba__IterUMLMethod17AnnotationsNeighborCall18 = uMLMethod17.iteratorOfAnnotations () ;
                                          while ( fujaba__IterUMLMethod17AnnotationsNeighborCall18.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLMethod17AnnotationsNeighborCall18.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall18 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall18 and uMLMethod17
                                                JavaSDM.ensure ( neighborCall18.hasInElements ("callee", uMLMethod17) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(neighborCall21.equals (neighborCall18)) ) ;
                                                 
                                                // check To-Many-Link 'elements' between neighborCall18 and uMLMethod19
                                                JavaSDM.ensure ( neighborCall18.hasInElements ("caller", uMLMethod19) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object mediator is really bound
                                                      JavaSDM.ensure ( mediator != null ) ;
                                                       
                                                      // check object colleague is really bound
                                                      JavaSDM.ensure ( colleague != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                       
                                                      // bind broadcastMediator: BroadcastMediatorAnnotation
                                                      fujaba__IterMediatorAnnotationsBroadcastMediator = mediator.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterMediatorAnnotationsBroadcastMediator.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterMediatorAnnotationsBroadcastMediator.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof BroadcastMediatorAnnotation ) ;
                                                            broadcastMediator = (BroadcastMediatorAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between broadcastMediator and mediator
                                                            JavaSDM.ensure ( broadcastMediator.hasInElements ("mediator", mediator) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between broadcastMediator and colleague
                                                            JavaSDM.ensure ( broadcastMediator.hasInElements ("colleague", colleague) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object mediator is really bound
                                                         JavaSDM.ensure ( mediator != null ) ;
                                                          
                                                         // check object colleague is really bound
                                                         JavaSDM.ensure ( colleague != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                          
                                                         // create object
                                                         broadcastMediator = new BroadcastMediatorAnnotation ( ) ;
                                                          
                                                         // create link
                                                         broadcastMediator.addToElements ("mediator", mediator);
                                                          
                                                         // create link
                                                         broadcastMediator.addToElements ("colleague", colleague);
                                                          
                                                         // create link
                                                         broadcastMediator.addToBoundObjects ("colleague", colleague);
                                                          
                                                         // create link
                                                         broadcastMediator.addToBoundObjects ("mediator", mediator);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object neighborCall18 is really bound
                                                         JavaSDM.ensure ( neighborCall18 != null ) ;
                                                          
                                                         // check object oneToManyAssociation20 is really bound
                                                         JavaSDM.ensure ( oneToManyAssociation20 != null ) ;
                                                          
                                                         // check object neighborCall21 is really bound
                                                         JavaSDM.ensure ( neighborCall21 != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(neighborCall18.equals (neighborCall21)) ) ;
                                                          
                                                         // check object broadcastMediator is really bound
                                                         JavaSDM.ensure ( broadcastMediator != null ) ;
                                                          
                                                         // create link
                                                         broadcastMediator.addToAntecedentAnnos (neighborCall18);
                                                          
                                                         // create link
                                                         broadcastMediator.addToAntecedentAnnos (oneToManyAssociation20);
                                                          
                                                         // create link
                                                         broadcastMediator.addToAntecedentAnnos (neighborCall21);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (broadcastMediator) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object broadcastMediator is really bound
            JavaSDM.ensure ( broadcastMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (broadcastMediator) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("mediator", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("colleague", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OneToManyAssociationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterColleagueMethodsUMLMethod25 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod26 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod31 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod34 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod22 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod29 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod33 = null ;
      Iterator fujaba__IterNeighborCall23ElementsUMLMethod24 = null ;
      Iterator fujaba__IterNeighborCall27ElementsUMLMethod28 = null ;
      Iterator fujaba__IterNeighborCall27ElementsUMLMethod30 = null ;
      Iterator fujaba__IterNeighborCall27ElementsUMLMethod32 = null ;
      Iterator fujaba__IterUMLMethod22AnnotationsNeighborCall23 = null ;
      Iterator fujaba__IterUMLMethod26AnnotationsNeighborCall27 = null ;
      NeighborCallAnnotation neighborCall23 = null ;
      NeighborCallAnnotation neighborCall27 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass colleague = null ;
      de.uni_paderborn.fujaba.uml.UMLClass mediator = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod22 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod24 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod25 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod26 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod28 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod29 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod30 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod31 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod32 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod33 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod34 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod22: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod22 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod22.hasNext () )
            {
               try
               {
                  uMLMethod22 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod22.next () ;
                   
                  // bind neighborCall23: NeighborCallAnnotation
                  fujaba__IterUMLMethod22AnnotationsNeighborCall23 = uMLMethod22.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod22AnnotationsNeighborCall23.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod22AnnotationsNeighborCall23.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall23 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall23 and uMLMethod22
                        JavaSDM.ensure ( neighborCall23.hasInElements ("callee", uMLMethod22) ) ;
                         
                        // bind uMLMethod24: UMLMethod
                        fujaba__IterNeighborCall23ElementsUMLMethod24 = neighborCall23.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall23ElementsUMLMethod24.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall23ElementsUMLMethod24.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod24 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod22.equals (uMLMethod24)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod24.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              // bind uMLMethod25: UMLMethod
                              fujaba__IterColleagueMethodsUMLMethod25 = colleague.iteratorOfMethods () ;
                              while ( fujaba__IterColleagueMethodsUMLMethod25.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod25 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod25.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod22.equals (uMLMethod25)) && !(uMLMethod24.equals (uMLMethod25)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (uMLMethod25);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod26: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod26 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod26.hasNext () )
            {
               try
               {
                  uMLMethod26 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod26.next () ;
                   
                  // bind neighborCall27: NeighborCallAnnotation
                  fujaba__IterUMLMethod26AnnotationsNeighborCall27 = uMLMethod26.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod26AnnotationsNeighborCall27.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod26AnnotationsNeighborCall27.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall27 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall27 and uMLMethod26
                        JavaSDM.ensure ( neighborCall27.hasInElements ("caller", uMLMethod26) ) ;
                         
                        // bind uMLMethod28: UMLMethod
                        fujaba__IterNeighborCall27ElementsUMLMethod28 = neighborCall27.iteratorOfElements ("callee") ;
                        while ( fujaba__IterNeighborCall27ElementsUMLMethod28.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall27ElementsUMLMethod28.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod28 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod26.equals (uMLMethod28)) ) ;
                               
                              // bind mediator: UMLClass
                              mediator = uMLMethod28.getParent () ;
                              JavaSDM.ensure ( mediator != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                               
                              // bind uMLMethod29: UMLMethod
                              fujaba__IterMediatorMethodsUMLMethod29 = mediator.iteratorOfMethods () ;
                              while ( fujaba__IterMediatorMethodsUMLMethod29.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod29 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod29.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod26.equals (uMLMethod29)) && !(uMLMethod28.equals (uMLMethod29)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (uMLMethod29);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall27 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod30: UMLMethod
            fujaba__IterNeighborCall27ElementsUMLMethod30 = neighborCall27.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall27ElementsUMLMethod30.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall27ElementsUMLMethod30.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod30 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  colleague = uMLMethod30.getParent () ;
                  JavaSDM.ensure ( colleague != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  // bind uMLMethod31: UMLMethod
                  fujaba__IterColleagueMethodsUMLMethod31 = colleague.iteratorOfMethods () ;
                  while ( fujaba__IterColleagueMethodsUMLMethod31.hasNext () )
                  {
                     try
                     {
                        uMLMethod31 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod31.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod30.equals (uMLMethod31)) ) ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod31);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OneToManyAssociation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (mediator);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (colleague);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall27 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod32: UMLMethod
            fujaba__IterNeighborCall27ElementsUMLMethod32 = neighborCall27.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall27ElementsUMLMethod32.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall27ElementsUMLMethod32.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod32 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  colleague = uMLMethod32.getParent () ;
                  JavaSDM.ensure ( colleague != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (colleague);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod33: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod33 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod33.hasNext () )
            {
               try
               {
                  uMLMethod33 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod33.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod33);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod34: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod34 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod34.hasNext () )
            {
               try
               {
                  uMLMethod34 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod34.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod34);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
