package de.upb.inferenceengine.engines;

import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.upb.javaast.methodast.MethodCallNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;

public class DelegationEngine
extends GFRNEngine
{
   private  DelegationEngine()
   {
   }

   private static DelegationEngine theDelegationEngine;

   public static DelegationEngine get()
   {
      if (theDelegationEngine == null)
      {
         theDelegationEngine = new DelegationEngine ();
      }
      return theDelegationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode12 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode15 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode3 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode6 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode9 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      DelegationAnnotation delegation = null ;
      Iterator fujaba__IterCalleeClassAnnotationsDelegation = null ;
      Iterator fujaba__IterCalleeClassAnnotationsReference10 = null ;
      Iterator fujaba__IterCalleeClassAnnotationsReference7 = null ;
      Iterator fujaba__IterCalleeClassMethodsCallee = null ;
      Iterator fujaba__IterCallerClassAnnotationsDelegation = null ;
      Iterator fujaba__IterCallerClassAttrsRefField = null ;
      Iterator fujaba__IterCallerClassMethodsCaller = null ;
      Iterator fujaba__IterRefFieldAnnotationsReference13 = null ;
      Iterator fujaba__IterRefFieldAnnotationsReference4 = null ;
      Iterator fujaba__IterReference10ElementsRefField = null ;
      Iterator fujaba__IterReference13ElementsCalleeClass = null ;
      Iterator fujaba__IterReference1ElementsCalleeClass = null ;
      Iterator fujaba__IterReference1ElementsRefField = null ;
      Iterator fujaba__IterReference4ElementsCalleeClass = null ;
      Iterator fujaba__IterReference7ElementsRefField = null ;
      de.upb.javaast.methodast.IdentifierNode id1 = null ;
      de.upb.javaast.methodast.IdentifierNode id2 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode11 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode14 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode2 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode5 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode12 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode15 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode3 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode6 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode9 = null ;
      ReferenceAnnotation reference1 = null ;
      ReferenceAnnotation reference10 = null ;
      ReferenceAnnotation reference13 = null ;
      ReferenceAnnotation reference4 = null ;
      ReferenceAnnotation reference7 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass calleeClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass callerClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference1 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind calleeClass: UMLClass
            fujaba__IterReference1ElementsCalleeClass = reference1.iteratorOfElements ("references") ;
            while ( fujaba__IterReference1ElementsCalleeClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference1ElementsCalleeClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind refField: UMLAttr
                  fujaba__IterReference1ElementsRefField = reference1.iteratorOfElements ("field") ;
                  while ( fujaba__IterReference1ElementsRefField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference1ElementsRefField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind callerClass: UMLClass
                        callerClass = refField.getParent () ;
                        JavaSDM.ensure ( callerClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(calleeClass.equals (callerClass)) ) ;
                         
                        // bind callee: UMLMethod
                        fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                        while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                        {
                           try
                           {
                              callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                               
                              // bind caller: UMLMethod
                              fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                              while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                              {
                                 try
                                 {
                                    caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                     
                                    // bind root: ASTRootNode
                                    root = caller.getASTRootNode () ;
                                    JavaSDM.ensure ( root != null ) ;
                                     
                                    // Path search between ASTRootNode and PrimaryExpressionNode
                                    // Bind primaryExpressionNode3 : PrimaryExpressionNode
                                    fujaba__IterRootToPrimaryExpressionNode3 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                                    while ( fujaba__IterRootToPrimaryExpressionNode3.hasNext () )
                                    {
                                       try
                                       {
                                          primaryExpressionNode3 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode3.next () ;
                                           
                                          // bind methodCallNode2: MethodCallNode
                                          fujaba__TmpObject = primaryExpressionNode3.getNextPrimaryExpression () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                          methodCallNode2 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(primaryExpressionNode3.equals (methodCallNode2)) ) ;
                                           
                                          // bind id1: IdentifierNode
                                          id1 = primaryExpressionNode3.getIdentifier () ;
                                          JavaSDM.ensure ( id1 != null ) ;
                                           
                                          // bind id2: IdentifierNode
                                          id2 = methodCallNode2.getIdentifier () ;
                                          JavaSDM.ensure ( id2 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id1.getName().equals(refField.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( caller.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // bind delegation: DelegationAnnotation
                                                fujaba__IterCallerClassAnnotationsDelegation = callerClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterCallerClassAnnotationsDelegation.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterCallerClassAnnotationsDelegation.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                      delegation = (DelegationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between delegation and callerClass
                                                      JavaSDM.ensure ( delegation.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and caller
                                                      JavaSDM.ensure ( delegation.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and callee
                                                      JavaSDM.ensure ( delegation.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and calleeClass
                                                      JavaSDM.ensure ( delegation.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id2 is really bound
                                                   JavaSDM.ensure ( id2 != null ) ;
                                                    
                                                   // check object id1 is really bound
                                                   JavaSDM.ensure ( id1 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(id2.equals (id1)) ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // check object refField is really bound
                                                   JavaSDM.ensure ( refField != null ) ;
                                                    
                                                   // create object
                                                   delegation = new DelegationAnnotation ( ) ;
                                                    
                                                   // create link
                                                   delegation.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   delegation.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   delegation.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   delegation.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("id2", id2);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("id1", id1);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("refField", refField);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference1 is really bound
                                                   JavaSDM.ensure ( reference1 != null ) ;
                                                    
                                                   // check object delegation is really bound
                                                   JavaSDM.ensure ( delegation != null ) ;
                                                    
                                                   // create link
                                                   delegation.addToAntecedentAnnos (reference1);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (delegation) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object delegation is really bound
            JavaSDM.ensure ( delegation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("caller", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = caller.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind callerClass: UMLClass
            callerClass = caller.getParent () ;
            JavaSDM.ensure ( callerClass != null ) ;
             
            // bind refField: UMLAttr
            fujaba__IterCallerClassAttrsRefField = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsRefField.next () ;
                   
                  // bind reference4: ReferenceAnnotation
                  fujaba__IterRefFieldAnnotationsReference4 = refField.iteratorOfAnnotations () ;
                  while ( fujaba__IterRefFieldAnnotationsReference4.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterRefFieldAnnotationsReference4.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference4 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference4 and refField
                        JavaSDM.ensure ( reference4.hasInElements ("field", refField) ) ;
                         
                        // bind calleeClass: UMLClass
                        fujaba__IterReference4ElementsCalleeClass = reference4.iteratorOfElements ("references") ;
                        while ( fujaba__IterReference4ElementsCalleeClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReference4ElementsCalleeClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                               
                              // bind callee: UMLMethod
                              fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                              while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                              {
                                 try
                                 {
                                    callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                     
                                    // Path search between ASTRootNode and PrimaryExpressionNode
                                    // Bind primaryExpressionNode6 : PrimaryExpressionNode
                                    fujaba__IterRootToPrimaryExpressionNode6 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                                    while ( fujaba__IterRootToPrimaryExpressionNode6.hasNext () )
                                    {
                                       try
                                       {
                                          primaryExpressionNode6 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode6.next () ;
                                           
                                          // bind methodCallNode5: MethodCallNode
                                          fujaba__TmpObject = primaryExpressionNode6.getNextPrimaryExpression () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                          methodCallNode5 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(primaryExpressionNode6.equals (methodCallNode5)) ) ;
                                           
                                          // bind id1: IdentifierNode
                                          id1 = primaryExpressionNode6.getIdentifier () ;
                                          JavaSDM.ensure ( id1 != null ) ;
                                           
                                          // bind id2: IdentifierNode
                                          id2 = methodCallNode5.getIdentifier () ;
                                          JavaSDM.ensure ( id2 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id1.getName().equals(refField.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( caller.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // bind delegation: DelegationAnnotation
                                                fujaba__IterCalleeClassAnnotationsDelegation = calleeClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterCalleeClassAnnotationsDelegation.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsDelegation.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                      delegation = (DelegationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between delegation and calleeClass
                                                      JavaSDM.ensure ( delegation.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and caller
                                                      JavaSDM.ensure ( delegation.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and callee
                                                      JavaSDM.ensure ( delegation.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and callerClass
                                                      JavaSDM.ensure ( delegation.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id2 is really bound
                                                   JavaSDM.ensure ( id2 != null ) ;
                                                    
                                                   // check object id1 is really bound
                                                   JavaSDM.ensure ( id1 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(id2.equals (id1)) ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // check object refField is really bound
                                                   JavaSDM.ensure ( refField != null ) ;
                                                    
                                                   // create object
                                                   delegation = new DelegationAnnotation ( ) ;
                                                    
                                                   // create link
                                                   delegation.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   delegation.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   delegation.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   delegation.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("id2", id2);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("id1", id1);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("refField", refField);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference4 is really bound
                                                   JavaSDM.ensure ( reference4 != null ) ;
                                                    
                                                   // check object delegation is really bound
                                                   JavaSDM.ensure ( delegation != null ) ;
                                                    
                                                   // create link
                                                   delegation.addToAntecedentAnnos (reference4);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (delegation) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object delegation is really bound
            JavaSDM.ensure ( delegation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("caller", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("callee", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind calleeClass: UMLClass
            calleeClass = callee.getParent () ;
            JavaSDM.ensure ( calleeClass != null ) ;
             
            // bind reference7: ReferenceAnnotation
            fujaba__IterCalleeClassAnnotationsReference7 = calleeClass.iteratorOfAnnotations () ;
            while ( fujaba__IterCalleeClassAnnotationsReference7.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsReference7.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                  reference7 = (ReferenceAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between reference7 and calleeClass
                  JavaSDM.ensure ( reference7.hasInElements ("references", calleeClass) ) ;
                   
                  // bind refField: UMLAttr
                  fujaba__IterReference7ElementsRefField = reference7.iteratorOfElements ("field") ;
                  while ( fujaba__IterReference7ElementsRefField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference7ElementsRefField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind callerClass: UMLClass
                        callerClass = refField.getParent () ;
                        JavaSDM.ensure ( callerClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(calleeClass.equals (callerClass)) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                        while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                        {
                           try
                           {
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                               
                              // bind root: ASTRootNode
                              root = caller.getASTRootNode () ;
                              JavaSDM.ensure ( root != null ) ;
                               
                              // Path search between ASTRootNode and PrimaryExpressionNode
                              // Bind primaryExpressionNode9 : PrimaryExpressionNode
                              fujaba__IterRootToPrimaryExpressionNode9 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                              while ( fujaba__IterRootToPrimaryExpressionNode9.hasNext () )
                              {
                                 try
                                 {
                                    primaryExpressionNode9 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode9.next () ;
                                     
                                    // bind methodCallNode8: MethodCallNode
                                    fujaba__TmpObject = primaryExpressionNode9.getNextPrimaryExpression () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                    methodCallNode8 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(primaryExpressionNode9.equals (methodCallNode8)) ) ;
                                     
                                    // bind id1: IdentifierNode
                                    id1 = primaryExpressionNode9.getIdentifier () ;
                                    JavaSDM.ensure ( id1 != null ) ;
                                     
                                    // bind id2: IdentifierNode
                                    id2 = methodCallNode8.getIdentifier () ;
                                    JavaSDM.ensure ( id2 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( id1.getName().equals(refField.getName()) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( caller.getName().equals(callee.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object caller is really bound
                                          JavaSDM.ensure ( caller != null ) ;
                                           
                                          // check object callee is really bound
                                          JavaSDM.ensure ( callee != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // check object callerClass is really bound
                                          JavaSDM.ensure ( callerClass != null ) ;
                                           
                                          // check object calleeClass is really bound
                                          JavaSDM.ensure ( calleeClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                           
                                          // bind delegation: DelegationAnnotation
                                          fujaba__IterCallerClassAnnotationsDelegation = callerClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterCallerClassAnnotationsDelegation.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCallerClassAnnotationsDelegation.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                delegation = (DelegationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between delegation and callerClass
                                                JavaSDM.ensure ( delegation.hasInElements ("callerClass", callerClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between delegation and caller
                                                JavaSDM.ensure ( delegation.hasInElements ("caller", caller) ) ;
                                                 
                                                // check To-Many-Link 'elements' between delegation and callee
                                                JavaSDM.ensure ( delegation.hasInElements ("callee", callee) ) ;
                                                 
                                                // check To-Many-Link 'elements' between delegation and calleeClass
                                                JavaSDM.ensure ( delegation.hasInElements ("calleeClass", calleeClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object caller is really bound
                                             JavaSDM.ensure ( caller != null ) ;
                                              
                                             // check object callee is really bound
                                             JavaSDM.ensure ( callee != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                              
                                             // check object callerClass is really bound
                                             JavaSDM.ensure ( callerClass != null ) ;
                                              
                                             // check object calleeClass is really bound
                                             JavaSDM.ensure ( calleeClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                              
                                             // check object id2 is really bound
                                             JavaSDM.ensure ( id2 != null ) ;
                                              
                                             // check object id1 is really bound
                                             JavaSDM.ensure ( id1 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (id1)) ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // check object refField is really bound
                                             JavaSDM.ensure ( refField != null ) ;
                                              
                                             // create object
                                             delegation = new DelegationAnnotation ( ) ;
                                              
                                             // create link
                                             delegation.addToElements ("caller", caller);
                                              
                                             // create link
                                             delegation.addToElements ("callee", callee);
                                              
                                             // create link
                                             delegation.addToElements ("callerClass", callerClass);
                                              
                                             // create link
                                             delegation.addToElements ("calleeClass", calleeClass);
                                              
                                             // create link
                                             delegation.addToBoundObjects ("caller", caller);
                                              
                                             // create link
                                             delegation.addToBoundObjects ("id2", id2);
                                              
                                             // create link
                                             delegation.addToBoundObjects ("id1", id1);
                                              
                                             // create link
                                             delegation.addToBoundObjects ("root", root);
                                              
                                             // create link
                                             delegation.addToBoundObjects ("callee", callee);
                                              
                                             // create link
                                             delegation.addToBoundObjects ("calleeClass", calleeClass);
                                              
                                             // create link
                                             delegation.addToBoundObjects ("callerClass", callerClass);
                                              
                                             // create link
                                             delegation.addToBoundObjects ("refField", refField);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object reference7 is really bound
                                             JavaSDM.ensure ( reference7 != null ) ;
                                              
                                             // check object delegation is really bound
                                             JavaSDM.ensure ( delegation != null ) ;
                                              
                                             // create link
                                             delegation.addToAntecedentAnnos (reference7);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (delegation) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object delegation is really bound
            JavaSDM.ensure ( delegation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("callee", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("calleeClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
            while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                   
                  // bind reference10: ReferenceAnnotation
                  fujaba__IterCalleeClassAnnotationsReference10 = calleeClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterCalleeClassAnnotationsReference10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsReference10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference10 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference10 and calleeClass
                        JavaSDM.ensure ( reference10.hasInElements ("references", calleeClass) ) ;
                         
                        // bind refField: UMLAttr
                        fujaba__IterReference10ElementsRefField = reference10.iteratorOfElements ("field") ;
                        while ( fujaba__IterReference10ElementsRefField.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReference10ElementsRefField.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              // bind callerClass: UMLClass
                              callerClass = refField.getParent () ;
                              JavaSDM.ensure ( callerClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(calleeClass.equals (callerClass)) ) ;
                               
                              // bind caller: UMLMethod
                              fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                              while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                              {
                                 try
                                 {
                                    caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                     
                                    // bind root: ASTRootNode
                                    root = caller.getASTRootNode () ;
                                    JavaSDM.ensure ( root != null ) ;
                                     
                                    // Path search between ASTRootNode and PrimaryExpressionNode
                                    // Bind primaryExpressionNode12 : PrimaryExpressionNode
                                    fujaba__IterRootToPrimaryExpressionNode12 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                                    while ( fujaba__IterRootToPrimaryExpressionNode12.hasNext () )
                                    {
                                       try
                                       {
                                          primaryExpressionNode12 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode12.next () ;
                                           
                                          // bind methodCallNode11: MethodCallNode
                                          fujaba__TmpObject = primaryExpressionNode12.getNextPrimaryExpression () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                          methodCallNode11 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(primaryExpressionNode12.equals (methodCallNode11)) ) ;
                                           
                                          // bind id1: IdentifierNode
                                          id1 = primaryExpressionNode12.getIdentifier () ;
                                          JavaSDM.ensure ( id1 != null ) ;
                                           
                                          // bind id2: IdentifierNode
                                          id2 = methodCallNode11.getIdentifier () ;
                                          JavaSDM.ensure ( id2 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id1.getName().equals(refField.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( caller.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // bind delegation: DelegationAnnotation
                                                fujaba__IterCalleeClassAnnotationsDelegation = calleeClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterCalleeClassAnnotationsDelegation.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsDelegation.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                      delegation = (DelegationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between delegation and calleeClass
                                                      JavaSDM.ensure ( delegation.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and caller
                                                      JavaSDM.ensure ( delegation.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and callee
                                                      JavaSDM.ensure ( delegation.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between delegation and callerClass
                                                      JavaSDM.ensure ( delegation.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id2 is really bound
                                                   JavaSDM.ensure ( id2 != null ) ;
                                                    
                                                   // check object id1 is really bound
                                                   JavaSDM.ensure ( id1 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(id2.equals (id1)) ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // check object refField is really bound
                                                   JavaSDM.ensure ( refField != null ) ;
                                                    
                                                   // create object
                                                   delegation = new DelegationAnnotation ( ) ;
                                                    
                                                   // create link
                                                   delegation.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   delegation.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   delegation.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   delegation.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("id2", id2);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("id1", id1);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   delegation.addToBoundObjects ("refField", refField);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference10 is really bound
                                                   JavaSDM.ensure ( reference10 != null ) ;
                                                    
                                                   // check object delegation is really bound
                                                   JavaSDM.ensure ( delegation != null ) ;
                                                    
                                                   // create link
                                                   delegation.addToAntecedentAnnos (reference10);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (delegation) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object delegation is really bound
            JavaSDM.ensure ( delegation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("calleeClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("callerClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            callerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterCallerClassAttrsRefField = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsRefField.next () ;
                   
                  // bind caller: UMLMethod
                  fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                  while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                  {
                     try
                     {
                        caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                         
                        // bind root: ASTRootNode
                        root = caller.getASTRootNode () ;
                        JavaSDM.ensure ( root != null ) ;
                         
                        // bind reference13: ReferenceAnnotation
                        fujaba__IterRefFieldAnnotationsReference13 = refField.iteratorOfAnnotations () ;
                        while ( fujaba__IterRefFieldAnnotationsReference13.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterRefFieldAnnotationsReference13.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference13 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference13 and refField
                              JavaSDM.ensure ( reference13.hasInElements ("field", refField) ) ;
                               
                              // bind calleeClass: UMLClass
                              fujaba__IterReference13ElementsCalleeClass = reference13.iteratorOfElements ("references") ;
                              while ( fujaba__IterReference13ElementsCalleeClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference13ElementsCalleeClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                                    while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // Path search between ASTRootNode and PrimaryExpressionNode
                                          // Bind primaryExpressionNode15 : PrimaryExpressionNode
                                          fujaba__IterRootToPrimaryExpressionNode15 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                                          while ( fujaba__IterRootToPrimaryExpressionNode15.hasNext () )
                                          {
                                             try
                                             {
                                                primaryExpressionNode15 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode15.next () ;
                                                 
                                                // bind methodCallNode14: MethodCallNode
                                                fujaba__TmpObject = primaryExpressionNode15.getNextPrimaryExpression () ;
                                                JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                                methodCallNode14 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(primaryExpressionNode15.equals (methodCallNode14)) ) ;
                                                 
                                                // bind id1: IdentifierNode
                                                id1 = primaryExpressionNode15.getIdentifier () ;
                                                JavaSDM.ensure ( id1 != null ) ;
                                                 
                                                // bind id2: IdentifierNode
                                                id2 = methodCallNode14.getIdentifier () ;
                                                JavaSDM.ensure ( id2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id1.getName().equals(refField.getName()) ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( caller.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object caller is really bound
                                                      JavaSDM.ensure ( caller != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                       
                                                      // check object callerClass is really bound
                                                      JavaSDM.ensure ( callerClass != null ) ;
                                                       
                                                      // check object calleeClass is really bound
                                                      JavaSDM.ensure ( calleeClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                       
                                                      // bind delegation: DelegationAnnotation
                                                      fujaba__IterCallerClassAnnotationsDelegation = callerClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCallerClassAnnotationsDelegation.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCallerClassAnnotationsDelegation.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof DelegationAnnotation ) ;
                                                            delegation = (DelegationAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between delegation and callerClass
                                                            JavaSDM.ensure ( delegation.hasInElements ("callerClass", callerClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between delegation and caller
                                                            JavaSDM.ensure ( delegation.hasInElements ("caller", caller) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between delegation and callee
                                                            JavaSDM.ensure ( delegation.hasInElements ("callee", callee) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between delegation and calleeClass
                                                            JavaSDM.ensure ( delegation.hasInElements ("calleeClass", calleeClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                          
                                                         // check object callerClass is really bound
                                                         JavaSDM.ensure ( callerClass != null ) ;
                                                          
                                                         // check object calleeClass is really bound
                                                         JavaSDM.ensure ( calleeClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                          
                                                         // check object id2 is really bound
                                                         JavaSDM.ensure ( id2 != null ) ;
                                                          
                                                         // check object id1 is really bound
                                                         JavaSDM.ensure ( id1 != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(id2.equals (id1)) ) ;
                                                          
                                                         // check object root is really bound
                                                         JavaSDM.ensure ( root != null ) ;
                                                          
                                                         // check object refField is really bound
                                                         JavaSDM.ensure ( refField != null ) ;
                                                          
                                                         // create object
                                                         delegation = new DelegationAnnotation ( ) ;
                                                          
                                                         // create link
                                                         delegation.addToElements ("caller", caller);
                                                          
                                                         // create link
                                                         delegation.addToElements ("callee", callee);
                                                          
                                                         // create link
                                                         delegation.addToElements ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         delegation.addToElements ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         delegation.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         delegation.addToBoundObjects ("id2", id2);
                                                          
                                                         // create link
                                                         delegation.addToBoundObjects ("id1", id1);
                                                          
                                                         // create link
                                                         delegation.addToBoundObjects ("root", root);
                                                          
                                                         // create link
                                                         delegation.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         delegation.addToBoundObjects ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         delegation.addToBoundObjects ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         delegation.addToBoundObjects ("refField", refField);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object reference13 is really bound
                                                         JavaSDM.ensure ( reference13 != null ) ;
                                                          
                                                         // check object delegation is really bound
                                                         JavaSDM.ensure ( delegation != null ) ;
                                                          
                                                         // create link
                                                         delegation.addToAntecedentAnnos (reference13);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (delegation) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object delegation is really bound
            JavaSDM.ensure ( delegation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("callerClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (delegation) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("caller", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("callee", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("callerClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("calleeClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterCallerClassAttrsRefField = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass calleeClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass callerClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind callerClass: UMLClass
            callerClass = caller.getParent () ;
            JavaSDM.ensure ( callerClass != null ) ;
             
            // bind refField: UMLAttr
            fujaba__IterCallerClassAttrsRefField = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsRefField.next () ;
                   
                  {
                     //  for each flow
                     set.add (refField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind calleeClass: UMLClass
            calleeClass = callee.getParent () ;
            JavaSDM.ensure ( calleeClass != null ) ;
             
            {
               //  for each flow
               set.add (calleeClass);
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            callerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterCallerClassAttrsRefField = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsRefField.next () ;
                   
                  {
                     //  for each flow
                     set.add (refField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (calleeClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
