package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLParam;

public class DoubleContainerAccessEngine
extends GFRNEngine
{
   private  DoubleContainerAccessEngine()
   {
   }

   private static DoubleContainerAccessEngine theDoubleContainerAccessEngine;

   public static DoubleContainerAccessEngine get()
   {
      if (theDoubleContainerAccessEngine == null)
      {
         theDoubleContainerAccessEngine = new DoubleContainerAccessEngine ();
      }
      return theDoubleContainerAccessEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess1 = null ;
      ContainerAccessAnnotation containerAccess10 = null ;
      ContainerAccessAnnotation containerAccess13 = null ;
      ContainerAccessAnnotation containerAccess16 = null ;
      ContainerAccessAnnotation containerAccess19 = null ;
      ContainerAccessAnnotation containerAccess22 = null ;
      ContainerAccessAnnotation containerAccess25 = null ;
      ContainerAccessAnnotation containerAccess28 = null ;
      ContainerAccessAnnotation containerAccess4 = null ;
      ContainerAccessAnnotation containerAccess7 = null ;
      DoubleContainerAccessAnnotation doubleContainerAccess = null ;
      Iterator fujaba__IterContainerAccess10ElementsUMLMethod9 = null ;
      Iterator fujaba__IterContainerAccess10ElementsUMLParam11 = null ;
      Iterator fujaba__IterContainerAccess13ElementsUMLParam18 = null ;
      Iterator fujaba__IterContainerAccess16ElementsUMLAttr14 = null ;
      Iterator fujaba__IterContainerAccess16ElementsUMLParam17 = null ;
      Iterator fujaba__IterContainerAccess19ElementsUMLParam24 = null ;
      Iterator fujaba__IterContainerAccess1ElementsUMLAttr2 = null ;
      Iterator fujaba__IterContainerAccess1ElementsUMLMethod3 = null ;
      Iterator fujaba__IterContainerAccess1ElementsUMLParam6 = null ;
      Iterator fujaba__IterContainerAccess22ElementsUMLAttr20 = null ;
      Iterator fujaba__IterContainerAccess22ElementsUMLMethod21 = null ;
      Iterator fujaba__IterContainerAccess25ElementsUMLAttr26 = null ;
      Iterator fujaba__IterContainerAccess25ElementsUMLMethod27 = null ;
      Iterator fujaba__IterContainerAccess28ElementsUMLParam29 = null ;
      Iterator fujaba__IterContainerAccess4ElementsUMLParam5 = null ;
      Iterator fujaba__IterContainerAccess7ElementsUMLParam12 = null ;
      Iterator fujaba__IterUMLAttr14AnnotationsDoubleContainerAccess = null ;
      Iterator fujaba__IterUMLAttr20AnnotationsContainerAccess19 = null ;
      Iterator fujaba__IterUMLAttr20AnnotationsDoubleContainerAccess = null ;
      Iterator fujaba__IterUMLAttr26AnnotationsContainerAccess28 = null ;
      Iterator fujaba__IterUMLAttr2AnnotationsContainerAccess4 = null ;
      Iterator fujaba__IterUMLAttr2AnnotationsDoubleContainerAccess = null ;
      Iterator fujaba__IterUMLAttr8AnnotationsContainerAccess10 = null ;
      Iterator fujaba__IterUMLAttr8AnnotationsContainerAccess7 = null ;
      Iterator fujaba__IterUMLMethod15AnnotationsContainerAccess13 = null ;
      Iterator fujaba__IterUMLMethod15AnnotationsContainerAccess16 = null ;
      Iterator fujaba__IterUMLParam12AnnotationsDoubleContainerAccess = null ;
      Iterator fujaba__IterUMLParam23AnnotationsContainerAccess22 = null ;
      Iterator fujaba__IterUMLParam30AnnotationsContainerAccess25 = null ;
      Iterator fujaba__IterUMLParam30AnnotationsDoubleContainerAccess = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr14 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr2 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr20 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr26 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr8 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod15 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod21 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod27 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod3 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod9 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam11 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam12 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam17 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam18 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam23 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam24 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam29 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam30 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam5 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess1 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr2: UMLAttr
            fujaba__IterContainerAccess1ElementsUMLAttr2 = containerAccess1.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess1ElementsUMLAttr2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess1ElementsUMLAttr2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr2 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  // bind uMLMethod3: UMLMethod
                  fujaba__IterContainerAccess1ElementsUMLMethod3 = containerAccess1.iteratorOfElements ("method") ;
                  while ( fujaba__IterContainerAccess1ElementsUMLMethod3.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess1ElementsUMLMethod3.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod3 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // bind uMLParam6: UMLParam
                        fujaba__IterContainerAccess1ElementsUMLParam6 = containerAccess1.iteratorOfElements ("pram") ;
                        while ( fujaba__IterContainerAccess1ElementsUMLParam6.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess1ElementsUMLParam6.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                              uMLParam6 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                               
                              // bind containerAccess4: ContainerAccessAnnotation
                              fujaba__IterUMLAttr2AnnotationsContainerAccess4 = uMLAttr2.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLAttr2AnnotationsContainerAccess4.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLAttr2AnnotationsContainerAccess4.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                                    containerAccess4 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between containerAccess4 and uMLAttr2
                                    JavaSDM.ensure ( containerAccess4.hasInElements ("field", uMLAttr2) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(containerAccess1.equals (containerAccess4)) ) ;
                                     
                                    // check To-Many-Link 'elements' between containerAccess4 and uMLMethod3
                                    JavaSDM.ensure ( containerAccess4.hasInElements ("method", uMLMethod3) ) ;
                                     
                                    // bind uMLParam5: UMLParam
                                    fujaba__IterContainerAccess4ElementsUMLParam5 = containerAccess4.iteratorOfElements ("param") ;
                                    while ( fujaba__IterContainerAccess4ElementsUMLParam5.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess4ElementsUMLParam5.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam5 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam6.equals (uMLParam5)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLAttr2 is really bound
                                                JavaSDM.ensure ( uMLAttr2 != null ) ;
                                                 
                                                // check object uMLMethod3 is really bound
                                                JavaSDM.ensure ( uMLMethod3 != null ) ;
                                                 
                                                // check object uMLParam5 is really bound
                                                JavaSDM.ensure ( uMLParam5 != null ) ;
                                                 
                                                // check object uMLParam6 is really bound
                                                JavaSDM.ensure ( uMLParam6 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam5.equals (uMLParam6)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLAttr2AnnotationsDoubleContainerAccess = uMLAttr2.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLAttr2AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLAttr2AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLAttr2
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr2) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLMethod3
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod3) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam5
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam5) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam6
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam6) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLAttr2 is really bound
                                                   JavaSDM.ensure ( uMLAttr2 != null ) ;
                                                    
                                                   // check object uMLMethod3 is really bound
                                                   JavaSDM.ensure ( uMLMethod3 != null ) ;
                                                    
                                                   // check object uMLParam5 is really bound
                                                   JavaSDM.ensure ( uMLParam5 != null ) ;
                                                    
                                                   // check object uMLParam6 is really bound
                                                   JavaSDM.ensure ( uMLParam6 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam5.equals (uMLParam6)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr2);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod3);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam5);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam6);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess1 is really bound
                                                   JavaSDM.ensure ( containerAccess1 != null ) ;
                                                    
                                                   // check object containerAccess4 is really bound
                                                   JavaSDM.ensure ( containerAccess4 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess1.equals (containerAccess4)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess1);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess4);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr8 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess10: ContainerAccessAnnotation
            fujaba__IterUMLAttr8AnnotationsContainerAccess10 = uMLAttr8.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLAttr8AnnotationsContainerAccess10.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLAttr8AnnotationsContainerAccess10.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess10 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess10 and uMLAttr8
                  JavaSDM.ensure ( containerAccess10.hasInElements ("field", uMLAttr8) ) ;
                   
                  // bind containerAccess7: ContainerAccessAnnotation
                  fujaba__IterUMLAttr8AnnotationsContainerAccess7 = uMLAttr8.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr8AnnotationsContainerAccess7.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr8AnnotationsContainerAccess7.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                        containerAccess7 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between containerAccess7 and uMLAttr8
                        JavaSDM.ensure ( containerAccess7.hasInElements ("field", uMLAttr8) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(containerAccess10.equals (containerAccess7)) ) ;
                         
                        // bind uMLMethod9: UMLMethod
                        fujaba__IterContainerAccess10ElementsUMLMethod9 = containerAccess10.iteratorOfElements ("method") ;
                        while ( fujaba__IterContainerAccess10ElementsUMLMethod9.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess10ElementsUMLMethod9.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod9 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check To-Many-Link 'elements' between containerAccess7 and uMLMethod9
                              JavaSDM.ensure ( containerAccess7.hasInElements ("method", uMLMethod9) ) ;
                               
                              // bind uMLParam11: UMLParam
                              fujaba__IterContainerAccess10ElementsUMLParam11 = containerAccess10.iteratorOfElements ("param") ;
                              while ( fujaba__IterContainerAccess10ElementsUMLParam11.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterContainerAccess10ElementsUMLParam11.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                    uMLParam11 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                                     
                                    // bind uMLParam12: UMLParam
                                    fujaba__IterContainerAccess7ElementsUMLParam12 = containerAccess7.iteratorOfElements ("pram") ;
                                    while ( fujaba__IterContainerAccess7ElementsUMLParam12.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess7ElementsUMLParam12.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam12 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam11.equals (uMLParam12)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLAttr8 is really bound
                                                JavaSDM.ensure ( uMLAttr8 != null ) ;
                                                 
                                                // check object uMLMethod9 is really bound
                                                JavaSDM.ensure ( uMLMethod9 != null ) ;
                                                 
                                                // check object uMLParam11 is really bound
                                                JavaSDM.ensure ( uMLParam11 != null ) ;
                                                 
                                                // check object uMLParam12 is really bound
                                                JavaSDM.ensure ( uMLParam12 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam11.equals (uMLParam12)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLParam12AnnotationsDoubleContainerAccess = uMLParam12.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLParam12AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLParam12AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLParam12
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam12) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLAttr8
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr8) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLMethod9
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod9) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam11
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam11) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLAttr8 is really bound
                                                   JavaSDM.ensure ( uMLAttr8 != null ) ;
                                                    
                                                   // check object uMLMethod9 is really bound
                                                   JavaSDM.ensure ( uMLMethod9 != null ) ;
                                                    
                                                   // check object uMLParam11 is really bound
                                                   JavaSDM.ensure ( uMLParam11 != null ) ;
                                                    
                                                   // check object uMLParam12 is really bound
                                                   JavaSDM.ensure ( uMLParam12 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam11.equals (uMLParam12)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr8);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod9);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam11);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam12);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess7 is really bound
                                                   JavaSDM.ensure ( containerAccess7 != null ) ;
                                                    
                                                   // check object containerAccess10 is really bound
                                                   JavaSDM.ensure ( containerAccess10 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess7.equals (containerAccess10)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess7);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess10);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod15 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess16: ContainerAccessAnnotation
            fujaba__IterUMLMethod15AnnotationsContainerAccess16 = uMLMethod15.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLMethod15AnnotationsContainerAccess16.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLMethod15AnnotationsContainerAccess16.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess16 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess16 and uMLMethod15
                  JavaSDM.ensure ( containerAccess16.hasInElements ("method", uMLMethod15) ) ;
                   
                  // bind containerAccess13: ContainerAccessAnnotation
                  fujaba__IterUMLMethod15AnnotationsContainerAccess13 = uMLMethod15.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod15AnnotationsContainerAccess13.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod15AnnotationsContainerAccess13.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                        containerAccess13 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between containerAccess13 and uMLMethod15
                        JavaSDM.ensure ( containerAccess13.hasInElements ("method", uMLMethod15) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(containerAccess16.equals (containerAccess13)) ) ;
                         
                        // bind uMLAttr14: UMLAttr
                        fujaba__IterContainerAccess16ElementsUMLAttr14 = containerAccess16.iteratorOfElements ("field") ;
                        while ( fujaba__IterContainerAccess16ElementsUMLAttr14.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess16ElementsUMLAttr14.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              uMLAttr14 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              // check To-Many-Link 'elements' between containerAccess13 and uMLAttr14
                              JavaSDM.ensure ( containerAccess13.hasInElements ("field", uMLAttr14) ) ;
                               
                              // bind uMLParam17: UMLParam
                              fujaba__IterContainerAccess16ElementsUMLParam17 = containerAccess16.iteratorOfElements ("param") ;
                              while ( fujaba__IterContainerAccess16ElementsUMLParam17.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterContainerAccess16ElementsUMLParam17.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                    uMLParam17 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                                     
                                    // bind uMLParam18: UMLParam
                                    fujaba__IterContainerAccess13ElementsUMLParam18 = containerAccess13.iteratorOfElements ("pram") ;
                                    while ( fujaba__IterContainerAccess13ElementsUMLParam18.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess13ElementsUMLParam18.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam18 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam17.equals (uMLParam18)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLAttr14 is really bound
                                                JavaSDM.ensure ( uMLAttr14 != null ) ;
                                                 
                                                // check object uMLMethod15 is really bound
                                                JavaSDM.ensure ( uMLMethod15 != null ) ;
                                                 
                                                // check object uMLParam17 is really bound
                                                JavaSDM.ensure ( uMLParam17 != null ) ;
                                                 
                                                // check object uMLParam18 is really bound
                                                JavaSDM.ensure ( uMLParam18 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam17.equals (uMLParam18)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLAttr14AnnotationsDoubleContainerAccess = uMLAttr14.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLAttr14AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLAttr14AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLAttr14
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr14) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLMethod15
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod15) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam17
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam17) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam18
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam18) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLAttr14 is really bound
                                                   JavaSDM.ensure ( uMLAttr14 != null ) ;
                                                    
                                                   // check object uMLMethod15 is really bound
                                                   JavaSDM.ensure ( uMLMethod15 != null ) ;
                                                    
                                                   // check object uMLParam17 is really bound
                                                   JavaSDM.ensure ( uMLParam17 != null ) ;
                                                    
                                                   // check object uMLParam18 is really bound
                                                   JavaSDM.ensure ( uMLParam18 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam17.equals (uMLParam18)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr14);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod15);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam17);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam18);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess13 is really bound
                                                   JavaSDM.ensure ( containerAccess13 != null ) ;
                                                    
                                                   // check object containerAccess16 is really bound
                                                   JavaSDM.ensure ( containerAccess16 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess13.equals (containerAccess16)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess13);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess16);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam23 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess22: ContainerAccessAnnotation
            fujaba__IterUMLParam23AnnotationsContainerAccess22 = uMLParam23.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLParam23AnnotationsContainerAccess22.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLParam23AnnotationsContainerAccess22.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess22 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess22 and uMLParam23
                  JavaSDM.ensure ( containerAccess22.hasInElements ("param", uMLParam23) ) ;
                   
                  // bind uMLAttr20: UMLAttr
                  fujaba__IterContainerAccess22ElementsUMLAttr20 = containerAccess22.iteratorOfElements ("field") ;
                  while ( fujaba__IterContainerAccess22ElementsUMLAttr20.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess22ElementsUMLAttr20.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr20 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind uMLMethod21: UMLMethod
                        fujaba__IterContainerAccess22ElementsUMLMethod21 = containerAccess22.iteratorOfElements ("method") ;
                        while ( fujaba__IterContainerAccess22ElementsUMLMethod21.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess22ElementsUMLMethod21.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod21 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // bind containerAccess19: ContainerAccessAnnotation
                              fujaba__IterUMLAttr20AnnotationsContainerAccess19 = uMLAttr20.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLAttr20AnnotationsContainerAccess19.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLAttr20AnnotationsContainerAccess19.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                                    containerAccess19 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between containerAccess19 and uMLAttr20
                                    JavaSDM.ensure ( containerAccess19.hasInElements ("field", uMLAttr20) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(containerAccess22.equals (containerAccess19)) ) ;
                                     
                                    // check To-Many-Link 'elements' between containerAccess19 and uMLMethod21
                                    JavaSDM.ensure ( containerAccess19.hasInElements ("method", uMLMethod21) ) ;
                                     
                                    // bind uMLParam24: UMLParam
                                    fujaba__IterContainerAccess19ElementsUMLParam24 = containerAccess19.iteratorOfElements ("pram") ;
                                    while ( fujaba__IterContainerAccess19ElementsUMLParam24.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess19ElementsUMLParam24.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam24 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam23.equals (uMLParam24)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLAttr20 is really bound
                                                JavaSDM.ensure ( uMLAttr20 != null ) ;
                                                 
                                                // check object uMLMethod21 is really bound
                                                JavaSDM.ensure ( uMLMethod21 != null ) ;
                                                 
                                                // check object uMLParam23 is really bound
                                                JavaSDM.ensure ( uMLParam23 != null ) ;
                                                 
                                                // check object uMLParam24 is really bound
                                                JavaSDM.ensure ( uMLParam24 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam23.equals (uMLParam24)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLAttr20AnnotationsDoubleContainerAccess = uMLAttr20.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLAttr20AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLAttr20AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLAttr20
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr20) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLMethod21
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod21) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam23
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam23) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam24
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam24) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLAttr20 is really bound
                                                   JavaSDM.ensure ( uMLAttr20 != null ) ;
                                                    
                                                   // check object uMLMethod21 is really bound
                                                   JavaSDM.ensure ( uMLMethod21 != null ) ;
                                                    
                                                   // check object uMLParam23 is really bound
                                                   JavaSDM.ensure ( uMLParam23 != null ) ;
                                                    
                                                   // check object uMLParam24 is really bound
                                                   JavaSDM.ensure ( uMLParam24 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam23.equals (uMLParam24)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr20);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod21);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam23);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam24);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess19 is really bound
                                                   JavaSDM.ensure ( containerAccess19 != null ) ;
                                                    
                                                   // check object containerAccess22 is really bound
                                                   JavaSDM.ensure ( containerAccess22 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess19.equals (containerAccess22)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess19);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess22);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("param", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam30 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess25: ContainerAccessAnnotation
            fujaba__IterUMLParam30AnnotationsContainerAccess25 = uMLParam30.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLParam30AnnotationsContainerAccess25.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLParam30AnnotationsContainerAccess25.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess25 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess25 and uMLParam30
                  JavaSDM.ensure ( containerAccess25.hasInElements ("pram", uMLParam30) ) ;
                   
                  // bind uMLAttr26: UMLAttr
                  fujaba__IterContainerAccess25ElementsUMLAttr26 = containerAccess25.iteratorOfElements ("field") ;
                  while ( fujaba__IterContainerAccess25ElementsUMLAttr26.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess25ElementsUMLAttr26.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr26 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind uMLMethod27: UMLMethod
                        fujaba__IterContainerAccess25ElementsUMLMethod27 = containerAccess25.iteratorOfElements ("method") ;
                        while ( fujaba__IterContainerAccess25ElementsUMLMethod27.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess25ElementsUMLMethod27.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod27 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // bind containerAccess28: ContainerAccessAnnotation
                              fujaba__IterUMLAttr26AnnotationsContainerAccess28 = uMLAttr26.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLAttr26AnnotationsContainerAccess28.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLAttr26AnnotationsContainerAccess28.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                                    containerAccess28 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between containerAccess28 and uMLAttr26
                                    JavaSDM.ensure ( containerAccess28.hasInElements ("field", uMLAttr26) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(containerAccess25.equals (containerAccess28)) ) ;
                                     
                                    // check To-Many-Link 'elements' between containerAccess28 and uMLMethod27
                                    JavaSDM.ensure ( containerAccess28.hasInElements ("method", uMLMethod27) ) ;
                                     
                                    // bind uMLParam29: UMLParam
                                    fujaba__IterContainerAccess28ElementsUMLParam29 = containerAccess28.iteratorOfElements ("param") ;
                                    while ( fujaba__IterContainerAccess28ElementsUMLParam29.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess28ElementsUMLParam29.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam29 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam30.equals (uMLParam29)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLAttr26 is really bound
                                                JavaSDM.ensure ( uMLAttr26 != null ) ;
                                                 
                                                // check object uMLMethod27 is really bound
                                                JavaSDM.ensure ( uMLMethod27 != null ) ;
                                                 
                                                // check object uMLParam29 is really bound
                                                JavaSDM.ensure ( uMLParam29 != null ) ;
                                                 
                                                // check object uMLParam30 is really bound
                                                JavaSDM.ensure ( uMLParam30 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam29.equals (uMLParam30)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLParam30AnnotationsDoubleContainerAccess = uMLParam30.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLParam30AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLParam30AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLParam30
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam30) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLAttr26
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr26) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLMethod27
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod27) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam29
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam29) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLAttr26 is really bound
                                                   JavaSDM.ensure ( uMLAttr26 != null ) ;
                                                    
                                                   // check object uMLMethod27 is really bound
                                                   JavaSDM.ensure ( uMLMethod27 != null ) ;
                                                    
                                                   // check object uMLParam29 is really bound
                                                   JavaSDM.ensure ( uMLParam29 != null ) ;
                                                    
                                                   // check object uMLParam30 is really bound
                                                   JavaSDM.ensure ( uMLParam30 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam29.equals (uMLParam30)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr26);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod27);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam29);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam30);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess25 is really bound
                                                   JavaSDM.ensure ( containerAccess25 != null ) ;
                                                    
                                                   // check object containerAccess28 is really bound
                                                   JavaSDM.ensure ( containerAccess28 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess25.equals (containerAccess28)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess25);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess28);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("param", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (doubleContainerAccess) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLParam )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLParam )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ContainerAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ContainerAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess31 = null ;
      ContainerAccessAnnotation containerAccess33 = null ;
      Iterator fujaba__IterContainerAccess31ElementsUMLAttr32 = null ;
      Iterator fujaba__IterContainerAccess33ElementsUMLAttr34 = null ;
      Iterator fujaba__IterContainerAccess33ElementsUMLAttr35 = null ;
      Iterator fujaba__IterUMLParam29AnnotationsContainerAccess31 = null ;
      Iterator fujaba__IterUMLParam30AnnotationsContainerAccess33 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr26 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr32 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr34 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr35 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod27 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam29 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam30 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("ContainerAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr26 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr26);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod27 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLMethod27);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam29 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess31: ContainerAccessAnnotation
            fujaba__IterUMLParam29AnnotationsContainerAccess31 = uMLParam29.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLParam29AnnotationsContainerAccess31.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLParam29AnnotationsContainerAccess31.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess31 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess31 and uMLParam29
                  JavaSDM.ensure ( containerAccess31.hasInElements ("param", uMLParam29) ) ;
                   
                  // bind uMLAttr32: UMLAttr
                  fujaba__IterContainerAccess31ElementsUMLAttr32 = containerAccess31.iteratorOfElements ("field") ;
                  while ( fujaba__IterContainerAccess31ElementsUMLAttr32.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess31ElementsUMLAttr32.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr32 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLAttr32);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam30 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLParam30);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("ContainerAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr32 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr32);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod27 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLMethod27);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam29 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLParam29);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam30 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess33: ContainerAccessAnnotation
            fujaba__IterUMLParam30AnnotationsContainerAccess33 = uMLParam30.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLParam30AnnotationsContainerAccess33.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLParam30AnnotationsContainerAccess33.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess33 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess33 and uMLParam30
                  JavaSDM.ensure ( containerAccess33.hasInElements ("pram", uMLParam30) ) ;
                   
                  // bind uMLAttr34: UMLAttr
                  fujaba__IterContainerAccess33ElementsUMLAttr34 = containerAccess33.iteratorOfElements ("field") ;
                  while ( fujaba__IterContainerAccess33ElementsUMLAttr34.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess33ElementsUMLAttr34.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr34 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLAttr34);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess33 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr35: UMLAttr
            fujaba__IterContainerAccess33ElementsUMLAttr35 = containerAccess33.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess33ElementsUMLAttr35.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess33ElementsUMLAttr35.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr35 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr35);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
