package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;

public class MementoEngine
extends GFRNEngine
{
   private  MementoEngine()
   {
   }

   private static MementoEngine theMementoEngine;

   public static MementoEngine get()
   {
      if (theMementoEngine == null)
      {
         theMementoEngine = new MementoEngine ();
      }
      return theMementoEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod10 = null ;
      CreateMethodAnnotation createMethod16 = null ;
      CreateMethodAnnotation createMethod22 = null ;
      CreateMethodAnnotation createMethod4 = null ;
      Iterator fujaba__IterCaretakerClassAnnotationsMemento = null ;
      Iterator fujaba__IterCaretakerClassAttrsUMLAttr23 = null ;
      Iterator fujaba__IterCreateMethod10ElementsMementoClass = null ;
      Iterator fujaba__IterCreateMethod16ElementsUMLMethod15 = null ;
      Iterator fujaba__IterCreateMethod22ElementsUMLMethod21 = null ;
      Iterator fujaba__IterCreateMethod4ElementsUMLMethod3 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod16 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod22 = null ;
      Iterator fujaba__IterMementoClassAnnotationsCreateMethod4 = null ;
      Iterator fujaba__IterMementoClassAnnotationsMultiReference13 = null ;
      Iterator fujaba__IterMementoClassAnnotationsMultiReference7 = null ;
      Iterator fujaba__IterMementoClassAnnotationsSetMethod14 = null ;
      Iterator fujaba__IterMementoClassAnnotationsSetMethod2 = null ;
      Iterator fujaba__IterMementoClassAnnotationsSetMethod20 = null ;
      Iterator fujaba__IterMultiReference13ElementsUMLAttr17 = null ;
      Iterator fujaba__IterMultiReference19ElementsMementoClass = null ;
      Iterator fujaba__IterMultiReference1ElementsMementoClass = null ;
      Iterator fujaba__IterMultiReference1ElementsUMLAttr5 = null ;
      Iterator fujaba__IterMultiReference7ElementsUMLAttr11 = null ;
      Iterator fujaba__IterOriginatorClassAnnotationsMemento = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod12 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod9 = null ;
      Iterator fujaba__IterSetMethod14ElementsUMLMethod18 = null ;
      Iterator fujaba__IterSetMethod20ElementsUMLMethod24 = null ;
      Iterator fujaba__IterSetMethod2ElementsUMLMethod6 = null ;
      Iterator fujaba__IterUMLAttr23AnnotationsMultiReference19 = null ;
      Iterator fujaba__IterUMLMethod12AnnotationsSetMethod8 = null ;
      Iterator fujaba__IterUMLMethod9AnnotationsCreateMethod10 = null ;
      MementoAnnotation memento = null ;
      MultiReferenceAnnotation multiReference1 = null ;
      MultiReferenceAnnotation multiReference13 = null ;
      MultiReferenceAnnotation multiReference19 = null ;
      MultiReferenceAnnotation multiReference7 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod14 = null ;
      SetMethodAnnotation setMethod2 = null ;
      SetMethodAnnotation setMethod20 = null ;
      SetMethodAnnotation setMethod8 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr11 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr17 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr23 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr5 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass caretakerClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass mementoClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass originatorClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod12 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod15 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod18 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod21 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod24 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod3 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod6 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod9 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference1 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind mementoClass: UMLClass
            fujaba__IterMultiReference1ElementsMementoClass = multiReference1.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference1ElementsMementoClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference1ElementsMementoClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLAttr5: UMLAttr
                  fujaba__IterMultiReference1ElementsUMLAttr5 = multiReference1.iteratorOfElements ("field") ;
                  while ( fujaba__IterMultiReference1ElementsUMLAttr5.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiReference1ElementsUMLAttr5.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr5 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind caretakerClass: UMLClass
                        caretakerClass = uMLAttr5.getParent () ;
                        JavaSDM.ensure ( caretakerClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                         
                        // bind createMethod4: CreateMethodAnnotation
                        fujaba__IterMementoClassAnnotationsCreateMethod4 = mementoClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterMementoClassAnnotationsCreateMethod4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod4 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod4 and mementoClass
                              JavaSDM.ensure ( createMethod4.hasInElements ("creates", mementoClass) ) ;
                               
                              // bind setMethod2: SetMethodAnnotation
                              fujaba__IterMementoClassAnnotationsSetMethod2 = mementoClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterMementoClassAnnotationsSetMethod2.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMementoClassAnnotationsSetMethod2.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                    setMethod2 = (SetMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between setMethod2 and mementoClass
                                    JavaSDM.ensure ( setMethod2.hasInElements ("sets", mementoClass) ) ;
                                     
                                    // bind uMLMethod3: UMLMethod
                                    fujaba__IterCreateMethod4ElementsUMLMethod3 = createMethod4.iteratorOfElements ("method") ;
                                    while ( fujaba__IterCreateMethod4ElementsUMLMethod3.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterCreateMethod4ElementsUMLMethod3.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          uMLMethod3 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                           
                                          // bind originatorClass: UMLClass
                                          originatorClass = uMLMethod3.getParent () ;
                                          JavaSDM.ensure ( originatorClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                                           
                                          // bind uMLMethod6: UMLMethod
                                          fujaba__IterSetMethod2ElementsUMLMethod6 = setMethod2.iteratorOfElements ("method") ;
                                          while ( fujaba__IterSetMethod2ElementsUMLMethod6.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSetMethod2ElementsUMLMethod6.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                uMLMethod6 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod3.equals (uMLMethod6)) ) ;
                                                 
                                                // check To-One-Link 'parent' between uMLMethod6 and originatorClass
                                                JavaSDM.ensure ( (uMLMethod6.getParent () != null) && uMLMethod6.getParent ().equals (originatorClass) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object originatorClass is really bound
                                                      JavaSDM.ensure ( originatorClass != null ) ;
                                                       
                                                      // check object mementoClass is really bound
                                                      JavaSDM.ensure ( mementoClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                       
                                                      // check object caretakerClass is really bound
                                                      JavaSDM.ensure ( caretakerClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(originatorClass.equals (caretakerClass)) && !(mementoClass.equals (caretakerClass)) ) ;
                                                       
                                                      // bind memento: MementoAnnotation
                                                      fujaba__IterOriginatorClassAnnotationsMemento = originatorClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterOriginatorClassAnnotationsMemento.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterOriginatorClassAnnotationsMemento.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                            memento = (MementoAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between memento and originatorClass
                                                            JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between memento and mementoClass
                                                            JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between memento and caretakerClass
                                                            JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object originatorClass is really bound
                                                         JavaSDM.ensure ( originatorClass != null ) ;
                                                          
                                                         // check object mementoClass is really bound
                                                         JavaSDM.ensure ( mementoClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                          
                                                         // check object caretakerClass is really bound
                                                         JavaSDM.ensure ( caretakerClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                          
                                                         // create object
                                                         memento = new MementoAnnotation ( ) ;
                                                          
                                                         // create link
                                                         memento.addToElements ("originator", originatorClass);
                                                          
                                                         // create link
                                                         memento.addToElements ("memento", mementoClass);
                                                          
                                                         // create link
                                                         memento.addToElements ("caretaker", caretakerClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("originatorClass", originatorClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("mementoClass", mementoClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object multiReference1 is really bound
                                                         JavaSDM.ensure ( multiReference1 != null ) ;
                                                          
                                                         // check object setMethod2 is really bound
                                                         JavaSDM.ensure ( setMethod2 != null ) ;
                                                          
                                                         // check object createMethod4 is really bound
                                                         JavaSDM.ensure ( createMethod4 != null ) ;
                                                          
                                                         // check object memento is really bound
                                                         JavaSDM.ensure ( memento != null ) ;
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (multiReference1);
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (setMethod2);
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (createMethod4);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (memento) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("originator", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            originatorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod9: UMLMethod
            fujaba__IterOriginatorClassMethodsUMLMethod9 = originatorClass.iteratorOfMethods () ;
            while ( fujaba__IterOriginatorClassMethodsUMLMethod9.hasNext () )
            {
               try
               {
                  uMLMethod9 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod9.next () ;
                   
                  // bind uMLMethod12: UMLMethod
                  fujaba__IterOriginatorClassMethodsUMLMethod12 = originatorClass.iteratorOfMethods () ;
                  while ( fujaba__IterOriginatorClassMethodsUMLMethod12.hasNext () )
                  {
                     try
                     {
                        uMLMethod12 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod12.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod9.equals (uMLMethod12)) ) ;
                         
                        // bind createMethod10: CreateMethodAnnotation
                        fujaba__IterUMLMethod9AnnotationsCreateMethod10 = uMLMethod9.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod9AnnotationsCreateMethod10.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod9AnnotationsCreateMethod10.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod10 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod10 and uMLMethod9
                              JavaSDM.ensure ( createMethod10.hasInElements ("method", uMLMethod9) ) ;
                               
                              // bind setMethod8: SetMethodAnnotation
                              fujaba__IterUMLMethod12AnnotationsSetMethod8 = uMLMethod12.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod12AnnotationsSetMethod8.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod12AnnotationsSetMethod8.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                    setMethod8 = (SetMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between setMethod8 and uMLMethod12
                                    JavaSDM.ensure ( setMethod8.hasInElements ("method", uMLMethod12) ) ;
                                     
                                    // bind mementoClass: UMLClass
                                    fujaba__IterCreateMethod10ElementsMementoClass = createMethod10.iteratorOfElements ("creates") ;
                                    while ( fujaba__IterCreateMethod10ElementsMementoClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterCreateMethod10ElementsMementoClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                           
                                          // check To-Many-Link 'elements' between setMethod8 and mementoClass
                                          JavaSDM.ensure ( setMethod8.hasInElements ("sets", mementoClass) ) ;
                                           
                                          // bind multiReference7: MultiReferenceAnnotation
                                          fujaba__IterMementoClassAnnotationsMultiReference7 = mementoClass.iteratorOfAnnotations () ;
                                          while ( fujaba__IterMementoClassAnnotationsMultiReference7.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMementoClassAnnotationsMultiReference7.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                                multiReference7 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between multiReference7 and mementoClass
                                                JavaSDM.ensure ( multiReference7.hasInElements ("references", mementoClass) ) ;
                                                 
                                                // bind uMLAttr11: UMLAttr
                                                fujaba__IterMultiReference7ElementsUMLAttr11 = multiReference7.iteratorOfElements ("field") ;
                                                while ( fujaba__IterMultiReference7ElementsUMLAttr11.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterMultiReference7ElementsUMLAttr11.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                                      uMLAttr11 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                                                       
                                                      // bind caretakerClass: UMLClass
                                                      caretakerClass = uMLAttr11.getParent () ;
                                                      JavaSDM.ensure ( caretakerClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object originatorClass is really bound
                                                            JavaSDM.ensure ( originatorClass != null ) ;
                                                             
                                                            // check object mementoClass is really bound
                                                            JavaSDM.ensure ( mementoClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                             
                                                            // check object caretakerClass is really bound
                                                            JavaSDM.ensure ( caretakerClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(originatorClass.equals (caretakerClass)) && !(mementoClass.equals (caretakerClass)) ) ;
                                                             
                                                            // bind memento: MementoAnnotation
                                                            fujaba__IterOriginatorClassAnnotationsMemento = originatorClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterOriginatorClassAnnotationsMemento.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterOriginatorClassAnnotationsMemento.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                                  memento = (MementoAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between memento and originatorClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and mementoClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and caretakerClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object originatorClass is really bound
                                                               JavaSDM.ensure ( originatorClass != null ) ;
                                                                
                                                               // check object mementoClass is really bound
                                                               JavaSDM.ensure ( mementoClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                
                                                               // check object caretakerClass is really bound
                                                               JavaSDM.ensure ( caretakerClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                
                                                               // create object
                                                               memento = new MementoAnnotation ( ) ;
                                                                
                                                               // create link
                                                               memento.addToElements ("originator", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("memento", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("caretaker", caretakerClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("originatorClass", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("mementoClass", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object multiReference7 is really bound
                                                               JavaSDM.ensure ( multiReference7 != null ) ;
                                                                
                                                               // check object setMethod8 is really bound
                                                               JavaSDM.ensure ( setMethod8 != null ) ;
                                                                
                                                               // check object createMethod10 is really bound
                                                               JavaSDM.ensure ( createMethod10 != null ) ;
                                                                
                                                               // check object memento is really bound
                                                               JavaSDM.ensure ( memento != null ) ;
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (multiReference7);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (setMethod8);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (createMethod10);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (memento) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("originator", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("memento", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind createMethod16: CreateMethodAnnotation
            fujaba__IterMementoClassAnnotationsCreateMethod16 = mementoClass.iteratorOfAnnotations () ;
            while ( fujaba__IterMementoClassAnnotationsCreateMethod16.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod16.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                  createMethod16 = (CreateMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between createMethod16 and mementoClass
                  JavaSDM.ensure ( createMethod16.hasInElements ("creates", mementoClass) ) ;
                   
                  // bind setMethod14: SetMethodAnnotation
                  fujaba__IterMementoClassAnnotationsSetMethod14 = mementoClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterMementoClassAnnotationsSetMethod14.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMementoClassAnnotationsSetMethod14.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                        setMethod14 = (SetMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between setMethod14 and mementoClass
                        JavaSDM.ensure ( setMethod14.hasInElements ("sets", mementoClass) ) ;
                         
                        // bind multiReference13: MultiReferenceAnnotation
                        fujaba__IterMementoClassAnnotationsMultiReference13 = mementoClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterMementoClassAnnotationsMultiReference13.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMementoClassAnnotationsMultiReference13.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                              multiReference13 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between multiReference13 and mementoClass
                              JavaSDM.ensure ( multiReference13.hasInElements ("references", mementoClass) ) ;
                               
                              // bind uMLMethod15: UMLMethod
                              fujaba__IterCreateMethod16ElementsUMLMethod15 = createMethod16.iteratorOfElements ("method") ;
                              while ( fujaba__IterCreateMethod16ElementsUMLMethod15.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod16ElementsUMLMethod15.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod15 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                     
                                    // bind originatorClass: UMLClass
                                    originatorClass = uMLMethod15.getParent () ;
                                    JavaSDM.ensure ( originatorClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                                     
                                    // bind uMLMethod18: UMLMethod
                                    fujaba__IterSetMethod14ElementsUMLMethod18 = setMethod14.iteratorOfElements ("method") ;
                                    while ( fujaba__IterSetMethod14ElementsUMLMethod18.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterSetMethod14ElementsUMLMethod18.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          uMLMethod18 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod15.equals (uMLMethod18)) ) ;
                                           
                                          // check To-One-Link 'parent' between uMLMethod18 and originatorClass
                                          JavaSDM.ensure ( (uMLMethod18.getParent () != null) && uMLMethod18.getParent ().equals (originatorClass) ) ;
                                           
                                          // bind uMLAttr17: UMLAttr
                                          fujaba__IterMultiReference13ElementsUMLAttr17 = multiReference13.iteratorOfElements ("field") ;
                                          while ( fujaba__IterMultiReference13ElementsUMLAttr17.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMultiReference13ElementsUMLAttr17.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                                uMLAttr17 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                                                 
                                                // bind caretakerClass: UMLClass
                                                caretakerClass = uMLAttr17.getParent () ;
                                                JavaSDM.ensure ( caretakerClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object originatorClass is really bound
                                                      JavaSDM.ensure ( originatorClass != null ) ;
                                                       
                                                      // check object mementoClass is really bound
                                                      JavaSDM.ensure ( mementoClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                       
                                                      // check object caretakerClass is really bound
                                                      JavaSDM.ensure ( caretakerClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(originatorClass.equals (caretakerClass)) && !(mementoClass.equals (caretakerClass)) ) ;
                                                       
                                                      // bind memento: MementoAnnotation
                                                      fujaba__IterOriginatorClassAnnotationsMemento = originatorClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterOriginatorClassAnnotationsMemento.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterOriginatorClassAnnotationsMemento.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                            memento = (MementoAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between memento and originatorClass
                                                            JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between memento and mementoClass
                                                            JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between memento and caretakerClass
                                                            JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object originatorClass is really bound
                                                         JavaSDM.ensure ( originatorClass != null ) ;
                                                          
                                                         // check object mementoClass is really bound
                                                         JavaSDM.ensure ( mementoClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                          
                                                         // check object caretakerClass is really bound
                                                         JavaSDM.ensure ( caretakerClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                          
                                                         // create object
                                                         memento = new MementoAnnotation ( ) ;
                                                          
                                                         // create link
                                                         memento.addToElements ("originator", originatorClass);
                                                          
                                                         // create link
                                                         memento.addToElements ("memento", mementoClass);
                                                          
                                                         // create link
                                                         memento.addToElements ("caretaker", caretakerClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("originatorClass", originatorClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("mementoClass", mementoClass);
                                                          
                                                         // create link
                                                         memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object multiReference13 is really bound
                                                         JavaSDM.ensure ( multiReference13 != null ) ;
                                                          
                                                         // check object setMethod14 is really bound
                                                         JavaSDM.ensure ( setMethod14 != null ) ;
                                                          
                                                         // check object createMethod16 is really bound
                                                         JavaSDM.ensure ( createMethod16 != null ) ;
                                                          
                                                         // check object memento is really bound
                                                         JavaSDM.ensure ( memento != null ) ;
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (multiReference13);
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (setMethod14);
                                                          
                                                         // create link
                                                         memento.addToAntecedentAnnos (createMethod16);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (memento) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("memento", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("caretaker", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            caretakerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr23: UMLAttr
            fujaba__IterCaretakerClassAttrsUMLAttr23 = caretakerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCaretakerClassAttrsUMLAttr23.hasNext () )
            {
               try
               {
                  uMLAttr23 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCaretakerClassAttrsUMLAttr23.next () ;
                   
                  // bind multiReference19: MultiReferenceAnnotation
                  fujaba__IterUMLAttr23AnnotationsMultiReference19 = uMLAttr23.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr23AnnotationsMultiReference19.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr23AnnotationsMultiReference19.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference19 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference19 and uMLAttr23
                        JavaSDM.ensure ( multiReference19.hasInElements ("field", uMLAttr23) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterMultiReference19ElementsMementoClass = multiReference19.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference19ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference19ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(caretakerClass.equals (mementoClass)) ) ;
                               
                              // bind createMethod22: CreateMethodAnnotation
                              fujaba__IterMementoClassAnnotationsCreateMethod22 = mementoClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterMementoClassAnnotationsCreateMethod22.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMementoClassAnnotationsCreateMethod22.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                    createMethod22 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between createMethod22 and mementoClass
                                    JavaSDM.ensure ( createMethod22.hasInElements ("creates", mementoClass) ) ;
                                     
                                    // bind setMethod20: SetMethodAnnotation
                                    fujaba__IterMementoClassAnnotationsSetMethod20 = mementoClass.iteratorOfAnnotations () ;
                                    while ( fujaba__IterMementoClassAnnotationsSetMethod20.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterMementoClassAnnotationsSetMethod20.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                          setMethod20 = (SetMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between setMethod20 and mementoClass
                                          JavaSDM.ensure ( setMethod20.hasInElements ("sets", mementoClass) ) ;
                                           
                                          // bind uMLMethod21: UMLMethod
                                          fujaba__IterCreateMethod22ElementsUMLMethod21 = createMethod22.iteratorOfElements ("method") ;
                                          while ( fujaba__IterCreateMethod22ElementsUMLMethod21.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCreateMethod22ElementsUMLMethod21.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                uMLMethod21 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // bind originatorClass: UMLClass
                                                originatorClass = uMLMethod21.getParent () ;
                                                JavaSDM.ensure ( originatorClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(mementoClass.equals (originatorClass)) ) ;
                                                 
                                                // bind uMLMethod24: UMLMethod
                                                fujaba__IterSetMethod20ElementsUMLMethod24 = setMethod20.iteratorOfElements ("method") ;
                                                while ( fujaba__IterSetMethod20ElementsUMLMethod24.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterSetMethod20ElementsUMLMethod24.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod24 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod21.equals (uMLMethod24)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between uMLMethod24 and originatorClass
                                                      JavaSDM.ensure ( (uMLMethod24.getParent () != null) && uMLMethod24.getParent ().equals (originatorClass) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object originatorClass is really bound
                                                            JavaSDM.ensure ( originatorClass != null ) ;
                                                             
                                                            // check object mementoClass is really bound
                                                            JavaSDM.ensure ( mementoClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                             
                                                            // check object caretakerClass is really bound
                                                            JavaSDM.ensure ( caretakerClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(originatorClass.equals (caretakerClass)) && !(mementoClass.equals (caretakerClass)) ) ;
                                                             
                                                            // bind memento: MementoAnnotation
                                                            fujaba__IterCaretakerClassAnnotationsMemento = caretakerClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterCaretakerClassAnnotationsMemento.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterCaretakerClassAnnotationsMemento.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof MementoAnnotation ) ;
                                                                  memento = (MementoAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between memento and caretakerClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("caretaker", caretakerClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and originatorClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("originator", originatorClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between memento and mementoClass
                                                                  JavaSDM.ensure ( memento.hasInElements ("memento", mementoClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object originatorClass is really bound
                                                               JavaSDM.ensure ( originatorClass != null ) ;
                                                                
                                                               // check object mementoClass is really bound
                                                               JavaSDM.ensure ( mementoClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                                                                
                                                               // check object caretakerClass is really bound
                                                               JavaSDM.ensure ( caretakerClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(mementoClass.equals (caretakerClass)) ) ;
                                                                
                                                               // create object
                                                               memento = new MementoAnnotation ( ) ;
                                                                
                                                               // create link
                                                               memento.addToElements ("originator", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("memento", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToElements ("caretaker", caretakerClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("originatorClass", originatorClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("mementoClass", mementoClass);
                                                                
                                                               // create link
                                                               memento.addToBoundObjects ("caretakerClass", caretakerClass);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object multiReference19 is really bound
                                                               JavaSDM.ensure ( multiReference19 != null ) ;
                                                                
                                                               // check object setMethod20 is really bound
                                                               JavaSDM.ensure ( setMethod20 != null ) ;
                                                                
                                                               // check object createMethod22 is really bound
                                                               JavaSDM.ensure ( createMethod22 != null ) ;
                                                                
                                                               // check object memento is really bound
                                                               JavaSDM.ensure ( memento != null ) ;
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (multiReference19);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (setMethod20);
                                                                
                                                               // create link
                                                               memento.addToAntecedentAnnos (createMethod22);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (memento) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object memento is really bound
            JavaSDM.ensure ( memento != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("caretaker", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (memento) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("originator", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("memento", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("caretaker", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof SetMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof CreateMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod26 = null ;
      CreateMethodAnnotation createMethod29 = null ;
      Iterator fujaba__IterCaretakerClassAttrsUMLAttr27 = null ;
      Iterator fujaba__IterCaretakerClassAttrsUMLAttr30 = null ;
      Iterator fujaba__IterCaretakerClassAttrsUMLAttr33 = null ;
      Iterator fujaba__IterCreateMethod26ElementsMementoClass = null ;
      Iterator fujaba__IterCreateMethod29ElementsMementoClass = null ;
      Iterator fujaba__IterMultiReference31ElementsMementoClass = null ;
      Iterator fujaba__IterMultiReference34ElementsMementoClass = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod25 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod28 = null ;
      Iterator fujaba__IterOriginatorClassMethodsUMLMethod32 = null ;
      Iterator fujaba__IterUMLAttr30AnnotationsMultiReference31 = null ;
      Iterator fujaba__IterUMLAttr33AnnotationsMultiReference34 = null ;
      Iterator fujaba__IterUMLMethod25AnnotationsCreateMethod26 = null ;
      Iterator fujaba__IterUMLMethod28AnnotationsCreateMethod29 = null ;
      MultiReferenceAnnotation multiReference31 = null ;
      MultiReferenceAnnotation multiReference34 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr27 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr30 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr33 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass caretakerClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass mementoClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass originatorClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod25 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod28 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod32 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("MultiReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            originatorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod25: UMLMethod
            fujaba__IterOriginatorClassMethodsUMLMethod25 = originatorClass.iteratorOfMethods () ;
            while ( fujaba__IterOriginatorClassMethodsUMLMethod25.hasNext () )
            {
               try
               {
                  uMLMethod25 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod25.next () ;
                   
                  // bind createMethod26: CreateMethodAnnotation
                  fujaba__IterUMLMethod25AnnotationsCreateMethod26 = uMLMethod25.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod25AnnotationsCreateMethod26.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod25AnnotationsCreateMethod26.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod26 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod26 and uMLMethod25
                        JavaSDM.ensure ( createMethod26.hasInElements ("method", uMLMethod25) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterCreateMethod26ElementsMementoClass = createMethod26.iteratorOfElements ("creates") ;
                        while ( fujaba__IterCreateMethod26ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCreateMethod26ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (mementoClass);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (mementoClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            caretakerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr27: UMLAttr
            fujaba__IterCaretakerClassAttrsUMLAttr27 = caretakerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCaretakerClassAttrsUMLAttr27.hasNext () )
            {
               try
               {
                  uMLAttr27 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCaretakerClassAttrsUMLAttr27.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr27);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("SetMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            originatorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod28: UMLMethod
            fujaba__IterOriginatorClassMethodsUMLMethod28 = originatorClass.iteratorOfMethods () ;
            while ( fujaba__IterOriginatorClassMethodsUMLMethod28.hasNext () )
            {
               try
               {
                  uMLMethod28 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod28.next () ;
                   
                  // bind createMethod29: CreateMethodAnnotation
                  fujaba__IterUMLMethod28AnnotationsCreateMethod29 = uMLMethod28.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod28AnnotationsCreateMethod29.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod28AnnotationsCreateMethod29.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod29 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod29 and uMLMethod28
                        JavaSDM.ensure ( createMethod29.hasInElements ("method", uMLMethod28) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterCreateMethod29ElementsMementoClass = createMethod29.iteratorOfElements ("creates") ;
                        while ( fujaba__IterCreateMethod29ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCreateMethod29ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(originatorClass.equals (mementoClass)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (mementoClass);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (mementoClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            caretakerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr30: UMLAttr
            fujaba__IterCaretakerClassAttrsUMLAttr30 = caretakerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCaretakerClassAttrsUMLAttr30.hasNext () )
            {
               try
               {
                  uMLAttr30 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCaretakerClassAttrsUMLAttr30.next () ;
                   
                  // bind multiReference31: MultiReferenceAnnotation
                  fujaba__IterUMLAttr30AnnotationsMultiReference31 = uMLAttr30.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr30AnnotationsMultiReference31.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr30AnnotationsMultiReference31.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference31 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference31 and uMLAttr30
                        JavaSDM.ensure ( multiReference31.hasInElements ("field", uMLAttr30) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterMultiReference31ElementsMementoClass = multiReference31.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference31ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference31ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(caretakerClass.equals (mementoClass)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (mementoClass);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference31 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind mementoClass: UMLClass
            fujaba__IterMultiReference31ElementsMementoClass = multiReference31.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference31ElementsMementoClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference31ElementsMementoClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (mementoClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("CreateMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            originatorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod32: UMLMethod
            fujaba__IterOriginatorClassMethodsUMLMethod32 = originatorClass.iteratorOfMethods () ;
            while ( fujaba__IterOriginatorClassMethodsUMLMethod32.hasNext () )
            {
               try
               {
                  uMLMethod32 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterOriginatorClassMethodsUMLMethod32.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod32);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (mementoClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            caretakerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr33: UMLAttr
            fujaba__IterCaretakerClassAttrsUMLAttr33 = caretakerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCaretakerClassAttrsUMLAttr33.hasNext () )
            {
               try
               {
                  uMLAttr33 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCaretakerClassAttrsUMLAttr33.next () ;
                   
                  // bind multiReference34: MultiReferenceAnnotation
                  fujaba__IterUMLAttr33AnnotationsMultiReference34 = uMLAttr33.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr33AnnotationsMultiReference34.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr33AnnotationsMultiReference34.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference34 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference34 and uMLAttr33
                        JavaSDM.ensure ( multiReference34.hasInElements ("field", uMLAttr33) ) ;
                         
                        // bind mementoClass: UMLClass
                        fujaba__IterMultiReference34ElementsMementoClass = multiReference34.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference34ElementsMementoClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference34ElementsMementoClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(caretakerClass.equals (mementoClass)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (mementoClass);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference34 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind mementoClass: UMLClass
            fujaba__IterMultiReference34ElementsMementoClass = multiReference34.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference34ElementsMementoClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference34ElementsMementoClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  mementoClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (mementoClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
