package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class MultiReferenceEngine
extends GFRNEngine
{
   private  MultiReferenceEngine()
   {
   }

   private static MultiReferenceEngine theMultiReferenceEngine;

   public static MultiReferenceEngine get()
   {
      if (theMultiReferenceEngine == null)
      {
         theMultiReferenceEngine = new MultiReferenceEngine ();
      }
      return theMultiReferenceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      AssignmentToContainerAnnotation assignmentToContainer1 = null ;
      AssignmentToContainerAnnotation assignmentToContainer10 = null ;
      AssignmentToContainerAnnotation assignmentToContainer4 = null ;
      AssignmentToContainerAnnotation assignmentToContainer7 = null ;
      Iterator fujaba__IterAssignmentToContainer10ElementsParam = null ;
      Iterator fujaba__IterAssignmentToContainer1ElementsParam = null ;
      Iterator fujaba__IterAssignmentToContainer1ElementsReferencingField = null ;
      Iterator fujaba__IterAssignmentToContainer4ElementsParam = null ;
      Iterator fujaba__IterAssignmentToContainer7ElementsReferencingField = null ;
      Iterator fujaba__IterParamAnnotationsAssignmentToContainer7 = null ;
      Iterator fujaba__IterReferencingClassAnnotationsMultiReference = null ;
      Iterator fujaba__IterReferencingClassAttrsReferencingField = null ;
      Iterator fujaba__IterReferencingClassMethodsReadOp = null ;
      Iterator fujaba__IterReferencingClassMethodsWriteOp = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsAssignmentToContainer10 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsAssignmentToContainer4 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsMultiReference = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation11 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation2 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation5 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation8 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation12 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation3 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation6 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation9 = null ;
      Iterator fujaba__IterReferredClassRevParamTypeParam = null ;
      MultiReferenceAnnotation multiReference = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReadOperationAnnotation readOperation11 = null ;
      ReadOperationAnnotation readOperation2 = null ;
      ReadOperationAnnotation readOperation5 = null ;
      ReadOperationAnnotation readOperation8 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr referencingField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencingClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referredClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod readOp = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod writeOp = null ;
      de.uni_paderborn.fujaba.uml.UMLParam param = null ;
      WriteOperationAnnotation writeOperation12 = null ;
      WriteOperationAnnotation writeOperation3 = null ;
      WriteOperationAnnotation writeOperation6 = null ;
      WriteOperationAnnotation writeOperation9 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssignmentToContainerAnnotation ) ;
             
            // explicit type cast
            assignmentToContainer1 = (AssignmentToContainerAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind param: UMLParam
            fujaba__IterAssignmentToContainer1ElementsParam = assignmentToContainer1.iteratorOfElements ("param") ;
            while ( fujaba__IterAssignmentToContainer1ElementsParam.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssignmentToContainer1ElementsParam.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                   
                  // bind referredClass: UMLClass
                  fujaba__TmpObject = param.getParamType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterAssignmentToContainer1ElementsReferencingField = assignmentToContainer1.iteratorOfElements ("field") ;
                  while ( fujaba__IterAssignmentToContainer1ElementsReferencingField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssignmentToContainer1ElementsReferencingField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind referencingClass: UMLClass
                        referencingClass = referencingField.getParent () ;
                        JavaSDM.ensure ( referencingClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                         
                        // bind readOperation2: ReadOperationAnnotation
                        fujaba__IterReferencingFieldAnnotationsReadOperation2 = referencingField.iteratorOfAnnotations () ;
                        do
                        {
                           try
                           {
                              readOperation2 = null ;
                              if ( fujaba__IterReferencingFieldAnnotationsReadOperation2.hasNext () )
                              {
                                 fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation2.next () ;
                                 if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                                 {
                                    readOperation2 = (ReadOperationAnnotation) fujaba__TmpObject;
                                 }
                                 else
                                 {
                                    JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation2.hasNext ()) ) ;
                                 }
                              }
                               
                              // check Reverse-Qualified-Link 'elements' between readOperation2 and referencingField
                              JavaSDM.ensure ( (readOperation2 == null) || readOperation2.hasInElements ("field", referencingField) ) ;
                               
                              // bind writeOperation3: WriteOperationAnnotation
                              fujaba__IterReferencingFieldAnnotationsWriteOperation3 = referencingField.iteratorOfAnnotations () ;
                              do
                              {
                                 try
                                 {
                                    writeOperation3 = null ;
                                    if ( fujaba__IterReferencingFieldAnnotationsWriteOperation3.hasNext () )
                                    {
                                       fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation3.next () ;
                                       if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                                       {
                                          writeOperation3 = (WriteOperationAnnotation) fujaba__TmpObject;
                                       }
                                       else
                                       {
                                          JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation3.hasNext ()) ) ;
                                       }
                                    }
                                     
                                    // check Reverse-Qualified-Link 'elements' between writeOperation3 and referencingField
                                    JavaSDM.ensure ( (writeOperation3 == null) || writeOperation3.hasInElements ("field", referencingField) ) ;
                                     
                                    // bind readOp: UMLMethod
                                    fujaba__IterReferencingClassMethodsReadOp = referencingClass.iteratorOfMethods () ;
                                    do
                                    {
                                       try
                                       {
                                          readOp = null ;
                                          if ( fujaba__IterReferencingClassMethodsReadOp.hasNext () )
                                          {
                                             readOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReadOp.next () ;
                                              
                                          }
                                           
                                          // check To-Many-Link 'elements' between readOperation2 and readOp
                                          JavaSDM.ensure ( ((readOperation2 == null) || (readOp == null)) || ((readOperation2 != null) || (readOp != null) || readOperation2.hasInElements ("method", readOp)) ) ;
                                           
                                          // bind writeOp: UMLMethod
                                          fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                                          do
                                          {
                                             try
                                             {
                                                writeOp = null ;
                                                if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                                                {
                                                   writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                                    
                                                }
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( (writeOp == null) || ((readOp == null) || !(readOp.equals (writeOp))) ) ;
                                                 
                                                // check To-Many-Link 'elements' between writeOperation3 and writeOp
                                                JavaSDM.ensure ( ((writeOperation3 == null) || (writeOp == null)) || ((writeOperation3 != null) || (writeOp != null) || writeOperation3.hasInElements ("method", writeOp)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object referencingField is really bound
                                                      JavaSDM.ensure ( referencingField != null ) ;
                                                       
                                                      // check object referredClass is really bound
                                                      JavaSDM.ensure ( referredClass != null ) ;
                                                       
                                                      // check object referencingClass is really bound
                                                      JavaSDM.ensure ( referencingClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                                                       
                                                      // bind multiReference: MultiReferenceAnnotation
                                                      fujaba__IterReferencingClassAnnotationsMultiReference = referencingClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterReferencingClassAnnotationsMultiReference.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterReferencingClassAnnotationsMultiReference.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                                            multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between multiReference and referencingClass
                                                            JavaSDM.ensure ( multiReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiReference and referencingField
                                                            JavaSDM.ensure ( multiReference.hasInElements ("field", referencingField) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiReference and referredClass
                                                            JavaSDM.ensure ( multiReference.hasInElements ("references", referredClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object referencingField is really bound
                                                         JavaSDM.ensure ( referencingField != null ) ;
                                                          
                                                         // check object referredClass is really bound
                                                         JavaSDM.ensure ( referredClass != null ) ;
                                                          
                                                         // check object referencingClass is really bound
                                                         JavaSDM.ensure ( referencingClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                                                          
                                                         // check object param is really bound
                                                         JavaSDM.ensure ( param != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( (writeOp == null) || ((readOp == null) || !(readOp.equals (writeOp))) ) ;
                                                          
                                                         // create object
                                                         multiReference = new MultiReferenceAnnotation ( ) ;
                                                          
                                                         // create link
                                                         multiReference.addToElements ("field", referencingField);
                                                          
                                                         // create link
                                                         multiReference.addToElements ("references", referredClass);
                                                          
                                                         // create link
                                                         multiReference.addToElements ("referecningClass", referencingClass);
                                                          
                                                         // create link
                                                         multiReference.addToBoundObjects ("param", param);
                                                          
                                                         // create link
                                                         multiReference.addToBoundObjects ("referencingField", referencingField);
                                                          
                                                         // create link
                                                         multiReference.addToBoundObjects ("referredClass", referredClass);
                                                          
                                                         // create link
                                                         if ( readOp != null )
                                                         {
                                                            multiReference.addToBoundObjects ("readOp", readOp);
                                                         } // if
                                                          
                                                         // create link
                                                         multiReference.addToBoundObjects ("referencingClass", referencingClass);
                                                          
                                                         // create link
                                                         if ( writeOp != null )
                                                         {
                                                            multiReference.addToBoundObjects ("writeOp", writeOp);
                                                         } // if
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object assignmentToContainer1 is really bound
                                                         JavaSDM.ensure ( assignmentToContainer1 != null ) ;
                                                          
                                                         // check object multiReference is really bound
                                                         JavaSDM.ensure ( multiReference != null ) ;
                                                          
                                                         // create link
                                                         multiReference.addToAntecedentAnnos (assignmentToContainer1);
                                                          
                                                         // create link
                                                         if ( readOperation2 != null )
                                                         {
                                                            multiReference.addToAntecedentAnnos (readOperation2);
                                                         } // if
                                                          
                                                         // create link
                                                         if ( writeOperation3 != null )
                                                         {
                                                            multiReference.addToAntecedentAnnos (writeOperation3);
                                                         } // if
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (multiReference) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                          while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingClassMethodsReadOp.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingFieldAnnotationsWriteOperation3.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingFieldAnnotationsReadOperation2.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind referencingClass: UMLClass
            referencingClass = referencingField.getParent () ;
            JavaSDM.ensure ( referencingClass != null ) ;
             
            // bind assignmentToContainer4: AssignmentToContainerAnnotation
            fujaba__IterReferencingFieldAnnotationsAssignmentToContainer4 = referencingField.iteratorOfAnnotations () ;
            while ( fujaba__IterReferencingFieldAnnotationsAssignmentToContainer4.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsAssignmentToContainer4.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                  assignmentToContainer4 = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assignmentToContainer4 and referencingField
                  JavaSDM.ensure ( assignmentToContainer4.hasInElements ("field", referencingField) ) ;
                   
                  // bind param: UMLParam
                  fujaba__IterAssignmentToContainer4ElementsParam = assignmentToContainer4.iteratorOfElements ("param") ;
                  while ( fujaba__IterAssignmentToContainer4ElementsParam.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssignmentToContainer4ElementsParam.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                        param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                         
                        // bind referredClass: UMLClass
                        fujaba__TmpObject = param.getParamType () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                         
                        // bind readOperation5: ReadOperationAnnotation
                        fujaba__IterReferencingFieldAnnotationsReadOperation5 = referencingField.iteratorOfAnnotations () ;
                        do
                        {
                           try
                           {
                              readOperation5 = null ;
                              if ( fujaba__IterReferencingFieldAnnotationsReadOperation5.hasNext () )
                              {
                                 fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation5.next () ;
                                 if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                                 {
                                    readOperation5 = (ReadOperationAnnotation) fujaba__TmpObject;
                                 }
                                 else
                                 {
                                    JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation5.hasNext ()) ) ;
                                 }
                              }
                               
                              // check Reverse-Qualified-Link 'elements' between readOperation5 and referencingField
                              JavaSDM.ensure ( (readOperation5 == null) || readOperation5.hasInElements ("field", referencingField) ) ;
                               
                              // bind writeOperation6: WriteOperationAnnotation
                              fujaba__IterReferencingFieldAnnotationsWriteOperation6 = referencingField.iteratorOfAnnotations () ;
                              do
                              {
                                 try
                                 {
                                    writeOperation6 = null ;
                                    if ( fujaba__IterReferencingFieldAnnotationsWriteOperation6.hasNext () )
                                    {
                                       fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation6.next () ;
                                       if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                                       {
                                          writeOperation6 = (WriteOperationAnnotation) fujaba__TmpObject;
                                       }
                                       else
                                       {
                                          JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation6.hasNext ()) ) ;
                                       }
                                    }
                                     
                                    // check Reverse-Qualified-Link 'elements' between writeOperation6 and referencingField
                                    JavaSDM.ensure ( (writeOperation6 == null) || writeOperation6.hasInElements ("field", referencingField) ) ;
                                     
                                    // bind readOp: UMLMethod
                                    fujaba__IterReferencingClassMethodsReadOp = referencingClass.iteratorOfMethods () ;
                                    do
                                    {
                                       try
                                       {
                                          readOp = null ;
                                          if ( fujaba__IterReferencingClassMethodsReadOp.hasNext () )
                                          {
                                             readOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReadOp.next () ;
                                              
                                          }
                                           
                                          // check To-Many-Link 'elements' between readOperation5 and readOp
                                          JavaSDM.ensure ( ((readOperation5 == null) || (readOp == null)) || ((readOperation5 != null) || (readOp != null) || readOperation5.hasInElements ("method", readOp)) ) ;
                                           
                                          // bind writeOp: UMLMethod
                                          fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                                          do
                                          {
                                             try
                                             {
                                                writeOp = null ;
                                                if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                                                {
                                                   writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                                    
                                                }
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( (writeOp == null) || ((readOp == null) || !(readOp.equals (writeOp))) ) ;
                                                 
                                                // check To-Many-Link 'elements' between writeOperation6 and writeOp
                                                JavaSDM.ensure ( ((writeOperation6 == null) || (writeOp == null)) || ((writeOperation6 != null) || (writeOp != null) || writeOperation6.hasInElements ("method", writeOp)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object referencingField is really bound
                                                      JavaSDM.ensure ( referencingField != null ) ;
                                                       
                                                      // check object referredClass is really bound
                                                      JavaSDM.ensure ( referredClass != null ) ;
                                                       
                                                      // check object referencingClass is really bound
                                                      JavaSDM.ensure ( referencingClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                                                       
                                                      // bind multiReference: MultiReferenceAnnotation
                                                      fujaba__IterReferencingFieldAnnotationsMultiReference = referencingField.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterReferencingFieldAnnotationsMultiReference.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsMultiReference.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                                            multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between multiReference and referencingField
                                                            JavaSDM.ensure ( multiReference.hasInElements ("field", referencingField) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiReference and referredClass
                                                            JavaSDM.ensure ( multiReference.hasInElements ("references", referredClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiReference and referencingClass
                                                            JavaSDM.ensure ( multiReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object referencingField is really bound
                                                         JavaSDM.ensure ( referencingField != null ) ;
                                                          
                                                         // check object referredClass is really bound
                                                         JavaSDM.ensure ( referredClass != null ) ;
                                                          
                                                         // check object referencingClass is really bound
                                                         JavaSDM.ensure ( referencingClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                                                          
                                                         // check object param is really bound
                                                         JavaSDM.ensure ( param != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( (writeOp == null) || ((readOp == null) || !(readOp.equals (writeOp))) ) ;
                                                          
                                                         // create object
                                                         multiReference = new MultiReferenceAnnotation ( ) ;
                                                          
                                                         // create link
                                                         multiReference.addToElements ("field", referencingField);
                                                          
                                                         // create link
                                                         multiReference.addToElements ("references", referredClass);
                                                          
                                                         // create link
                                                         multiReference.addToElements ("referecningClass", referencingClass);
                                                          
                                                         // create link
                                                         multiReference.addToBoundObjects ("param", param);
                                                          
                                                         // create link
                                                         multiReference.addToBoundObjects ("referencingField", referencingField);
                                                          
                                                         // create link
                                                         multiReference.addToBoundObjects ("referredClass", referredClass);
                                                          
                                                         // create link
                                                         if ( readOp != null )
                                                         {
                                                            multiReference.addToBoundObjects ("readOp", readOp);
                                                         } // if
                                                          
                                                         // create link
                                                         multiReference.addToBoundObjects ("referencingClass", referencingClass);
                                                          
                                                         // create link
                                                         if ( writeOp != null )
                                                         {
                                                            multiReference.addToBoundObjects ("writeOp", writeOp);
                                                         } // if
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object assignmentToContainer4 is really bound
                                                         JavaSDM.ensure ( assignmentToContainer4 != null ) ;
                                                          
                                                         // check object multiReference is really bound
                                                         JavaSDM.ensure ( multiReference != null ) ;
                                                          
                                                         // create link
                                                         multiReference.addToAntecedentAnnos (assignmentToContainer4);
                                                          
                                                         // create link
                                                         if ( readOperation5 != null )
                                                         {
                                                            multiReference.addToAntecedentAnnos (readOperation5);
                                                         } // if
                                                          
                                                         // create link
                                                         if ( writeOperation6 != null )
                                                         {
                                                            multiReference.addToAntecedentAnnos (writeOperation6);
                                                         } // if
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (multiReference) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                          while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingClassMethodsReadOp.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingFieldAnnotationsWriteOperation6.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingFieldAnnotationsReadOperation5.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind param: UMLParam
            fujaba__IterReferredClassRevParamTypeParam = referredClass.iteratorOfRevParamType () ;
            while ( fujaba__IterReferredClassRevParamTypeParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterReferredClassRevParamTypeParam.next () ;
                   
                  // bind assignmentToContainer7: AssignmentToContainerAnnotation
                  fujaba__IterParamAnnotationsAssignmentToContainer7 = param.iteratorOfAnnotations () ;
                  while ( fujaba__IterParamAnnotationsAssignmentToContainer7.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterParamAnnotationsAssignmentToContainer7.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                        assignmentToContainer7 = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between assignmentToContainer7 and param
                        JavaSDM.ensure ( assignmentToContainer7.hasInElements ("param", param) ) ;
                         
                        // bind referencingField: UMLAttr
                        fujaba__IterAssignmentToContainer7ElementsReferencingField = assignmentToContainer7.iteratorOfElements ("field") ;
                        while ( fujaba__IterAssignmentToContainer7ElementsReferencingField.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssignmentToContainer7ElementsReferencingField.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              // bind referencingClass: UMLClass
                              referencingClass = referencingField.getParent () ;
                              JavaSDM.ensure ( referencingClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                               
                              // bind readOperation8: ReadOperationAnnotation
                              fujaba__IterReferencingFieldAnnotationsReadOperation8 = referencingField.iteratorOfAnnotations () ;
                              do
                              {
                                 try
                                 {
                                    readOperation8 = null ;
                                    if ( fujaba__IterReferencingFieldAnnotationsReadOperation8.hasNext () )
                                    {
                                       fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation8.next () ;
                                       if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                                       {
                                          readOperation8 = (ReadOperationAnnotation) fujaba__TmpObject;
                                       }
                                       else
                                       {
                                          JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation8.hasNext ()) ) ;
                                       }
                                    }
                                     
                                    // check Reverse-Qualified-Link 'elements' between readOperation8 and referencingField
                                    JavaSDM.ensure ( (readOperation8 == null) || readOperation8.hasInElements ("field", referencingField) ) ;
                                     
                                    // bind writeOperation9: WriteOperationAnnotation
                                    fujaba__IterReferencingFieldAnnotationsWriteOperation9 = referencingField.iteratorOfAnnotations () ;
                                    do
                                    {
                                       try
                                       {
                                          writeOperation9 = null ;
                                          if ( fujaba__IterReferencingFieldAnnotationsWriteOperation9.hasNext () )
                                          {
                                             fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation9.next () ;
                                             if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                                             {
                                                writeOperation9 = (WriteOperationAnnotation) fujaba__TmpObject;
                                             }
                                             else
                                             {
                                                JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation9.hasNext ()) ) ;
                                             }
                                          }
                                           
                                          // check Reverse-Qualified-Link 'elements' between writeOperation9 and referencingField
                                          JavaSDM.ensure ( (writeOperation9 == null) || writeOperation9.hasInElements ("field", referencingField) ) ;
                                           
                                          // bind readOp: UMLMethod
                                          fujaba__IterReferencingClassMethodsReadOp = referencingClass.iteratorOfMethods () ;
                                          do
                                          {
                                             try
                                             {
                                                readOp = null ;
                                                if ( fujaba__IterReferencingClassMethodsReadOp.hasNext () )
                                                {
                                                   readOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReadOp.next () ;
                                                    
                                                }
                                                 
                                                // check To-Many-Link 'elements' between readOperation8 and readOp
                                                JavaSDM.ensure ( ((readOperation8 == null) || (readOp == null)) || ((readOperation8 != null) || (readOp != null) || readOperation8.hasInElements ("method", readOp)) ) ;
                                                 
                                                // bind writeOp: UMLMethod
                                                fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                                                do
                                                {
                                                   try
                                                   {
                                                      writeOp = null ;
                                                      if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                                                      {
                                                         writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                                          
                                                      }
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( (writeOp == null) || ((readOp == null) || !(readOp.equals (writeOp))) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between writeOperation9 and writeOp
                                                      JavaSDM.ensure ( ((writeOperation9 == null) || (writeOp == null)) || ((writeOperation9 != null) || (writeOp != null) || writeOperation9.hasInElements ("method", writeOp)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object referencingField is really bound
                                                            JavaSDM.ensure ( referencingField != null ) ;
                                                             
                                                            // check object referredClass is really bound
                                                            JavaSDM.ensure ( referredClass != null ) ;
                                                             
                                                            // check object referencingClass is really bound
                                                            JavaSDM.ensure ( referencingClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                                                             
                                                            // bind multiReference: MultiReferenceAnnotation
                                                            fujaba__IterReferencingClassAnnotationsMultiReference = referencingClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterReferencingClassAnnotationsMultiReference.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterReferencingClassAnnotationsMultiReference.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                                                  multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between multiReference and referencingClass
                                                                  JavaSDM.ensure ( multiReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between multiReference and referencingField
                                                                  JavaSDM.ensure ( multiReference.hasInElements ("field", referencingField) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between multiReference and referredClass
                                                                  JavaSDM.ensure ( multiReference.hasInElements ("references", referredClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object referencingField is really bound
                                                               JavaSDM.ensure ( referencingField != null ) ;
                                                                
                                                               // check object referredClass is really bound
                                                               JavaSDM.ensure ( referredClass != null ) ;
                                                                
                                                               // check object referencingClass is really bound
                                                               JavaSDM.ensure ( referencingClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                                                                
                                                               // check object param is really bound
                                                               JavaSDM.ensure ( param != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( (writeOp == null) || ((readOp == null) || !(readOp.equals (writeOp))) ) ;
                                                                
                                                               // create object
                                                               multiReference = new MultiReferenceAnnotation ( ) ;
                                                                
                                                               // create link
                                                               multiReference.addToElements ("field", referencingField);
                                                                
                                                               // create link
                                                               multiReference.addToElements ("references", referredClass);
                                                                
                                                               // create link
                                                               multiReference.addToElements ("referecningClass", referencingClass);
                                                                
                                                               // create link
                                                               multiReference.addToBoundObjects ("param", param);
                                                                
                                                               // create link
                                                               multiReference.addToBoundObjects ("referencingField", referencingField);
                                                                
                                                               // create link
                                                               multiReference.addToBoundObjects ("referredClass", referredClass);
                                                                
                                                               // create link
                                                               if ( readOp != null )
                                                               {
                                                                  multiReference.addToBoundObjects ("readOp", readOp);
                                                               } // if
                                                                
                                                               // create link
                                                               multiReference.addToBoundObjects ("referencingClass", referencingClass);
                                                                
                                                               // create link
                                                               if ( writeOp != null )
                                                               {
                                                                  multiReference.addToBoundObjects ("writeOp", writeOp);
                                                               } // if
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object assignmentToContainer7 is really bound
                                                               JavaSDM.ensure ( assignmentToContainer7 != null ) ;
                                                                
                                                               // check object multiReference is really bound
                                                               JavaSDM.ensure ( multiReference != null ) ;
                                                                
                                                               // create link
                                                               multiReference.addToAntecedentAnnos (assignmentToContainer7);
                                                                
                                                               // create link
                                                               if ( readOperation8 != null )
                                                               {
                                                                  multiReference.addToAntecedentAnnos (readOperation8);
                                                               } // if
                                                                
                                                               // create link
                                                               if ( writeOperation9 != null )
                                                               {
                                                                  multiReference.addToAntecedentAnnos (writeOperation9);
                                                               } // if
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (multiReference) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                                while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                          while ( fujaba__IterReferencingClassMethodsReadOp.hasNext () ) ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingFieldAnnotationsWriteOperation9.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingFieldAnnotationsReadOperation8.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("references", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("referecningClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  // bind assignmentToContainer10: AssignmentToContainerAnnotation
                  fujaba__IterReferencingFieldAnnotationsAssignmentToContainer10 = referencingField.iteratorOfAnnotations () ;
                  while ( fujaba__IterReferencingFieldAnnotationsAssignmentToContainer10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsAssignmentToContainer10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                        assignmentToContainer10 = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between assignmentToContainer10 and referencingField
                        JavaSDM.ensure ( assignmentToContainer10.hasInElements ("field", referencingField) ) ;
                         
                        // bind param: UMLParam
                        fujaba__IterAssignmentToContainer10ElementsParam = assignmentToContainer10.iteratorOfElements ("param") ;
                        while ( fujaba__IterAssignmentToContainer10ElementsParam.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssignmentToContainer10ElementsParam.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                              param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                               
                              // bind referredClass: UMLClass
                              fujaba__TmpObject = param.getParamType () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                               
                              // bind readOp: UMLMethod
                              fujaba__IterReferencingClassMethodsReadOp = referencingClass.iteratorOfMethods () ;
                              do
                              {
                                 try
                                 {
                                    readOp = null ;
                                    if ( fujaba__IterReferencingClassMethodsReadOp.hasNext () )
                                    {
                                       readOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReadOp.next () ;
                                        
                                    }
                                     
                                    // bind writeOp: UMLMethod
                                    fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                                    do
                                    {
                                       try
                                       {
                                          writeOp = null ;
                                          if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                                          {
                                             writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                              
                                          }
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( (writeOp == null) || ((readOp == null) || !(readOp.equals (writeOp))) ) ;
                                           
                                          // bind readOperation11: ReadOperationAnnotation
                                          fujaba__IterReferencingFieldAnnotationsReadOperation11 = referencingField.iteratorOfAnnotations () ;
                                          do
                                          {
                                             try
                                             {
                                                readOperation11 = null ;
                                                if ( fujaba__IterReferencingFieldAnnotationsReadOperation11.hasNext () )
                                                {
                                                   fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation11.next () ;
                                                   if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                                                   {
                                                      readOperation11 = (ReadOperationAnnotation) fujaba__TmpObject;
                                                   }
                                                   else
                                                   {
                                                      JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation11.hasNext ()) ) ;
                                                   }
                                                }
                                                 
                                                // check Reverse-Qualified-Link 'elements' between readOperation11 and referencingField
                                                JavaSDM.ensure ( (readOperation11 == null) || readOperation11.hasInElements ("field", referencingField) ) ;
                                                 
                                                // check To-Many-Link 'elements' between readOperation11 and readOp
                                                JavaSDM.ensure ( ((readOperation11 == null) || (readOp == null)) || ((readOperation11 != null) || (readOp != null) || readOperation11.hasInElements ("method", readOp)) ) ;
                                                 
                                                // bind writeOperation12: WriteOperationAnnotation
                                                fujaba__IterReferencingFieldAnnotationsWriteOperation12 = referencingField.iteratorOfAnnotations () ;
                                                do
                                                {
                                                   try
                                                   {
                                                      writeOperation12 = null ;
                                                      if ( fujaba__IterReferencingFieldAnnotationsWriteOperation12.hasNext () )
                                                      {
                                                         fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation12.next () ;
                                                         if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                                                         {
                                                            writeOperation12 = (WriteOperationAnnotation) fujaba__TmpObject;
                                                         }
                                                         else
                                                         {
                                                            JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation12.hasNext ()) ) ;
                                                         }
                                                      }
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between writeOperation12 and referencingField
                                                      JavaSDM.ensure ( (writeOperation12 == null) || writeOperation12.hasInElements ("field", referencingField) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between writeOperation12 and writeOp
                                                      JavaSDM.ensure ( ((writeOperation12 == null) || (writeOp == null)) || ((writeOperation12 != null) || (writeOp != null) || writeOperation12.hasInElements ("method", writeOp)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object referencingField is really bound
                                                            JavaSDM.ensure ( referencingField != null ) ;
                                                             
                                                            // check object referredClass is really bound
                                                            JavaSDM.ensure ( referredClass != null ) ;
                                                             
                                                            // check object referencingClass is really bound
                                                            JavaSDM.ensure ( referencingClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                                                             
                                                            // bind multiReference: MultiReferenceAnnotation
                                                            fujaba__IterReferencingFieldAnnotationsMultiReference = referencingField.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterReferencingFieldAnnotationsMultiReference.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsMultiReference.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                                                  multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between multiReference and referencingField
                                                                  JavaSDM.ensure ( multiReference.hasInElements ("field", referencingField) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between multiReference and referredClass
                                                                  JavaSDM.ensure ( multiReference.hasInElements ("references", referredClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between multiReference and referencingClass
                                                                  JavaSDM.ensure ( multiReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object referencingField is really bound
                                                               JavaSDM.ensure ( referencingField != null ) ;
                                                                
                                                               // check object referredClass is really bound
                                                               JavaSDM.ensure ( referredClass != null ) ;
                                                                
                                                               // check object referencingClass is really bound
                                                               JavaSDM.ensure ( referencingClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                                                                
                                                               // check object param is really bound
                                                               JavaSDM.ensure ( param != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( (writeOp == null) || ((readOp == null) || !(readOp.equals (writeOp))) ) ;
                                                                
                                                               // create object
                                                               multiReference = new MultiReferenceAnnotation ( ) ;
                                                                
                                                               // create link
                                                               multiReference.addToElements ("field", referencingField);
                                                                
                                                               // create link
                                                               multiReference.addToElements ("references", referredClass);
                                                                
                                                               // create link
                                                               multiReference.addToElements ("referecningClass", referencingClass);
                                                                
                                                               // create link
                                                               multiReference.addToBoundObjects ("param", param);
                                                                
                                                               // create link
                                                               multiReference.addToBoundObjects ("referencingField", referencingField);
                                                                
                                                               // create link
                                                               multiReference.addToBoundObjects ("referredClass", referredClass);
                                                                
                                                               // create link
                                                               if ( readOp != null )
                                                               {
                                                                  multiReference.addToBoundObjects ("readOp", readOp);
                                                               } // if
                                                                
                                                               // create link
                                                               multiReference.addToBoundObjects ("referencingClass", referencingClass);
                                                                
                                                               // create link
                                                               if ( writeOp != null )
                                                               {
                                                                  multiReference.addToBoundObjects ("writeOp", writeOp);
                                                               } // if
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object assignmentToContainer10 is really bound
                                                               JavaSDM.ensure ( assignmentToContainer10 != null ) ;
                                                                
                                                               // check object multiReference is really bound
                                                               JavaSDM.ensure ( multiReference != null ) ;
                                                                
                                                               // create link
                                                               multiReference.addToAntecedentAnnos (assignmentToContainer10);
                                                                
                                                               // create link
                                                               if ( readOperation11 != null )
                                                               {
                                                                  multiReference.addToAntecedentAnnos (readOperation11);
                                                               } // if
                                                                
                                                               // create link
                                                               if ( writeOperation12 != null )
                                                               {
                                                                  multiReference.addToAntecedentAnnos (writeOperation12);
                                                               } // if
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (multiReference) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                                while ( fujaba__IterReferencingFieldAnnotationsWriteOperation12.hasNext () ) ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                          while ( fujaba__IterReferencingFieldAnnotationsReadOperation11.hasNext () ) ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingClassMethodsReadOp.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("referecningClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (multiReference) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("referecningClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof AssignmentToContainerAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      AssignmentToContainerAnnotation assignmentToContainer13 = null ;
      AssignmentToContainerAnnotation assignmentToContainer14 = null ;
      Iterator fujaba__IterAssignmentToContainer13ElementsReferencingField = null ;
      Iterator fujaba__IterAssignmentToContainer14ElementsReferencingField = null ;
      Iterator fujaba__IterParamAnnotationsAssignmentToContainer13 = null ;
      Iterator fujaba__IterParamAnnotationsAssignmentToContainer14 = null ;
      Iterator fujaba__IterReferencingClassAttrsReferencingField = null ;
      Iterator fujaba__IterReferredClassRevParamTypeParam = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr referencingField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencingClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referredClass = null ;
      de.uni_paderborn.fujaba.uml.UMLParam param = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("AssignmentToContainer") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind param: UMLParam
            fujaba__IterReferredClassRevParamTypeParam = referredClass.iteratorOfRevParamType () ;
            while ( fujaba__IterReferredClassRevParamTypeParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterReferredClassRevParamTypeParam.next () ;
                   
                  {
                     //  for each flow
                     set.add (param);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("ReadOperation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind param: UMLParam
            fujaba__IterReferredClassRevParamTypeParam = referredClass.iteratorOfRevParamType () ;
            while ( fujaba__IterReferredClassRevParamTypeParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterReferredClassRevParamTypeParam.next () ;
                   
                  // bind assignmentToContainer13: AssignmentToContainerAnnotation
                  fujaba__IterParamAnnotationsAssignmentToContainer13 = param.iteratorOfAnnotations () ;
                  while ( fujaba__IterParamAnnotationsAssignmentToContainer13.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterParamAnnotationsAssignmentToContainer13.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                        assignmentToContainer13 = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between assignmentToContainer13 and param
                        JavaSDM.ensure ( assignmentToContainer13.hasInElements ("param", param) ) ;
                         
                        // bind referencingField: UMLAttr
                        fujaba__IterAssignmentToContainer13ElementsReferencingField = assignmentToContainer13.iteratorOfElements ("field") ;
                        while ( fujaba__IterAssignmentToContainer13ElementsReferencingField.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssignmentToContainer13ElementsReferencingField.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              {
                                 //  for each flow
                                 set.add (referencingField);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssignmentToContainerAnnotation ) ;
             
            // explicit type cast
            assignmentToContainer13 = (AssignmentToContainerAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterAssignmentToContainer13ElementsReferencingField = assignmentToContainer13.iteratorOfElements ("field") ;
            while ( fujaba__IterAssignmentToContainer13ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssignmentToContainer13ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("WriteOperation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind param: UMLParam
            fujaba__IterReferredClassRevParamTypeParam = referredClass.iteratorOfRevParamType () ;
            while ( fujaba__IterReferredClassRevParamTypeParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterReferredClassRevParamTypeParam.next () ;
                   
                  // bind assignmentToContainer14: AssignmentToContainerAnnotation
                  fujaba__IterParamAnnotationsAssignmentToContainer14 = param.iteratorOfAnnotations () ;
                  while ( fujaba__IterParamAnnotationsAssignmentToContainer14.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterParamAnnotationsAssignmentToContainer14.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                        assignmentToContainer14 = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between assignmentToContainer14 and param
                        JavaSDM.ensure ( assignmentToContainer14.hasInElements ("param", param) ) ;
                         
                        // bind referencingField: UMLAttr
                        fujaba__IterAssignmentToContainer14ElementsReferencingField = assignmentToContainer14.iteratorOfElements ("field") ;
                        while ( fujaba__IterAssignmentToContainer14ElementsReferencingField.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssignmentToContainer14ElementsReferencingField.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              {
                                 //  for each flow
                                 set.add (referencingField);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssignmentToContainerAnnotation ) ;
             
            // explicit type cast
            assignmentToContainer14 = (AssignmentToContainerAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterAssignmentToContainer14ElementsReferencingField = assignmentToContainer14.iteratorOfElements ("field") ;
            while ( fujaba__IterAssignmentToContainer14ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssignmentToContainer14ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
