package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class ObjectAdapterEngine
extends GFRNEngine
{
   private  ObjectAdapterEngine()
   {
   }

   private static ObjectAdapterEngine theObjectAdapterEngine;

   public static ObjectAdapterEngine get()
   {
      if (theObjectAdapterEngine == null)
      {
         theObjectAdapterEngine = new ObjectAdapterEngine ();
      }
      return theObjectAdapterEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAdapteeAnnotationsObjectAdapter = null ;
      Iterator fujaba__IterAdapteeMethodsCallee = null ;
      Iterator fujaba__IterAdapterAnnotationsGeneralization13 = null ;
      Iterator fujaba__IterAdapterAnnotationsGeneralization5 = null ;
      Iterator fujaba__IterAdapterAnnotationsGeneralization9 = null ;
      Iterator fujaba__IterAdapterAnnotationsObjectAdapter = null ;
      Iterator fujaba__IterAdapterMethodsCaller = null ;
      Iterator fujaba__IterCalleeAnnotationsNeighborCall10 = null ;
      Iterator fujaba__IterCallerAnnotationsNeighborCall2 = null ;
      Iterator fujaba__IterCallerAnnotationsNeighborCall6 = null ;
      Iterator fujaba__IterCallerAnnotationsOverridingMethod11 = null ;
      Iterator fujaba__IterCallerAnnotationsOverridingMethod15 = null ;
      Iterator fujaba__IterCallerAnnotationsOverridingMethod7 = null ;
      Iterator fujaba__IterGeneralization1ElementsAdapter = null ;
      Iterator fujaba__IterGeneralization5ElementsTarget = null ;
      Iterator fujaba__IterNeighborCall10ElementsCaller = null ;
      Iterator fujaba__IterNeighborCall14ElementsCallee = null ;
      Iterator fujaba__IterNeighborCall14ElementsCaller = null ;
      Iterator fujaba__IterNeighborCall2ElementsCallee = null ;
      Iterator fujaba__IterNeighborCall6ElementsCallee = null ;
      Iterator fujaba__IterOverridingMethod11ElementsUMLMethod12 = null ;
      Iterator fujaba__IterOverridingMethod15ElementsUMLMethod16 = null ;
      Iterator fujaba__IterOverridingMethod3ElementsCaller = null ;
      Iterator fujaba__IterOverridingMethod7ElementsUMLMethod8 = null ;
      Iterator fujaba__IterTargetAnnotationsGeneralization1 = null ;
      Iterator fujaba__IterTargetMethodsUMLMethod4 = null ;
      Iterator fujaba__IterUMLMethod4AnnotationsOverridingMethod3 = null ;
      GeneralizationAnnotation generalization1 = null ;
      GeneralizationAnnotation generalization13 = null ;
      GeneralizationAnnotation generalization5 = null ;
      GeneralizationAnnotation generalization9 = null ;
      NeighborCallAnnotation neighborCall10 = null ;
      NeighborCallAnnotation neighborCall14 = null ;
      NeighborCallAnnotation neighborCall2 = null ;
      NeighborCallAnnotation neighborCall6 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ObjectAdapterAnnotation objectAdapter = null ;
      OverridingMethodAnnotation overridingMethod11 = null ;
      OverridingMethodAnnotation overridingMethod15 = null ;
      OverridingMethodAnnotation overridingMethod3 = null ;
      OverridingMethodAnnotation overridingMethod7 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass adaptee = null ;
      de.uni_paderborn.fujaba.uml.UMLClass adapter = null ;
      de.uni_paderborn.fujaba.uml.UMLClass target = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod12 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod16 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod4 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod8 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("target", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            target = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (target.isAbstract () == true) ) ;
             
            // bind uMLMethod4: UMLMethod
            fujaba__IterTargetMethodsUMLMethod4 = target.iteratorOfMethods () ;
            while ( fujaba__IterTargetMethodsUMLMethod4.hasNext () )
            {
               try
               {
                  uMLMethod4 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterTargetMethodsUMLMethod4.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (uMLMethod4.isAbstract () == true) ) ;
                   
                  // bind generalization1: GeneralizationAnnotation
                  fujaba__IterTargetAnnotationsGeneralization1 = target.iteratorOfAnnotations () ;
                  while ( fujaba__IterTargetAnnotationsGeneralization1.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterTargetAnnotationsGeneralization1.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization1 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization1 and target
                        JavaSDM.ensure ( generalization1.hasInElements ("superClass", target) ) ;
                         
                        // bind overridingMethod3: OverridingMethodAnnotation
                        fujaba__IterUMLMethod4AnnotationsOverridingMethod3 = uMLMethod4.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod4AnnotationsOverridingMethod3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod4AnnotationsOverridingMethod3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod3 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod3 and uMLMethod4
                              JavaSDM.ensure ( overridingMethod3.hasInElements ("overridden", uMLMethod4) ) ;
                               
                              // bind adapter: UMLClass
                              fujaba__IterGeneralization1ElementsAdapter = generalization1.iteratorOfElements ("subClass") ;
                              while ( fujaba__IterGeneralization1ElementsAdapter.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterGeneralization1ElementsAdapter.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                     
                                    // bind caller: UMLMethod
                                    fujaba__IterOverridingMethod3ElementsCaller = overridingMethod3.iteratorOfElements ("overriding") ;
                                    while ( fujaba__IterOverridingMethod3ElementsCaller.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterOverridingMethod3ElementsCaller.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod4.equals (caller)) ) ;
                                           
                                          // check To-One-Link 'parent' between caller and adapter
                                          JavaSDM.ensure ( (caller.getParent () != null) && caller.getParent ().equals (adapter) ) ;
                                           
                                          // bind neighborCall2: NeighborCallAnnotation
                                          fujaba__IterCallerAnnotationsNeighborCall2 = caller.iteratorOfAnnotations () ;
                                          while ( fujaba__IterCallerAnnotationsNeighborCall2.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCallerAnnotationsNeighborCall2.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall2 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall2 and caller
                                                JavaSDM.ensure ( neighborCall2.hasInElements ("caller", caller) ) ;
                                                 
                                                // bind callee: UMLMethod
                                                fujaba__IterNeighborCall2ElementsCallee = neighborCall2.iteratorOfElements ("callee") ;
                                                while ( fujaba__IterNeighborCall2ElementsCallee.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall2ElementsCallee.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(caller.equals (callee)) && !(uMLMethod4.equals (callee)) ) ;
                                                       
                                                      // bind adaptee: UMLClass
                                                      adaptee = callee.getParent () ;
                                                      JavaSDM.ensure ( adaptee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object target is really bound
                                                            JavaSDM.ensure ( target != null ) ;
                                                             
                                                            // check object adapter is really bound
                                                            JavaSDM.ensure ( adapter != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                                             
                                                            // check object adaptee is really bound
                                                            JavaSDM.ensure ( adaptee != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                             
                                                            // bind objectAdapter: ObjectAdapterAnnotation
                                                            fujaba__IterAdapteeAnnotationsObjectAdapter = adaptee.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterAdapteeAnnotationsObjectAdapter.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAdapteeAnnotationsObjectAdapter.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof ObjectAdapterAnnotation ) ;
                                                                  objectAdapter = (ObjectAdapterAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between objectAdapter and adaptee
                                                                  JavaSDM.ensure ( objectAdapter.hasInElements ("adaptee", adaptee) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between objectAdapter and target
                                                                  JavaSDM.ensure ( objectAdapter.hasInElements ("target", target) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between objectAdapter and adapter
                                                                  JavaSDM.ensure ( objectAdapter.hasInElements ("adapter", adapter) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object target is really bound
                                                               JavaSDM.ensure ( target != null ) ;
                                                                
                                                               // check object adapter is really bound
                                                               JavaSDM.ensure ( adapter != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                                                
                                                               // check object adaptee is really bound
                                                               JavaSDM.ensure ( adaptee != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                                
                                                               // check object callee is really bound
                                                               JavaSDM.ensure ( callee != null ) ;
                                                                
                                                               // check object caller is really bound
                                                               JavaSDM.ensure ( caller != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                                
                                                               // create object
                                                               objectAdapter = new ObjectAdapterAnnotation ( ) ;
                                                                
                                                               // create link
                                                               objectAdapter.addToElements ("target", target);
                                                                
                                                               // create link
                                                               objectAdapter.addToElements ("adapter", adapter);
                                                                
                                                               // create link
                                                               objectAdapter.addToElements ("adaptee", adaptee);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("target", target);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("adapter", adapter);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("adaptee", adaptee);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("callee", callee);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("caller", caller);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object generalization1 is really bound
                                                               JavaSDM.ensure ( generalization1 != null ) ;
                                                                
                                                               // check object neighborCall2 is really bound
                                                               JavaSDM.ensure ( neighborCall2 != null ) ;
                                                                
                                                               // check object overridingMethod3 is really bound
                                                               JavaSDM.ensure ( overridingMethod3 != null ) ;
                                                                
                                                               // check object objectAdapter is really bound
                                                               JavaSDM.ensure ( objectAdapter != null ) ;
                                                                
                                                               // create link
                                                               objectAdapter.addToAntecedentAnnos (generalization1);
                                                                
                                                               // create link
                                                               objectAdapter.addToAntecedentAnnos (neighborCall2);
                                                                
                                                               // create link
                                                               objectAdapter.addToAntecedentAnnos (overridingMethod3);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (objectAdapter) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object objectAdapter is really bound
            JavaSDM.ensure ( objectAdapter != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("target", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("adapter", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterAdapterMethodsCaller = adapter.iteratorOfMethods () ;
            while ( fujaba__IterAdapterMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapterMethodsCaller.next () ;
                   
                  // bind generalization5: GeneralizationAnnotation
                  fujaba__IterAdapterAnnotationsGeneralization5 = adapter.iteratorOfAnnotations () ;
                  while ( fujaba__IterAdapterAnnotationsGeneralization5.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAdapterAnnotationsGeneralization5.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization5 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization5 and adapter
                        JavaSDM.ensure ( generalization5.hasInElements ("subClass", adapter) ) ;
                         
                        // bind neighborCall6: NeighborCallAnnotation
                        fujaba__IterCallerAnnotationsNeighborCall6 = caller.iteratorOfAnnotations () ;
                        while ( fujaba__IterCallerAnnotationsNeighborCall6.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCallerAnnotationsNeighborCall6.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall6 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall6 and caller
                              JavaSDM.ensure ( neighborCall6.hasInElements ("caller", caller) ) ;
                               
                              // bind overridingMethod7: OverridingMethodAnnotation
                              fujaba__IterCallerAnnotationsOverridingMethod7 = caller.iteratorOfAnnotations () ;
                              while ( fujaba__IterCallerAnnotationsOverridingMethod7.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCallerAnnotationsOverridingMethod7.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                    overridingMethod7 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between overridingMethod7 and caller
                                    JavaSDM.ensure ( overridingMethod7.hasInElements ("overriding", caller) ) ;
                                     
                                    // bind target: UMLClass
                                    fujaba__IterGeneralization5ElementsTarget = generalization5.iteratorOfElements ("superClass") ;
                                    while ( fujaba__IterGeneralization5ElementsTarget.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization5ElementsTarget.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          target = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (target.isAbstract () == true) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(adapter.equals (target)) ) ;
                                           
                                          // bind callee: UMLMethod
                                          fujaba__IterNeighborCall6ElementsCallee = neighborCall6.iteratorOfElements ("callee") ;
                                          while ( fujaba__IterNeighborCall6ElementsCallee.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterNeighborCall6ElementsCallee.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // bind adaptee: UMLClass
                                                adaptee = callee.getParent () ;
                                                JavaSDM.ensure ( adaptee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                 
                                                // bind uMLMethod8: UMLMethod
                                                fujaba__IterOverridingMethod7ElementsUMLMethod8 = overridingMethod7.iteratorOfElements ("overridden") ;
                                                while ( fujaba__IterOverridingMethod7ElementsUMLMethod8.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterOverridingMethod7ElementsUMLMethod8.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod8 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (uMLMethod8.isAbstract () == true) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(callee.equals (uMLMethod8)) && !(caller.equals (uMLMethod8)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between uMLMethod8 and target
                                                      JavaSDM.ensure ( (uMLMethod8.getParent () != null) && uMLMethod8.getParent ().equals (target) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object target is really bound
                                                            JavaSDM.ensure ( target != null ) ;
                                                             
                                                            // check object adapter is really bound
                                                            JavaSDM.ensure ( adapter != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                                             
                                                            // check object adaptee is really bound
                                                            JavaSDM.ensure ( adaptee != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                             
                                                            // bind objectAdapter: ObjectAdapterAnnotation
                                                            fujaba__IterAdapterAnnotationsObjectAdapter = adapter.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterAdapterAnnotationsObjectAdapter.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAdapterAnnotationsObjectAdapter.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof ObjectAdapterAnnotation ) ;
                                                                  objectAdapter = (ObjectAdapterAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between objectAdapter and adapter
                                                                  JavaSDM.ensure ( objectAdapter.hasInElements ("adapter", adapter) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between objectAdapter and target
                                                                  JavaSDM.ensure ( objectAdapter.hasInElements ("target", target) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between objectAdapter and adaptee
                                                                  JavaSDM.ensure ( objectAdapter.hasInElements ("adaptee", adaptee) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object target is really bound
                                                               JavaSDM.ensure ( target != null ) ;
                                                                
                                                               // check object adapter is really bound
                                                               JavaSDM.ensure ( adapter != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                                                
                                                               // check object adaptee is really bound
                                                               JavaSDM.ensure ( adaptee != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                                
                                                               // check object callee is really bound
                                                               JavaSDM.ensure ( callee != null ) ;
                                                                
                                                               // check object caller is really bound
                                                               JavaSDM.ensure ( caller != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                                
                                                               // create object
                                                               objectAdapter = new ObjectAdapterAnnotation ( ) ;
                                                                
                                                               // create link
                                                               objectAdapter.addToElements ("target", target);
                                                                
                                                               // create link
                                                               objectAdapter.addToElements ("adapter", adapter);
                                                                
                                                               // create link
                                                               objectAdapter.addToElements ("adaptee", adaptee);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("target", target);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("adapter", adapter);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("adaptee", adaptee);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("callee", callee);
                                                                
                                                               // create link
                                                               objectAdapter.addToBoundObjects ("caller", caller);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object generalization5 is really bound
                                                               JavaSDM.ensure ( generalization5 != null ) ;
                                                                
                                                               // check object neighborCall6 is really bound
                                                               JavaSDM.ensure ( neighborCall6 != null ) ;
                                                                
                                                               // check object overridingMethod7 is really bound
                                                               JavaSDM.ensure ( overridingMethod7 != null ) ;
                                                                
                                                               // check object objectAdapter is really bound
                                                               JavaSDM.ensure ( objectAdapter != null ) ;
                                                                
                                                               // create link
                                                               objectAdapter.addToAntecedentAnnos (generalization5);
                                                                
                                                               // create link
                                                               objectAdapter.addToAntecedentAnnos (neighborCall6);
                                                                
                                                               // create link
                                                               objectAdapter.addToAntecedentAnnos (overridingMethod7);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (objectAdapter) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object objectAdapter is really bound
            JavaSDM.ensure ( objectAdapter != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("adapter", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("adaptee", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterAdapteeMethodsCallee = adaptee.iteratorOfMethods () ;
            while ( fujaba__IterAdapteeMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapteeMethodsCallee.next () ;
                   
                  // bind neighborCall10: NeighborCallAnnotation
                  fujaba__IterCalleeAnnotationsNeighborCall10 = callee.iteratorOfAnnotations () ;
                  while ( fujaba__IterCalleeAnnotationsNeighborCall10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCalleeAnnotationsNeighborCall10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall10 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall10 and callee
                        JavaSDM.ensure ( neighborCall10.hasInElements ("callee", callee) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterNeighborCall10ElementsCaller = neighborCall10.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall10ElementsCaller.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall10ElementsCaller.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                               
                              // bind adapter: UMLClass
                              adapter = caller.getParent () ;
                              JavaSDM.ensure ( adapter != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(adaptee.equals (adapter)) ) ;
                               
                              // bind overridingMethod11: OverridingMethodAnnotation
                              fujaba__IterCallerAnnotationsOverridingMethod11 = caller.iteratorOfAnnotations () ;
                              while ( fujaba__IterCallerAnnotationsOverridingMethod11.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCallerAnnotationsOverridingMethod11.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                    overridingMethod11 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between overridingMethod11 and caller
                                    JavaSDM.ensure ( overridingMethod11.hasInElements ("overriding", caller) ) ;
                                     
                                    // bind generalization9: GeneralizationAnnotation
                                    fujaba__IterAdapterAnnotationsGeneralization9 = adapter.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAdapterAnnotationsGeneralization9.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAdapterAnnotationsGeneralization9.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          generalization9 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between generalization9 and adapter
                                          JavaSDM.ensure ( generalization9.hasInElements ("subClass", adapter) ) ;
                                           
                                          // bind uMLMethod12: UMLMethod
                                          fujaba__IterOverridingMethod11ElementsUMLMethod12 = overridingMethod11.iteratorOfElements ("overridden") ;
                                          while ( fujaba__IterOverridingMethod11ElementsUMLMethod12.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterOverridingMethod11ElementsUMLMethod12.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                uMLMethod12 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (uMLMethod12.isAbstract () == true) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callee.equals (uMLMethod12)) && !(caller.equals (uMLMethod12)) ) ;
                                                 
                                                // bind target: UMLClass
                                                target = uMLMethod12.getParent () ;
                                                JavaSDM.ensure ( target != null ) ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (target.isAbstract () == true) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(adapter.equals (target)) && !(adaptee.equals (target)) ) ;
                                                 
                                                // check To-Many-Link 'elements' between generalization9 and target
                                                JavaSDM.ensure ( generalization9.hasInElements ("superClass", target) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object target is really bound
                                                      JavaSDM.ensure ( target != null ) ;
                                                       
                                                      // check object adapter is really bound
                                                      JavaSDM.ensure ( adapter != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                                       
                                                      // check object adaptee is really bound
                                                      JavaSDM.ensure ( adaptee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                       
                                                      // bind objectAdapter: ObjectAdapterAnnotation
                                                      fujaba__IterAdapterAnnotationsObjectAdapter = adapter.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterAdapterAnnotationsObjectAdapter.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAdapterAnnotationsObjectAdapter.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof ObjectAdapterAnnotation ) ;
                                                            objectAdapter = (ObjectAdapterAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between objectAdapter and adapter
                                                            JavaSDM.ensure ( objectAdapter.hasInElements ("adapter", adapter) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between objectAdapter and target
                                                            JavaSDM.ensure ( objectAdapter.hasInElements ("target", target) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between objectAdapter and adaptee
                                                            JavaSDM.ensure ( objectAdapter.hasInElements ("adaptee", adaptee) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object target is really bound
                                                         JavaSDM.ensure ( target != null ) ;
                                                          
                                                         // check object adapter is really bound
                                                         JavaSDM.ensure ( adapter != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                                          
                                                         // check object adaptee is really bound
                                                         JavaSDM.ensure ( adaptee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // create object
                                                         objectAdapter = new ObjectAdapterAnnotation ( ) ;
                                                          
                                                         // create link
                                                         objectAdapter.addToElements ("target", target);
                                                          
                                                         // create link
                                                         objectAdapter.addToElements ("adapter", adapter);
                                                          
                                                         // create link
                                                         objectAdapter.addToElements ("adaptee", adaptee);
                                                          
                                                         // create link
                                                         objectAdapter.addToBoundObjects ("target", target);
                                                          
                                                         // create link
                                                         objectAdapter.addToBoundObjects ("adapter", adapter);
                                                          
                                                         // create link
                                                         objectAdapter.addToBoundObjects ("adaptee", adaptee);
                                                          
                                                         // create link
                                                         objectAdapter.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         objectAdapter.addToBoundObjects ("caller", caller);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object generalization9 is really bound
                                                         JavaSDM.ensure ( generalization9 != null ) ;
                                                          
                                                         // check object neighborCall10 is really bound
                                                         JavaSDM.ensure ( neighborCall10 != null ) ;
                                                          
                                                         // check object overridingMethod11 is really bound
                                                         JavaSDM.ensure ( overridingMethod11 != null ) ;
                                                          
                                                         // check object objectAdapter is really bound
                                                         JavaSDM.ensure ( objectAdapter != null ) ;
                                                          
                                                         // create link
                                                         objectAdapter.addToAntecedentAnnos (generalization9);
                                                          
                                                         // create link
                                                         objectAdapter.addToAntecedentAnnos (neighborCall10);
                                                          
                                                         // create link
                                                         objectAdapter.addToAntecedentAnnos (overridingMethod11);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (objectAdapter) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object objectAdapter is really bound
            JavaSDM.ensure ( objectAdapter != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("adaptee", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall14 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterNeighborCall14ElementsCallee = neighborCall14.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall14ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall14ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind adaptee: UMLClass
                  adaptee = callee.getParent () ;
                  JavaSDM.ensure ( adaptee != null ) ;
                   
                  // bind caller: UMLMethod
                  fujaba__IterNeighborCall14ElementsCaller = neighborCall14.iteratorOfElements ("caller") ;
                  while ( fujaba__IterNeighborCall14ElementsCaller.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall14ElementsCaller.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                         
                        // bind adapter: UMLClass
                        adapter = caller.getParent () ;
                        JavaSDM.ensure ( adapter != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(adaptee.equals (adapter)) ) ;
                         
                        // bind overridingMethod15: OverridingMethodAnnotation
                        fujaba__IterCallerAnnotationsOverridingMethod15 = caller.iteratorOfAnnotations () ;
                        while ( fujaba__IterCallerAnnotationsOverridingMethod15.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCallerAnnotationsOverridingMethod15.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod15 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod15 and caller
                              JavaSDM.ensure ( overridingMethod15.hasInElements ("overriding", caller) ) ;
                               
                              // bind generalization13: GeneralizationAnnotation
                              fujaba__IterAdapterAnnotationsGeneralization13 = adapter.iteratorOfAnnotations () ;
                              while ( fujaba__IterAdapterAnnotationsGeneralization13.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAdapterAnnotationsGeneralization13.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization13 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization13 and adapter
                                    JavaSDM.ensure ( generalization13.hasInElements ("subClass", adapter) ) ;
                                     
                                    // bind uMLMethod16: UMLMethod
                                    fujaba__IterOverridingMethod15ElementsUMLMethod16 = overridingMethod15.iteratorOfElements ("overridden") ;
                                    while ( fujaba__IterOverridingMethod15ElementsUMLMethod16.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterOverridingMethod15ElementsUMLMethod16.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          uMLMethod16 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (uMLMethod16.isAbstract () == true) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(callee.equals (uMLMethod16)) && !(caller.equals (uMLMethod16)) ) ;
                                           
                                          // bind target: UMLClass
                                          target = uMLMethod16.getParent () ;
                                          JavaSDM.ensure ( target != null ) ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (target.isAbstract () == true) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(adapter.equals (target)) && !(adaptee.equals (target)) ) ;
                                           
                                          // check To-Many-Link 'elements' between generalization13 and target
                                          JavaSDM.ensure ( generalization13.hasInElements ("superClass", target) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object target is really bound
                                                JavaSDM.ensure ( target != null ) ;
                                                 
                                                // check object adapter is really bound
                                                JavaSDM.ensure ( adapter != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                                 
                                                // check object adaptee is really bound
                                                JavaSDM.ensure ( adaptee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                 
                                                // bind objectAdapter: ObjectAdapterAnnotation
                                                fujaba__IterAdapteeAnnotationsObjectAdapter = adaptee.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterAdapteeAnnotationsObjectAdapter.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAdapteeAnnotationsObjectAdapter.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof ObjectAdapterAnnotation ) ;
                                                      objectAdapter = (ObjectAdapterAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between objectAdapter and adaptee
                                                      JavaSDM.ensure ( objectAdapter.hasInElements ("adaptee", adaptee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between objectAdapter and target
                                                      JavaSDM.ensure ( objectAdapter.hasInElements ("target", target) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between objectAdapter and adapter
                                                      JavaSDM.ensure ( objectAdapter.hasInElements ("adapter", adapter) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object target is really bound
                                                   JavaSDM.ensure ( target != null ) ;
                                                    
                                                   // check object adapter is really bound
                                                   JavaSDM.ensure ( adapter != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                                    
                                                   // check object adaptee is really bound
                                                   JavaSDM.ensure ( adaptee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(target.equals (adaptee)) && !(adapter.equals (adaptee)) ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                    
                                                   // create object
                                                   objectAdapter = new ObjectAdapterAnnotation ( ) ;
                                                    
                                                   // create link
                                                   objectAdapter.addToElements ("target", target);
                                                    
                                                   // create link
                                                   objectAdapter.addToElements ("adapter", adapter);
                                                    
                                                   // create link
                                                   objectAdapter.addToElements ("adaptee", adaptee);
                                                    
                                                   // create link
                                                   objectAdapter.addToBoundObjects ("target", target);
                                                    
                                                   // create link
                                                   objectAdapter.addToBoundObjects ("adapter", adapter);
                                                    
                                                   // create link
                                                   objectAdapter.addToBoundObjects ("adaptee", adaptee);
                                                    
                                                   // create link
                                                   objectAdapter.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   objectAdapter.addToBoundObjects ("caller", caller);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object generalization13 is really bound
                                                   JavaSDM.ensure ( generalization13 != null ) ;
                                                    
                                                   // check object neighborCall14 is really bound
                                                   JavaSDM.ensure ( neighborCall14 != null ) ;
                                                    
                                                   // check object overridingMethod15 is really bound
                                                   JavaSDM.ensure ( overridingMethod15 != null ) ;
                                                    
                                                   // check object objectAdapter is really bound
                                                   JavaSDM.ensure ( objectAdapter != null ) ;
                                                    
                                                   // create link
                                                   objectAdapter.addToAntecedentAnnos (generalization13);
                                                    
                                                   // create link
                                                   objectAdapter.addToAntecedentAnnos (neighborCall14);
                                                    
                                                   // create link
                                                   objectAdapter.addToAntecedentAnnos (overridingMethod15);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (objectAdapter) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object objectAdapter is really bound
            JavaSDM.ensure ( objectAdapter != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (objectAdapter) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("target", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("adapter", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("adaptee", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAdapteeMethodsCallee = null ;
      Iterator fujaba__IterAdapterMethodsCaller = null ;
      Iterator fujaba__IterCalleeAnnotationsNeighborCall17 = null ;
      Iterator fujaba__IterCalleeAnnotationsNeighborCall21 = null ;
      Iterator fujaba__IterNeighborCall17ElementsCaller = null ;
      Iterator fujaba__IterNeighborCall21ElementsCaller = null ;
      Iterator fujaba__IterOverridingMethod19ElementsCaller = null ;
      Iterator fujaba__IterTargetMethodsUMLMethod18 = null ;
      Iterator fujaba__IterTargetMethodsUMLMethod20 = null ;
      Iterator fujaba__IterUMLMethod18AnnotationsOverridingMethod19 = null ;
      NeighborCallAnnotation neighborCall17 = null ;
      NeighborCallAnnotation neighborCall21 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod19 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass adaptee = null ;
      de.uni_paderborn.fujaba.uml.UMLClass adapter = null ;
      de.uni_paderborn.fujaba.uml.UMLClass target = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod18 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod20 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            target = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (target);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (adapter);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterAdapteeMethodsCallee = adaptee.iteratorOfMethods () ;
            while ( fujaba__IterAdapteeMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapteeMethodsCallee.next () ;
                   
                  // bind neighborCall17: NeighborCallAnnotation
                  fujaba__IterCalleeAnnotationsNeighborCall17 = callee.iteratorOfAnnotations () ;
                  while ( fujaba__IterCalleeAnnotationsNeighborCall17.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCalleeAnnotationsNeighborCall17.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall17 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall17 and callee
                        JavaSDM.ensure ( neighborCall17.hasInElements ("callee", callee) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterNeighborCall17ElementsCaller = neighborCall17.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall17ElementsCaller.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall17ElementsCaller.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                               
                              // bind adapter: UMLClass
                              adapter = caller.getParent () ;
                              JavaSDM.ensure ( adapter != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(adaptee.equals (adapter)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (adapter);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall17 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall17ElementsCaller = neighborCall17.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall17ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall17ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind adapter: UMLClass
                  adapter = caller.getParent () ;
                  JavaSDM.ensure ( adapter != null ) ;
                   
                  {
                     //  for each flow
                     set.add (adapter);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            target = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod18: UMLMethod
            fujaba__IterTargetMethodsUMLMethod18 = target.iteratorOfMethods () ;
            while ( fujaba__IterTargetMethodsUMLMethod18.hasNext () )
            {
               try
               {
                  uMLMethod18 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterTargetMethodsUMLMethod18.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (uMLMethod18.isAbstract () == true) ) ;
                   
                  // bind overridingMethod19: OverridingMethodAnnotation
                  fujaba__IterUMLMethod18AnnotationsOverridingMethod19 = uMLMethod18.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod18AnnotationsOverridingMethod19.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod18AnnotationsOverridingMethod19.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod19 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod19 and uMLMethod18
                        JavaSDM.ensure ( overridingMethod19.hasInElements ("overridden", uMLMethod18) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterOverridingMethod19ElementsCaller = overridingMethod19.iteratorOfElements ("overriding") ;
                        while ( fujaba__IterOverridingMethod19ElementsCaller.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod19ElementsCaller.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod18.equals (caller)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (caller);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterAdapterMethodsCaller = adapter.iteratorOfMethods () ;
            while ( fujaba__IterAdapterMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapterMethodsCaller.next () ;
                   
                  {
                     //  for each flow
                     set.add (caller);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterAdapteeMethodsCallee = adaptee.iteratorOfMethods () ;
            while ( fujaba__IterAdapteeMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapteeMethodsCallee.next () ;
                   
                  {
                     //  for each flow
                     set.add (callee);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            target = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod20: UMLMethod
            fujaba__IterTargetMethodsUMLMethod20 = target.iteratorOfMethods () ;
            while ( fujaba__IterTargetMethodsUMLMethod20.hasNext () )
            {
               try
               {
                  uMLMethod20 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterTargetMethodsUMLMethod20.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (uMLMethod20.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod20);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterAdapterMethodsCaller = adapter.iteratorOfMethods () ;
            while ( fujaba__IterAdapterMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapterMethodsCaller.next () ;
                   
                  {
                     //  for each flow
                     set.add (caller);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterAdapteeMethodsCallee = adaptee.iteratorOfMethods () ;
            while ( fujaba__IterAdapteeMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapteeMethodsCallee.next () ;
                   
                  // bind neighborCall21: NeighborCallAnnotation
                  fujaba__IterCalleeAnnotationsNeighborCall21 = callee.iteratorOfAnnotations () ;
                  while ( fujaba__IterCalleeAnnotationsNeighborCall21.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCalleeAnnotationsNeighborCall21.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall21 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall21 and callee
                        JavaSDM.ensure ( neighborCall21.hasInElements ("callee", callee) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterNeighborCall21ElementsCaller = neighborCall21.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall21ElementsCaller.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall21ElementsCaller.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (caller);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall21 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall21ElementsCaller = neighborCall21.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall21ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall21ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (caller);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
