package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;

public class StrategyEngine
extends GFRNEngine
{
   private  StrategyEngine()
   {
   }

   private static StrategyEngine theStrategyEngine;

   public static StrategyEngine get()
   {
      if (theStrategyEngine == null)
      {
         theStrategyEngine = new StrategyEngine ();
      }
      return theStrategyEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      de.upb.tools.fca.FHashSet set = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterCalleeAnnotationsNeighborCall2 = null ;
      Iterator fujaba__IterCallerAnnotationsNeighborCall4 = null ;
      Iterator fujaba__IterContextClassAnnotationsStrategy = null ;
      Iterator fujaba__IterContextClassAttrsRefField = null ;
      Iterator fujaba__IterContextClassMethodsCaller = null ;
      Iterator fujaba__IterNeighborCall2ElementsCaller = null ;
      Iterator fujaba__IterNeighborCall4ElementsCallee = null ;
      Iterator fujaba__IterNeighborCall6ElementsCallee = null ;
      Iterator fujaba__IterNeighborCall6ElementsCaller = null ;
      Iterator fujaba__IterRefFieldAnnotationsReference3 = null ;
      Iterator fujaba__IterReference1ElementsRefField = null ;
      Iterator fujaba__IterReference3ElementsStrategyClass = null ;
      Iterator fujaba__IterSet = null ;
      Iterator fujaba__IterStrategyClassAnnotationsReference1 = null ;
      Iterator fujaba__IterStrategyClassAnnotationsReference5 = null ;
      Iterator fujaba__IterStrategyClassAnnotationsStrategy = null ;
      Iterator fujaba__IterStrategyClassMethodsCallee = null ;
      GeneralizationAnnotation fujaba__TmpObjectGeneralizationAnnotation = null ;
      NeighborCallAnnotation neighborCall2 = null ;
      NeighborCallAnnotation neighborCall4 = null ;
      NeighborCallAnnotation neighborCall6 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference1 = null ;
      ReferenceAnnotation reference3 = null ;
      ReferenceAnnotation reference5 = null ;
      StrategyAnnotation strategy = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass contextClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass strategyClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("strategy", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (strategyClass.isAbstract () == true) ) ;
             
            // bind callee: UMLMethod
            fujaba__IterStrategyClassMethodsCallee = strategyClass.iteratorOfMethods () ;
            while ( fujaba__IterStrategyClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterStrategyClassMethodsCallee.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (callee.isAbstract () == true) ) ;
                   
                  // bind reference1: ReferenceAnnotation
                  fujaba__IterStrategyClassAnnotationsReference1 = strategyClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterStrategyClassAnnotationsReference1.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterStrategyClassAnnotationsReference1.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference1 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference1 and strategyClass
                        JavaSDM.ensure ( reference1.hasInElements ("references", strategyClass) ) ;
                         
                        // bind neighborCall2: NeighborCallAnnotation
                        fujaba__IterCalleeAnnotationsNeighborCall2 = callee.iteratorOfAnnotations () ;
                        while ( fujaba__IterCalleeAnnotationsNeighborCall2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCalleeAnnotationsNeighborCall2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall2 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall2 and callee
                              JavaSDM.ensure ( neighborCall2.hasInElements ("callee", callee) ) ;
                               
                              // bind refField: UMLAttr
                              fujaba__IterReference1ElementsRefField = reference1.iteratorOfElements ("field") ;
                              while ( fujaba__IterReference1ElementsRefField.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference1ElementsRefField.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                    refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                                     
                                    // bind contextClass: UMLClass
                                    contextClass = refField.getParent () ;
                                    JavaSDM.ensure ( contextClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                     
                                    // bind caller: UMLMethod
                                    fujaba__IterNeighborCall2ElementsCaller = neighborCall2.iteratorOfElements ("caller") ;
                                    while ( fujaba__IterNeighborCall2ElementsCaller.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterNeighborCall2ElementsCaller.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                           
                                          // check To-One-Link 'parent' between caller and contextClass
                                          JavaSDM.ensure ( (caller.getParent () != null) && caller.getParent ().equals (contextClass) ) ;
                                           
                                          // linkSearchToSetTop
                                          set = new de.upb.tools.fca.FHashSet ( ) ;
                                          fujaba__IterSet = strategyClass.iteratorOfAnnotations () ;
                                          while ( fujaba__IterSet.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSet.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                //  check link :) 'elements' between set and contextClass
                                                JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (contextClass) ) ;
                                                 
                                                set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          } // while
                                          // constraint
                                          JavaSDM.ensure ( set.size() == 0 ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object strategyClass is really bound
                                                JavaSDM.ensure ( strategyClass != null ) ;
                                                 
                                                // check object contextClass is really bound
                                                JavaSDM.ensure ( contextClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                 
                                                // bind strategy: StrategyAnnotation
                                                fujaba__IterStrategyClassAnnotationsStrategy = strategyClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterStrategyClassAnnotationsStrategy.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterStrategyClassAnnotationsStrategy.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof StrategyAnnotation ) ;
                                                      strategy = (StrategyAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between strategy and strategyClass
                                                      JavaSDM.ensure ( strategy.hasInElements ("strategy", strategyClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between strategy and contextClass
                                                      JavaSDM.ensure ( strategy.hasInElements ("context", contextClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object strategyClass is really bound
                                                   JavaSDM.ensure ( strategyClass != null ) ;
                                                    
                                                   // check object contextClass is really bound
                                                   JavaSDM.ensure ( contextClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check object refField is really bound
                                                   JavaSDM.ensure ( refField != null ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                    
                                                   // create object
                                                   strategy = new StrategyAnnotation ( ) ;
                                                    
                                                   // create link
                                                   strategy.addToElements ("strategy", strategyClass);
                                                    
                                                   // create link
                                                   strategy.addToElements ("context", contextClass);
                                                    
                                                   // create link
                                                   strategy.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   strategy.addToBoundObjects ("strategyClass", strategyClass);
                                                    
                                                   // create link
                                                   strategy.addToBoundObjects ("contextClass", contextClass);
                                                    
                                                   // create link
                                                   strategy.addToBoundObjects ("refField", refField);
                                                    
                                                   // create link
                                                   strategy.addToBoundObjects ("caller", caller);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference1 is really bound
                                                   JavaSDM.ensure ( reference1 != null ) ;
                                                    
                                                   // check object neighborCall2 is really bound
                                                   JavaSDM.ensure ( neighborCall2 != null ) ;
                                                    
                                                   // check object strategy is really bound
                                                   JavaSDM.ensure ( strategy != null ) ;
                                                    
                                                   // create link
                                                   strategy.addToAntecedentAnnos (reference1);
                                                    
                                                   // create link
                                                   strategy.addToAntecedentAnnos (neighborCall2);
                                                    
                                                   fujaba__IterSet = set.iterator () ;
                                                   while ( fujaba__IterSet.hasNext () )
                                                   {
                                                      fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                      //  create set link
                                                      strategy.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                      fujaba__Success = true ;
                                                   } // while
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (strategy) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object strategy is really bound
            JavaSDM.ensure ( strategy != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("strategy", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("context", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            contextClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterContextClassAttrsRefField = contextClass.iteratorOfAttrs () ;
            while ( fujaba__IterContextClassAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterContextClassAttrsRefField.next () ;
                   
                  // bind caller: UMLMethod
                  fujaba__IterContextClassMethodsCaller = contextClass.iteratorOfMethods () ;
                  while ( fujaba__IterContextClassMethodsCaller.hasNext () )
                  {
                     try
                     {
                        caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterContextClassMethodsCaller.next () ;
                         
                        // bind reference3: ReferenceAnnotation
                        fujaba__IterRefFieldAnnotationsReference3 = refField.iteratorOfAnnotations () ;
                        while ( fujaba__IterRefFieldAnnotationsReference3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterRefFieldAnnotationsReference3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference3 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference3 and refField
                              JavaSDM.ensure ( reference3.hasInElements ("field", refField) ) ;
                               
                              // bind neighborCall4: NeighborCallAnnotation
                              fujaba__IterCallerAnnotationsNeighborCall4 = caller.iteratorOfAnnotations () ;
                              while ( fujaba__IterCallerAnnotationsNeighborCall4.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCallerAnnotationsNeighborCall4.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall4 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall4 and caller
                                    JavaSDM.ensure ( neighborCall4.hasInElements ("caller", caller) ) ;
                                     
                                    // bind strategyClass: UMLClass
                                    fujaba__IterReference3ElementsStrategyClass = reference3.iteratorOfElements ("references") ;
                                    while ( fujaba__IterReference3ElementsStrategyClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterReference3ElementsStrategyClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (strategyClass.isAbstract () == true) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(contextClass.equals (strategyClass)) ) ;
                                           
                                          // bind callee: UMLMethod
                                          fujaba__IterNeighborCall4ElementsCallee = neighborCall4.iteratorOfElements ("callee") ;
                                          while ( fujaba__IterNeighborCall4ElementsCallee.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterNeighborCall4ElementsCallee.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (callee.isAbstract () == true) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check To-One-Link 'parent' between callee and strategyClass
                                                JavaSDM.ensure ( (callee.getParent () != null) && callee.getParent ().equals (strategyClass) ) ;
                                                 
                                                // linkSearchToSetTop
                                                set = new de.upb.tools.fca.FHashSet ( ) ;
                                                fujaba__IterSet = contextClass.iteratorOfAnnotations () ;
                                                while ( fujaba__IterSet.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterSet.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      //  check link :) 'elements' between set and strategyClass
                                                      JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (strategyClass) ) ;
                                                       
                                                      set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                } // while
                                                // constraint
                                                JavaSDM.ensure ( set.size() == 0 ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object strategyClass is really bound
                                                      JavaSDM.ensure ( strategyClass != null ) ;
                                                       
                                                      // check object contextClass is really bound
                                                      JavaSDM.ensure ( contextClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                       
                                                      // bind strategy: StrategyAnnotation
                                                      fujaba__IterStrategyClassAnnotationsStrategy = strategyClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterStrategyClassAnnotationsStrategy.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterStrategyClassAnnotationsStrategy.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof StrategyAnnotation ) ;
                                                            strategy = (StrategyAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between strategy and strategyClass
                                                            JavaSDM.ensure ( strategy.hasInElements ("strategy", strategyClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between strategy and contextClass
                                                            JavaSDM.ensure ( strategy.hasInElements ("context", contextClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object strategyClass is really bound
                                                         JavaSDM.ensure ( strategyClass != null ) ;
                                                          
                                                         // check object contextClass is really bound
                                                         JavaSDM.ensure ( contextClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object refField is really bound
                                                         JavaSDM.ensure ( refField != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // create object
                                                         strategy = new StrategyAnnotation ( ) ;
                                                          
                                                         // create link
                                                         strategy.addToElements ("strategy", strategyClass);
                                                          
                                                         // create link
                                                         strategy.addToElements ("context", contextClass);
                                                          
                                                         // create link
                                                         strategy.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         strategy.addToBoundObjects ("strategyClass", strategyClass);
                                                          
                                                         // create link
                                                         strategy.addToBoundObjects ("contextClass", contextClass);
                                                          
                                                         // create link
                                                         strategy.addToBoundObjects ("refField", refField);
                                                          
                                                         // create link
                                                         strategy.addToBoundObjects ("caller", caller);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object reference3 is really bound
                                                         JavaSDM.ensure ( reference3 != null ) ;
                                                          
                                                         // check object neighborCall4 is really bound
                                                         JavaSDM.ensure ( neighborCall4 != null ) ;
                                                          
                                                         // check object strategy is really bound
                                                         JavaSDM.ensure ( strategy != null ) ;
                                                          
                                                         // create link
                                                         strategy.addToAntecedentAnnos (reference3);
                                                          
                                                         // create link
                                                         strategy.addToAntecedentAnnos (neighborCall4);
                                                          
                                                         fujaba__IterSet = set.iterator () ;
                                                         while ( fujaba__IterSet.hasNext () )
                                                         {
                                                            fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                            //  create set link
                                                            strategy.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                            fujaba__Success = true ;
                                                         } // while
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (strategy) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object strategy is really bound
            JavaSDM.ensure ( strategy != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("context", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall6 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall6ElementsCaller = neighborCall6.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall6ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall6ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind contextClass: UMLClass
                  contextClass = caller.getParent () ;
                  JavaSDM.ensure ( contextClass != null ) ;
                   
                  // bind callee: UMLMethod
                  fujaba__IterNeighborCall6ElementsCallee = neighborCall6.iteratorOfElements ("callee") ;
                  while ( fujaba__IterNeighborCall6ElementsCallee.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall6ElementsCallee.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (callee.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                         
                        // bind strategyClass: UMLClass
                        strategyClass = callee.getParent () ;
                        JavaSDM.ensure ( strategyClass != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (strategyClass.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(contextClass.equals (strategyClass)) ) ;
                         
                        // bind refField: UMLAttr
                        fujaba__IterContextClassAttrsRefField = contextClass.iteratorOfAttrs () ;
                        while ( fujaba__IterContextClassAttrsRefField.hasNext () )
                        {
                           try
                           {
                              refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterContextClassAttrsRefField.next () ;
                               
                              // bind reference5: ReferenceAnnotation
                              fujaba__IterStrategyClassAnnotationsReference5 = strategyClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterStrategyClassAnnotationsReference5.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterStrategyClassAnnotationsReference5.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                    reference5 = (ReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between reference5 and strategyClass
                                    JavaSDM.ensure ( reference5.hasInElements ("references", strategyClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between reference5 and refField
                                    JavaSDM.ensure ( reference5.hasInElements ("field", refField) ) ;
                                     
                                    // linkSearchToSetTop
                                    set = new de.upb.tools.fca.FHashSet ( ) ;
                                    fujaba__IterSet = contextClass.iteratorOfAnnotations () ;
                                    while ( fujaba__IterSet.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterSet.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          //  check link :) 'elements' between set and strategyClass
                                          JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (strategyClass) ) ;
                                           
                                          set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    } // while
                                    // constraint
                                    JavaSDM.ensure ( set.size() == 0 ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object strategyClass is really bound
                                          JavaSDM.ensure ( strategyClass != null ) ;
                                           
                                          // check object contextClass is really bound
                                          JavaSDM.ensure ( contextClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                           
                                          // bind strategy: StrategyAnnotation
                                          fujaba__IterContextClassAnnotationsStrategy = contextClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterContextClassAnnotationsStrategy.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterContextClassAnnotationsStrategy.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof StrategyAnnotation ) ;
                                                strategy = (StrategyAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between strategy and contextClass
                                                JavaSDM.ensure ( strategy.hasInElements ("context", contextClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between strategy and strategyClass
                                                JavaSDM.ensure ( strategy.hasInElements ("strategy", strategyClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object strategyClass is really bound
                                             JavaSDM.ensure ( strategyClass != null ) ;
                                              
                                             // check object contextClass is really bound
                                             JavaSDM.ensure ( contextClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                              
                                             // check object callee is really bound
                                             JavaSDM.ensure ( callee != null ) ;
                                              
                                             // check object refField is really bound
                                             JavaSDM.ensure ( refField != null ) ;
                                              
                                             // check object caller is really bound
                                             JavaSDM.ensure ( caller != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                              
                                             // create object
                                             strategy = new StrategyAnnotation ( ) ;
                                              
                                             // create link
                                             strategy.addToElements ("strategy", strategyClass);
                                              
                                             // create link
                                             strategy.addToElements ("context", contextClass);
                                              
                                             // create link
                                             strategy.addToBoundObjects ("callee", callee);
                                              
                                             // create link
                                             strategy.addToBoundObjects ("strategyClass", strategyClass);
                                              
                                             // create link
                                             strategy.addToBoundObjects ("contextClass", contextClass);
                                              
                                             // create link
                                             strategy.addToBoundObjects ("refField", refField);
                                              
                                             // create link
                                             strategy.addToBoundObjects ("caller", caller);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object reference5 is really bound
                                             JavaSDM.ensure ( reference5 != null ) ;
                                              
                                             // check object neighborCall6 is really bound
                                             JavaSDM.ensure ( neighborCall6 != null ) ;
                                              
                                             // check object strategy is really bound
                                             JavaSDM.ensure ( strategy != null ) ;
                                              
                                             // create link
                                             strategy.addToAntecedentAnnos (reference5);
                                              
                                             // create link
                                             strategy.addToAntecedentAnnos (neighborCall6);
                                              
                                             fujaba__IterSet = set.iterator () ;
                                             while ( fujaba__IterSet.hasNext () )
                                             {
                                                fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                //  create set link
                                                strategy.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                fujaba__Success = true ;
                                             } // while
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (strategy) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object strategy is really bound
            JavaSDM.ensure ( strategy != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (strategy) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("strategy", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("context", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterContextClassAttrsRefField = null ;
      Iterator fujaba__IterNeighborCall6ElementsCaller = null ;
      Iterator fujaba__IterRefFieldAnnotationsReference7 = null ;
      Iterator fujaba__IterReference7ElementsStrategyClass = null ;
      Iterator fujaba__IterStrategyClassMethodsCallee = null ;
      NeighborCallAnnotation neighborCall6 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference7 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass contextClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass strategyClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (strategyClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            contextClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterContextClassAttrsRefField = contextClass.iteratorOfAttrs () ;
            while ( fujaba__IterContextClassAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterContextClassAttrsRefField.next () ;
                   
                  {
                     //  for each flow
                     set.add (refField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall6 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall6ElementsCaller = neighborCall6.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall6ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall6ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind contextClass: UMLClass
                  contextClass = caller.getParent () ;
                  JavaSDM.ensure ( contextClass != null ) ;
                   
                  // bind refField: UMLAttr
                  fujaba__IterContextClassAttrsRefField = contextClass.iteratorOfAttrs () ;
                  while ( fujaba__IterContextClassAttrsRefField.hasNext () )
                  {
                     try
                     {
                        refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterContextClassAttrsRefField.next () ;
                         
                        {
                           //  for each flow
                           set.add (refField);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (strategyClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            contextClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (contextClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall6 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall6ElementsCaller = neighborCall6.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall6ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall6ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind contextClass: UMLClass
                  contextClass = caller.getParent () ;
                  JavaSDM.ensure ( contextClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (contextClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterStrategyClassMethodsCallee = strategyClass.iteratorOfMethods () ;
            while ( fujaba__IterStrategyClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterStrategyClassMethodsCallee.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (callee.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (callee);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            contextClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterContextClassAttrsRefField = contextClass.iteratorOfAttrs () ;
            while ( fujaba__IterContextClassAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterContextClassAttrsRefField.next () ;
                   
                  // bind reference7: ReferenceAnnotation
                  fujaba__IterRefFieldAnnotationsReference7 = refField.iteratorOfAnnotations () ;
                  while ( fujaba__IterRefFieldAnnotationsReference7.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterRefFieldAnnotationsReference7.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference7 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference7 and refField
                        JavaSDM.ensure ( reference7.hasInElements ("field", refField) ) ;
                         
                        // bind strategyClass: UMLClass
                        fujaba__IterReference7ElementsStrategyClass = reference7.iteratorOfElements ("references") ;
                        while ( fujaba__IterReference7ElementsStrategyClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReference7ElementsStrategyClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (strategyClass.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(contextClass.equals (strategyClass)) ) ;
                               
                              // bind callee: UMLMethod
                              fujaba__IterStrategyClassMethodsCallee = strategyClass.iteratorOfMethods () ;
                              while ( fujaba__IterStrategyClassMethodsCallee.hasNext () )
                              {
                                 try
                                 {
                                    callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterStrategyClassMethodsCallee.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (callee.isAbstract () == true) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (callee);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
